//
//  DigitalConfig.h
//  GJDigitalSDK
//
//  Created by wbb on 2021/11/1.
//

#import <Foundation/Foundation.h>

//错误码
typedef enum
{
    IM_CONNECT_ERROR,//信令控制器连接异常  请确认网络连接状态
    IM_LOGIN_ERROR,//信令控制器认证失败
    IM_CONNECTION_CLOSED_ERROR,//信令控制器连接已断开，无法发送信令
    IM_RTC_REMOTE_SDP_FAILED,//设置远程remote SDP失败
    IM_RTC_LOCAL_SDP_FAILED,//设置本地Local SDP失败
    MQTTEventConnectionRefused,//MQTT连接拒绝
    MQTTEventConnectionError,//MQTT连接错误
    MQTTEventProtocolError,//MQTT协议错误


//    IM_RTC_ICE_SERVER_FAILED,//设置ICE_SERVER失败
  
}ErrorCode;//错误码
@interface DigitalLiveConfig : NSObject
//appid接口返回的token
@property (nonatomic, copy)NSString*token;
//创建直播间或直播间列表返回的直播间ID
@property (nonatomic, copy)NSString* liveId;
/// 用户名字(deviceId) ，默认设备编号（已在sdk中设置）
@property (nonatomic, copy) NSString * userName;

/// 用户密码，默认123456
@property (nonatomic, copy) NSString * userPassword;

/// 信令控制服务器地址
@property (nonatomic, copy) NSString * serverIP;

// 信令控制服务器端口
@property (nonatomic, assign) NSInteger servePort;

/// 每次新建会话生成的唯一编号，不能重复
@property (nonatomic, copy) NSString * sessionId;

/// 机器人编号用来选择对接的对象
@property (nonatomic, copy) NSString * robotCode;

///// 机器人话术驱动（对话模式，一问一答）："bot"， 客户端驱动方式(驱动模式，文字音频直接驱动数字人)：""
//@property (nonatomic, copy) NSString * robotMode;
/// stun地址，ice服务器
@property (nonatomic, copy)NSArray *iceServers;


/// 是否播放本地语音(默认YES)
@property (nonatomic, assign) BOOL isShowLocalAudio;

/// 是否展示本地视频框(默认NO)
@property (nonatomic, assign) BOOL isShowLocalVideo;

/// 是否打开本地摄像头(默认NO )
@property (nonatomic, assign) BOOL isOpenCamera;

/// 是否关闭本地摄像头(默认YES)
@property (nonatomic, assign) BOOL isStopCamera;

/// 前置摄像头还是后置摄像头，默认前置（yes：前置，no：后置，）
@property (nonatomic, assign) BOOL usingFrontCamera;

/// openAsr（非必传）true：开启识别，false：不开启识别
@property (nonatomic, copy) NSString * openAsr;

/// 设备信息
@property (nonatomic, copy) NSString * device;

/// 内部用的传dhrtcpc,客户的用dhrtcdev,默认dhrtcdev
@property (nonatomic, copy) NSString * groupId;

/// 一句话识别(不使用音视频)：no，长链接识别：yes，默认no
@property (nonatomic, assign) BOOL isAsr;

///auido_type 0  webrtc录音  1 音频url或本地音频或tts读取samplebuffer传入webrtc
@property (nonatomic, assign) NSInteger auidoType;

//自定义ID
@property (nonatomic, assign) NSInteger  customId;
/// 0 无绿幕 1绿幕
@property (nonatomic, assign)NSInteger greenType;

@property (nonatomic, strong)NSString*send_str;
//模型code
@property (nonatomic, strong)NSString*  udCode;
//场景视频
@property (nonatomic, copy)NSString * sequence;

//MQTT用户名
@property (nonatomic, strong)NSString*  mqttUser;
//MQTT密钥
@property (nonatomic, strong)NSString*  mqttPassword;
//客户端发送topic
@property (nonatomic, strong)NSString * topicPub;
//客户端接收topic
@property (nonatomic, strong)NSString * topicSub;

+ (DigitalLiveConfig *)shareConfig;

/// 随机生成uuid 是一个通话id,每次通话都会产生一个新的通话id
- (NSString *)uuidString;


@end


