//
//  DigitalView.h
//  GJDigitalSDK
//
//  Created by 吴棒棒 on 2021/10/30.
//

#import <UIKit/UIKit.h>
#import <WebRTC/WebRTC.h>

@protocol DigitalLiveDelegate <NSObject>

@optional
/// 错误信息返回码
- (void)onError:(NSInteger)error_code;
/// 远程视频通讯完成
- (void)onRTCReomteSuccess;
///识别出来的asr数据
-(void)detectedSpeech:(NSString*)asrText;


//中控返回的所有json字典
-(void)onMessageDic:(NSDictionary*)messageDic;

/// 中控获取不到渲染端信息后通知客户端繁忙
- (void)onBusy;

/// 中控结束通话，发送bye事件
- (void)onByeBye;

// 是否成功加载数字人
- (void)onVideoShow:(BOOL)isSuccess :(float)progress;

//获取本地视频的视频流
- (void)capturer:(RTCVideoCapturer *)capturer didCaptureVideoFrame:(RTCVideoFrame *)frame;
//返回的推流地址
-(void)onRtmpUrl:(NSString*)rtmpUrl;

@end
@interface DigitalLiveManager : NSObject
//远程视频
@property (nonatomic, strong) UIView * remote_view;
//本地视频
@property (nonatomic, strong) UIView * local_view;

//DigitalViewDelegate代理
@property (nonatomic, weak) id<DigitalLiveDelegate> delegate;
////默认配置
+(DigitalLiveManager*)manager;
-(void)toInitMQTT;
///开始初始化通讯并且是否开启本地摄像头
-(void)toStart;
/// 结束通讯
-(void)toStop;
//打开本地摄像头
- (void)toOpenCamera;
//关闭本地摄像头
-(void)toStopCamera;

//YES静音 NO非静音
-(void)setMute:(BOOL)isEnabled;
/// 和后台约定自定义事件
- (void)toCustomDic:(NSDictionary*)dic;
//开始推流
-(void)toStartPushtoproxy;
///发送本地音频或网络音频的buffer给webrtc
-(void)deliverRecordedData:(CMSampleBufferRef)sampleBuffer;

@end

