//
//  DigitalViewController.m
//  GJDigitalDemo
//
//  Created by wbb on 2021/11/9.
//

#import "DigitalViewController.h"
#import "RequsetUtil.h"
#import "BGMusicView.h"
#import "ConfigManager.h"
#import "NSDate_Helper.h"
#import "DLSelectDigitalView.h"
#import "GYActionAlertView.h"
#import "DLRTMPView.h"
#import "GYAccess.h"
@interface DigitalViewController ()<DigitalLiveDelegate,JXCategoryViewDelegate>

@property (nonatomic, strong)UIView *backView;
//封面
@property (nonatomic, strong) UIImageView *coverImgView;
//头部背景View
@property (nonatomic, strong) UIView *headerBackView;
//远程数字人View
@property (nonatomic, strong) UIView *remotView;
//本地摄像头View
@property (nonatomic, strong) UIView * localView;
//文本内容
@property (nonatomic, copy) NSString * contentStr;
//返回按钮
@property (nonatomic, strong)UIButton* backBtn;
//重命名
@property(nonatomic,strong)HYEdgeInsetsButton * renameBtn;
//开始直播
@property(nonatomic,strong)UIButton *startBtn;
//结束直播
@property(nonatomic,strong)UIButton *stopBtn;
//主播按钮
@property (nonatomic, strong) HYEdgeInsetsButton * anchorBtn;
//话术按钮
@property (nonatomic, strong) HYEdgeInsetsButton * speechBtn;
//分类标题
@property (nonatomic, strong) JXCategoryImageView *categoryView;
//选中的话术图标
@property (nonatomic, strong)NSArray * selectImageArray;
//@property (nonatomic, strong) ControlPanelView *panelView;
//@property (nonatomic, strong) UIButton * openBtn;
@property (nonatomic, assign) BOOL isDigitalSuccess;//数字人是否加载完成

//音乐界面
@property (nonatomic, strong) BGMusicView * musicView;

//选择数字人
@property (nonatomic, strong)DLSelectDigitalView *selectDigitalView;
//提示框
@property (nonatomic, strong)GYActionAlertView * alertView;

@property (nonatomic, assign)NSInteger audioType;
@property (nonatomic, strong)NSMutableArray *audioList;
@property (nonatomic, strong)DLDigitalSceneModel *scence_model;

@property (nonatomic, strong)DLRTMPView * rtmpView;

@end

@implementation DigitalViewController
-(id)init
{
    self=[super init];
    if(self)
    {
        self.selectDigitalModel=[[DLSelectDigitalModel alloc] init];
        self.scence_model=[[DLDigitalSceneModel alloc] init];
        self.audioList=[[NSMutableArray alloc] init];
    }
    return self;
}
-(void)viewWillAppear:(BOOL)animated
{
    self.navigationController.navigationBarHidden=YES;
    [super viewWillAppear:animated];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor blackColor];
////    //相机权限
//    [[GYAccess manager] getCamerapermissions:^(bool isPermis) {
//
//    }];
//    //录音权限
//    [[GYAccess manager] getmicrophoneaccess:^(bool isPermis) {
//
//    }];
  
    [self.view addSubview:self.backView];

    //头部背景View
    [self.view addSubview:self.headerBackView];
    //开始直播
    [self.view addSubview:self.startBtn];
    
    //开始直播
    [self.view addSubview:self.stopBtn];
    //主播按钮
    [self.view addSubview:self.anchorBtn];
    
    //话术按钮
    [self.view addSubview:self.speechBtn];
    //话术分类
    [self.view addSubview:self.categoryView];
    
    //音乐界面
    [self.view addSubview:self.musicView];
    
    //返回按钮
    [self.headerBackView addSubview:self.backBtn];
    
    //重命名按钮
    [self.headerBackView addSubview:self.renameBtn];
    
    //选择数字人刻面
    [self.view addSubview:self.selectDigitalView];
    
    //远程数字人View
    [self.backView addSubview:self.remotView];
    //封面
    [self.backView addSubview:self.coverImgView];


    [self.view addSubview:self.rtmpView];
        //直播列表进来
    [self.coverImgView yy_setImageWithURL:[NSURL URLWithString:self.listModel.coverUrl] placeholder:nil];
 


    //根据场景id 查询场景详细信息
    MJWeakSelf
    [ConfigManager toQuerySceneDetailsByCode:self.listModel.udCode?:@"" block:^(BOOL isSuccess, NSString *msg, id responseObject) {
        NSLog(@"responseObject:%@",responseObject);
        if(isSuccess)
        {
            NSDictionary* data=responseObject[@"data"];
            if([data isKindOfClass:[NSDictionary class]])
            {
      
                weakSelf.scence_model=[DLDigitalSceneModel mj_objectWithKeyValues:data];

            }
        }
        else
        {
            [GlobalFunc showLoadText:[NSString stringWithFormat:@"%@,请选择其他主播",msg] :self.view];
        }
    
      
    }];
   // [self.backView addSubview:self.localView];
    

//    [DigitalManager manager].local_view=self.localView;//本地视频
    
}
-(UIView*)backView
{
    if(_backView==nil)
    {
        _backView=[[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
        _backView.backgroundColor=[UIColor clearColor];
    }
    return _backView;
    
}
-(UIImageView*)coverImgView
{
    if(_coverImgView==nil)
    {
        _coverImgView=[[UIImageView alloc] initWithFrame:CGRectMake(0,kStatusBarHeight+50, self.view.frame.size.width, self.view.frame.size.height-kStatusBarHeight-50)];
        _coverImgView.backgroundColor=[UIColor blackColor];
        _coverImgView.contentMode=UIViewContentModeScaleAspectFill;
    }
    return _coverImgView;
    
}
#pragma mark ------------------头部背景View-------------------------
-(UIView*)headerBackView
{
    if(_headerBackView==nil)
    {
        _headerBackView=[[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, kStatusBarHeight+50)];
        _headerBackView.backgroundColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
    }
    return _headerBackView;
    
}
#pragma mark ------------------远程数字人View-------------------------
-(UIView*)remotView
{
    if(_remotView==nil)
    {
        _remotView=[[UIView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(self.headerBackView.frame), self.view.frame.size.width, self.view.frame.size.height-CGRectGetMaxY(self.headerBackView.frame))];
        _remotView.backgroundColor=[UIColor clearColor];
    
    }
    return _remotView;
    
}
#pragma mark ------------------本地摄像头View-------------------------
- (UIView *)localView {
    if (!_localView) {
        _localView = [[UIView alloc] init];
        _localView.backgroundColor=[UIColor clearColor];
        _localView.frame=CGRectMake(self.view.frame.size.width-100, 100, 100, 177);

    }
    return _localView;
}
#pragma mark --------------------返回按钮-----------------------
- (UIButton *)backBtn {
    
    if (nil == _backBtn) {
        _backBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _backBtn.frame=CGRectMake(4, kStatusBarHeight+3, 44, 44);
        [_backBtn setImage:[UIImage imageNamed:@"dl_back_white"] forState:UIControlStateNormal];
        [_backBtn addTarget:self action:@selector(toBack) forControlEvents:UIControlEventTouchUpInside];

    }
    return _backBtn;
}
#pragma mark --------------------重命名按钮-----------------------
-(HYEdgeInsetsButton*)renameBtn
{
   if(_renameBtn==nil)
   {
       //关闭按钮
       UIImage *closeImage=[UIImage imageNamed:@"dl_rename"];
       _renameBtn=[HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];
       _renameBtn.frame=CGRectMake(60, kStatusBarHeight+3, self.view.frame.size.width-120, 44);
       _renameBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageRight;
       _renameBtn.imageTitleSpace=6;
       [_renameBtn setTitle:self.listModel.liveName?:@"请输入直播间名称" forState:UIControlStateNormal];
       [_renameBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
       _renameBtn.titleLabel.font=[UIFont fontWithName:@"PingFangSC-Semibold" size:16];
       [_renameBtn setImage:closeImage forState:UIControlStateNormal];
       _renameBtn.backgroundColor=[UIColor clearColor];
       [_renameBtn addTarget:self action:@selector(toRenameView) forControlEvents:UIControlEventTouchDown];
   }
   return _renameBtn;
}
#pragma mark-------------开始直播---------------------
-(UIButton*)startBtn
{
    if (nil == _startBtn) {
        _startBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _startBtn.frame=CGRectMake(20, self.view.frame.size.height-44-45, self.view.frame.size.width-40, 44);
        [_startBtn setTitle:@"开始直播" forState:UIControlStateNormal];
        [_startBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _startBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:12];
        _startBtn.backgroundColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        _startBtn.layer.cornerRadius=4;
        _startBtn.layer.masksToBounds=YES;
        [_startBtn addTarget:self action:@selector(toClickStart) forControlEvents:UIControlEventTouchDown];
    }
    return _startBtn;
}
#pragma mark-------------结束直播---------------------
-(UIButton*)stopBtn
{
    if (nil == _stopBtn) {
        _stopBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _stopBtn.frame=CGRectMake(20, self.view.frame.size.height-44-45, self.view.frame.size.width-40, 44);
        [_stopBtn setTitle:@"结束直播" forState:UIControlStateNormal];
        [_stopBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _stopBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:12];
        _stopBtn.backgroundColor=[UIColor colorWithHexString:@"#C62D2D" alpha:1.0];
        _stopBtn.layer.cornerRadius=4;
        _stopBtn.layer.masksToBounds=YES;
        _stopBtn.hidden=YES;
        [_stopBtn addTarget:self action:@selector(toClickStop) forControlEvents:UIControlEventTouchDown];
    }
    return _stopBtn;
}
#pragma mark -----------------主播按钮-------------------------
- (UIButton *)anchorBtn {
    
    if (nil == _anchorBtn) {
        NSMutableAttributedString*string=[GlobalFunc toGetFormStr:@"主播" font:[UIFont fontWithName:@"PingFangSC-Regular" size:10] color:[UIColor colorWithHexString:@"#FFFFFF"]];
        _anchorBtn = [HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];
        _anchorBtn.frame=CGRectMake(self.view.frame.size.width-65, CGRectGetMaxY(self.headerBackView.frame)+34, 55, 55);
        _anchorBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageTop;
        _anchorBtn.imageTitleSpace=5;
        [_anchorBtn setAttributedTitle:string forState:UIControlStateNormal];
        _anchorBtn.backgroundColor =[UIColor clearColor];
        [_anchorBtn setImage:[UIImage imageNamed:@"dl_zhubo_icon"] forState:UIControlStateNormal];
        [_anchorBtn addTarget:self action:@selector(toClickZhubo) forControlEvents:UIControlEventTouchUpInside];

    }
    return _anchorBtn;
}
#pragma mark -----------------话术按钮-------------------------
- (UIButton *)speechBtn
{
    if (nil == _speechBtn)
    {
        NSMutableAttributedString*string=[GlobalFunc toGetFormStr:@"话术" font:[UIFont fontWithName:@"PingFangSC-Regular" size:10] color:[UIColor colorWithHexString:@"#FFFFFF"]];
        _speechBtn = [HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];
        _speechBtn.frame=CGRectMake(self.anchorBtn.frame.origin.x, CGRectGetMaxY(self.anchorBtn.frame)+22, 55, 55);
        _speechBtn.backgroundColor =[UIColor clearColor];
        _speechBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageTop;
        _speechBtn.imageTitleSpace=5;
        [_speechBtn setAttributedTitle:string forState:UIControlStateNormal];
        [_speechBtn setImage:[UIImage imageNamed:@"dl_black_microphone"] forState:UIControlStateNormal];
        [_speechBtn addTarget:self action:@selector(toClickHuashu) forControlEvents:UIControlEventTouchUpInside];
   
    }
    return _speechBtn;
}
#pragma mark-----------------JXCategoryTitleView-----------------------
-(JXCategoryImageView*)categoryView
{
    if(_categoryView==nil)
    {
//        NSArray *imageInfoArray = @[@"dl_microphone_icon", @"dl_music_icon", @"dl_tts_icon"];
//        self.selectImageArray= @[@"dl_black_microphone", @"dl_black_music", @"dl_black_tts"];
        NSArray *imageInfoArray = @[@"dl_microphone_icon", @"dl_music_icon"];
      self.selectImageArray= @[@"dl_black_microphone", @"dl_black_music"];
        _categoryView = [[JXCategoryImageView alloc] initWithFrame:CGRectMake(self.view.frame.size.width-84-20, CGRectGetMinY(self.speechBtn.frame), 84, 34)];
        _categoryView.imageInfoArray = imageInfoArray;
        _categoryView.selectedImageInfoArray =imageInfoArray;
        _categoryView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.4];
        _categoryView.imageSize=CGSizeMake(34, 34);
        _categoryView.averageCellSpacingEnabled = NO;
        _categoryView.contentEdgeInsetLeft=0;
        _categoryView.contentEdgeInsetRight=0;
        _categoryView.cellSpacing=11;
        _categoryView.layer.cornerRadius=17;
        _categoryView.contentScrollViewClickTransitionAnimationEnabled = NO;
        _categoryView.collectionView.scrollEnabled=NO;
        _categoryView.contentScrollView.scrollEnabled=NO;
        _categoryView.selectedAnimationEnabled=NO;
        _categoryView.delegate=self;
        _categoryView.loadImageBlock = ^(UIImageView *imageView, id info) {
            NSString *imageName = info;
            imageView.image = [UIImage imageNamed:imageName];
        };
        _categoryView.hidden=YES;
//        JXCategoryIndicatorLineView *lineView = [[JXCategoryIndicatorLineView alloc] init];
//        lineView.indicatorColor = [UIColor colorWithHexString:@"#444CF0" alpha:1.0];
//        lineView.indicatorWidth = 20;
//        _categoryView.indicators = @[lineView];
    }
    return _categoryView;
}
-(DLRTMPView*)rtmpView
{
    if(nil==_rtmpView)
    {
        _rtmpView=[[DLRTMPView alloc] initWithFrame:CGRectMake(0, 0, ViewWidth, ViewHeight)];
        _rtmpView.hidden=YES;
    }
    return _rtmpView;
}
#pragma mark ------------------------背景音乐界面---------------------------
-(BGMusicView*)musicView
{
    if(_musicView==nil)
    {
        _musicView=[[BGMusicView alloc] initWithFrame:CGRectMake(0, 0, ViewWidth, ViewHeight)];
        //      _musicView.delegate=self;
        _musicView.hidden=YES;
        _musicView.listModel=self.listModel;
        [_musicView toLoadData];
        [self toLoadMusicViewBlock];
    }
    return _musicView;
}
-(void)toLoadMusicViewBlock
{

    MJWeakSelf
    _musicView.playBlock = ^(BGMusicModel * _Nonnull musicModel) {
        
    };
    _musicView.sureBlock = ^(NSInteger type, NSMutableArray * _Nonnull audioList) {
       if(type==1)
       {
           if(audioList.count==0)
           {
               [GlobalFunc showLoadText:@"还未设置话术列表" :weakSelf.view];
               return;
           }
           [weakSelf.audioList removeAllObjects];
           for(int i=0;i<audioList.count;i++)
           {
               BGMusicModel *musicModel=audioList[i];
               NSString * filepath;
//               if(musicModel.type==1)
//               {
//                   filepath=musicModel.music_name;
//               }
//               else
//               {
                   filepath=[NSString stringWithFormat:@"%@/%@",[GlobalFunc getHistoryCachePath:DLMUSIC],musicModel.music_name];
//               }
               
       

               [weakSelf.audioList addObject:filepath];
           }
           weakSelf.musicView.hidden=YES;
       }
    };


}
#pragma mark ---------------选择数字人界面---------------------------------
-(DLSelectDigitalView*)selectDigitalView
{
  if(_selectDigitalView==nil)
  {
      __weak typeof(self) weakSelf = self;
      _selectDigitalView=[[DLSelectDigitalView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
      _selectDigitalView.hidden=YES;
      _selectDigitalView.selectDigitalBlock = ^(NSInteger type, DLSelectDigitalModel * selectDigitalModel) {
          [weakSelf toSelectDigital:selectDigitalModel :type];
      };
  }
  return _selectDigitalView;
}
#pragma mark ---------------选中数字人---------------------------------
-(void)toSelectDigital:(DLSelectDigitalModel*)selectDigitalModel :(NSInteger)type
{
    self.selectDigitalView.hidden=YES;
    self.selectDigitalModel=selectDigitalModel;
    //设置封面
    if(self.selectDigitalModel.sceneList.count>0)
    {
        //数字人下的场景
       self.scence_model=   self.selectDigitalModel.sceneList[0];
       //设置封面
        [self.coverImgView yy_setImageWithURL:[NSURL URLWithString:self.scence_model.coverUrl] placeholder:nil];
        
        [ConfigManager toUpdateLiveAll:self.listModel.Id?:@"" coverUrl:self.scence_model.coverUrl?:@"" liveName:self.listModel.liveName?:@"" udCode:self.scence_model.sceneCode?:@"" robotCode:selectDigitalModel.robotCode?:@"" robotName:selectDigitalModel.robotName?:@"" block:^(BOOL isSuccess, NSString *msg, id responseObject) {
            if(isSuccess)
            {
                
            }
        }];
        
        
    }
   
}
-(void)toRenameView
{
    __weak typeof(self) weakSelf = self;
    __block GYActionAlertView * alert = [GYActionAlertView new];
    __weak GYActionAlertView *weakAlert = alert;
    alert.isDismiss=YES;
    alert.backColor=[UIColor colorWithHexString:@"#000000" alpha:0.6];
    [alert setAlert:@"起个名字" showTextField:YES message:@"" attributeMessage:nil cancel:@"取消" confirm:@"确定" delegate:nil handler:^(NSInteger type,NSString*nameStr) {
        if(type==1)
        {
            NSLog(@"nameStr:%@",nameStr);
            NSString *name_str=nameStr?:@"";
            if(name_str.length==0)
            {
                [GlobalFunc showWindowText:@"直播间名称不能为空" :weakSelf.view];
                return;
            }
            if(![GlobalFunc isInputRuleNotBlank:nameStr]) {
                [GlobalFunc showWindowText:@"直播间名称仅支持中英文和数字,限10个字" :weakSelf.view];
                return;
            }
            if(nameStr.length>10) {
                [GlobalFunc showWindowText:@"直播间名称仅支持中英文和数字,限10个字" :weakSelf.view];
                return;
            }
            [weakSelf.renameBtn setTitle:name_str forState:UIControlStateNormal];
//            weakSelf.lastBGModel.name_str=nameStr;
//            [GlobalFunc toSaveBgSucai:weakSelf.lastBGModel :weakSelf.listModel.Id];
            weakSelf.listModel.liveName=nameStr;
            [ConfigManager toUpdateLiveNameByLiveId:weakSelf.listModel.Id liveName:weakSelf.listModel.liveName block:^(BOOL isSuccess, NSString *msg, id responseObject) {
                if(isSuccess)
                {
                    [GlobalFunc showLoadText:@"更新名称成功" :weakSelf.view];
                }
            }];
            [weakAlert dismiss];
        }
        else
        {
            [weakAlert dismiss];
        }
    }];
    [alert show];
}
#pragma mark -----------------JXCategoryViewDelegate 点击选择话术分类-----------------------
- (void)categoryView:(JXCategoryBaseView *)categoryView didSelectedItemAtIndex:(NSInteger)index
{
    NSLog(@"index:%ld",index);

    _categoryView.hidden=YES;
    NSString * imageName=self.selectImageArray[index];
    [self.speechBtn setImage:[UIImage imageNamed:imageName] forState:UIControlStateNormal];
    _speechBtn.imageTitleSpace=5;
    if(index==1)
    {
        self.musicView.hidden=NO;
    }
    self.audioType=index;
}
-(void)toClickStart
{

   
    if([ConfigManager manager].token.length==0)
    {
        [GlobalFunc showLoadText:@"token不能为空" :self.view];
        return;
    }

    if(self.listModel.Id==nil)
    {
        
       [GlobalFunc showLoadText:@"直播间ID不能为空" :self.view];
        return;
    }
    if(self.scence_model.videoCoverUrl==nil)
    {
   
        [GlobalFunc showLoadText:@"videoCoverUrl不能为空" :self.view];
        return;
    }
    if(self.scence_model.sceneCode==nil)
    {
      
        [GlobalFunc showLoadText:@"sceneCode不能为空" :self.view];
        return;
    }
    if(self.audioType==1&&self.audioList.count==0)
    {
        [GlobalFunc showLoadText:@"话术列表不能为空" :self.view];
        return;
    }
    
    self.isDigitalSuccess=NO;
    
    [self toCheckPlay];
    

    MJWeakSelf
    NSLog(@"%@,%@",self.listModel.Id,self.listModel.liveName);
    [ConfigManager tocreateLiveSession:self.listModel.Id?:@"" name:self.listModel.liveName?:@"" block:^(BOOL isSuccess, NSString *msg, id responseObject) {
        __strong typeof(weakSelf) strongSelf = weakSelf;
       if(isSuccess)
       {
           NSDictionary *data_dic=responseObject[@"data"];
           NSString *sessionId=[GlobalFunc changeType:data_dic[@"sessionId"]];
           NSString *topicPub=[GlobalFunc changeType:data_dic[@"topicPub"]];
           NSString *topicSub=[GlobalFunc changeType:data_dic[@"topicSub"]];
           [weakSelf toStartDigital:sessionId topicPub:topicPub topicSub:topicSub];
       }
        else
        {
            [strongSelf.alertView dismiss];
            [GlobalFunc showLoadText:msg :strongSelf.view];
        }
    }];
    


  
}
#pragma mark ------------直播间ID---------------------------
-(void)toStartDigital:(NSString*)sessionId topicPub:(NSString*)topicPub topicSub:(NSString*)topicSub
{
    //获取的token
    [DigitalLiveConfig shareConfig].token=[ConfigManager manager].token;//从后端获取的token
    [DigitalLiveConfig shareConfig].sessionId= sessionId;//会话ID
    [DigitalLiveConfig shareConfig].userName=[ConfigManager manager].mqttUser;//MQTT连接用户名
    [DigitalLiveConfig shareConfig].userPassword=[ConfigManager manager].mqttPassword;//MQTT连接密钥
    [DigitalLiveConfig shareConfig].serverIP=MQTTURL;//MQTT连接地址
    [DigitalLiveConfig shareConfig].auidoType=self.audioType;//0 录音模式 1 音频文件发送buffer
    NSLog(@"self.audioType:%ld",self.audioType);
    [DigitalLiveConfig shareConfig].topicPub=topicPub;//客户端发送topic
    [DigitalLiveConfig shareConfig].topicSub=topicSub;////客户端接收topic
    [DigitalLiveConfig shareConfig].sequence=self.scence_model.videoCoverUrl;;//数字人场景视频地址
    [DigitalLiveConfig shareConfig].udCode= self.scence_model.sceneCode;//数字人场景code
    [DigitalLiveConfig shareConfig].greenType=1;//绿幕背景
    [DigitalLiveConfig shareConfig].liveId=self.listModel.Id;//直播间ID
    [DigitalLiveManager manager].remote_view=self.remotView;//远程视频
    [DigitalLiveManager manager].delegate=self;//代理
    [[DigitalLiveManager manager] toStart];//开始MQTT通讯
 
}
#pragma mark----------------------检查资源弹框-------------------------
-(void)toCheckPlay
{
   
  
    __weak typeof(self) weakSelf = self;
    self.alertView = [[GYActionAlertView alloc] init];
    self.alertView.backColor=[UIColor colorWithHexString:@"#000000" alpha:0.6];
    self.alertView.alertBackColor=[UIColor colorWithHexString:@"#212942" alpha:1.0];
    self.alertView.titleColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0];
    self.alertView.contentColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0];
    self.alertView.confirmColor=[UIColor clearColor];
    self.alertView.confirmBorderWidth=1;
    self.alertView.confirmBorderColor=[UIColor colorWithHexString:@"#0082FF" alpha:1.0];
    self.alertView.singleBtn=YES;
    self.alertView.title_content_space=13;
    self.alertView.isShowAnimation=YES;
//    self.alertView.removeWhenHide=YES;
    [self.alertView  setAlert:@"" message:@"正在加载直播资源，请耐心等待～" attributeMessage:nil cancel:nil confirm:@"取消" delegate:nil handler:^(NSInteger type) {
     
        if(type==1)
        {
            __strong typeof(weakSelf) strongSelf = weakSelf;
            //停止通讯 停止摄像头
            NSLog(@"停止通讯 停止摄像头");
            [strongSelf toStopALL];
        }
     
   

    }];
    [self.alertView  show];

  
}
#pragma mark -----------------点击结束直播----------------
-(void)toClickStop
{
    __weak typeof(self) weakSelf = self;
    [GlobalFunc alertWithTitle:@"关闭提示" msg:@"确认结束直播吗？" cancle:@"取消" sure:@"确定" :^(NSInteger type) {
        __strong typeof(weakSelf) strongSelf = weakSelf;
        if(type==1)
        {
            [strongSelf toStopALL];
            [strongSelf toShowStop];
        }
    }];
  
}
#pragma mark -----------------点击主播按钮-------------------------
-(void)toClickZhubo
{
    self.selectDigitalView.hidden=NO;
}
#pragma mark -----------------点击话术按钮-------------------------
-(void)toClickHuashu
{
    _categoryView.hidden=NO;
    [self.speechBtn setImage:[UIImage imageNamed:@""] forState:UIControlStateNormal];
    _speechBtn.imageTitleSpace=5;
}
#pragma mark
-(void)toBack
{
    [self.navigationController popViewControllerAnimated:YES];
    //停止通讯 停止摄像头

    [self toStopALL];
}
-(void)toStopALL
{

        
    [self.alertView dismiss];
    self.rtmpView.hidden=YES;

    [[DigitalLiveManager manager] toStop];
    [[AudioManager manager] toStop];
   
}

-(void)toShowStart
{
    [self.alertView dismiss];
    self.startBtn.hidden=YES;
    self.anchorBtn.hidden=YES;
    self.speechBtn.hidden=YES;
    self.stopBtn.hidden=NO;
    self.categoryView.hidden=YES;

}
-(void)toShowStop
{
    self.startBtn.hidden=NO;
    self.anchorBtn.hidden=NO;
    self.speechBtn.hidden=NO;
    self.stopBtn.hidden=YES;
    self.coverImgView.hidden=NO;

}
- (void)addAlert:(NSString *)content
{
    [GlobalFunc showLoadText:content :self.view];
    
    
}

- (UIStatusBarStyle)preferredStatusBarStyle {

    return UIStatusBarStyleLightContent;

}
#pragma mark-----------------------DigitalViewDelegate-----------------
/// 错误信息返回
- (void)onError:(NSInteger)error_code;
{
    //IM_CONNECT_ERROR,//信令控制器连接异常  请确认网络连接状态
    //IM_LOGIN_ERROR,//信令控制器认证失败
    //IM_CONNECTION_CLOSED_ERROR,//信令控制器连接已断开，无法发送信令
    //IM_RTC_REMOTE_SDP_FAILED,//设置远程remote SDP失败
    //IM_RTC_LOCAL_SDP_FAILED,//设本地Local SDP失败

 
    if (error_code==IM_CONNECT_ERROR)
    {
        [self addAlert:@"信令控制器连接异常"];
    }
    else if (error_code==IM_LOGIN_ERROR)
    {
        [self addAlert:@"信令控制器认证失败"];
    }
    else if (error_code==IM_CONNECTION_CLOSED_ERROR)
    {
        [self addAlert:@"信令控制器连接已断开"];
    }
    else if (error_code==IM_RTC_REMOTE_SDP_FAILED)
    {
        [self addAlert:@"设置远程remote SDP失败"];
    }
    else if (error_code==IM_RTC_LOCAL_SDP_FAILED)
    {
        [self addAlert:@"设置本地Local SDP失败"];
    }




}

/// 中控获取到播放话术后将字幕以及话术指令推送给客户端
/// @param dic 字幕以及话术指令
- (void)onCommand:(NSDictionary *)dic
{
    NSLog(@"onCommand ======= %@", dic);
}
///识别出来的asr内容
-(void)detectedSpeech:(NSString*)asrText
{
    //最好等数字人加载完成 在发送文本
    if(!self.isDigitalSuccess)
    {
        return;
    }

}
//返回的推流地址
-(void)onRtmpUrl:(NSString*)rtmpUrl
{
    self.rtmpView.hidden=NO;
    [self.rtmpView toSetRtmpUrl:rtmpUrl];
}
//中控返回的所有json字典
-(void)onMessageDic:(NSDictionary*)messageDic
{
    NSLog(@"messageDic ==== %@", messageDic);

    NSDictionary *error_dic=messageDic[@"error"];
    if(error_dic!=nil&&[error_dic isKindOfClass:[NSDictionary class]])
    {
        //服务端返回的错误
        NSLog(@"error_dic_message ==== %@", error_dic[@"message"]);
 
        [self toStopALL];
        [GlobalFunc showLoadText:error_dic[@"message"] :self.view];
    }
    
    NSString *event=messageDic[@"event"];
    if([event isEqualToString:@"SessionState"])
    {
        NSDictionary* params=messageDic[@"params"];
        NSString* state=[GlobalFunc changeType:params[@"state"]];
        if([state isEqualToString:@"Destroy"])
        {
            NSString *cause=[GlobalFunc changeType:params[@"cause"]];
            [self toStopALL];
            [GlobalFunc showLoadText:cause :self.view];
        }
    }
  
}
/// 中控获取不到渲染端信息后通知客户端繁忙
- (void)onBusy {
//    [self addAlert:@"机器人资源繁忙，请稍候再试!"];
}

/// 中控结束通话，发送bye事件
- (void)onByeBye {
//    [self addAlert:@"中控结束通话，发送bye事件"];

}
// 是否成功加载数字人
- (void)onVideoShow:(BOOL)isSuccess :(float)progress
{
    self.isDigitalSuccess=isSuccess;
    if (isSuccess) {
        NSLog(@"成功加载数字人");
        //开始推流
        self.coverImgView.hidden=YES;
        [[DigitalLiveManager manager] toStartPushtoproxy];
        if(self.audioType==1)
        {
            //音频模式发送音频buffer
          [[AudioManager manager] toStartWithAudioList:self.audioList];

        }
        
        [self toShowStart];
       
     
        
    }
}
//获取本地视频的视频流
- (void)capturer:(RTCVideoCapturer *)capturer didCaptureVideoFrame:(RTCVideoFrame *)frame
{

}
@end
