//
//  DLSelectDigitalViewController.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/5.
//

#import "DLSelectDigitalViewController.h"
#import "DLSelectDigitalCell.h"
#import "ConfigManager.h"
@interface DLSelectDigitalViewController ()<UICollectionViewDelegate,UICollectionViewDataSource>
@property (nonatomic, strong) UICollectionView *collectionView;
@property (nonatomic, copy) void(^scrollCallback)(UIScrollView *scrollView);
@property (nonatomic, assign) NSInteger page;
@property (nonatomic, assign) NSInteger size;
@property (nonatomic, assign) BOOL requestFinish;
@property (nonatomic, strong) NSMutableArray *arrData;
@end

@implementation DLSelectDigitalViewController
-(id)init
{
    self=[super init];
    if(self)
    {
        
        self.size = 10;
        self.arrData=[[NSMutableArray alloc] init];
    }
    return self;
}
-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    MJWeakSelf
    [ConfigManager isAppIdLoginBlock:^(BOOL isSuccess, NSString *msg, id responseObject) {
        if(isSuccess)
        {
            [weakSelf toLoadData];
        }
    }];

}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor=[UIColor clearColor];
    [self.view addSubview:self.collectionView];

//    [self toLoadData];
    // Do any additional setup after loading the view.
}
- (void)viewDidLayoutSubviews {
    [super viewDidLayoutSubviews];
    
    self.collectionView.frame = self.view.bounds;
}
-(void)toLoadData
{
    MJWeakSelf
    [ConfigManager toGetListMarketPage:1 size:100 type:self.viewIndex Block:^(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData) {
        weakSelf.arrData=[NSMutableArray arrayWithArray:listData];
        for(int i=0;i<[weakSelf.arrData count];i++)
        {
            DLSelectDigitalModel * digitalModel=weakSelf.arrData[i];
            if([ConfigManager  manager].selectDigitalModel.pid==digitalModel.pid)
            {
                digitalModel.isSelect=YES;
                [ConfigManager  manager].selectDigitalModel=digitalModel;
                if(self.selectDitalBlock)
                {
                    self.selectDitalBlock(digitalModel);
                }
            }
            else
            {
                digitalModel.isSelect=NO;
            }
         
        
        }
        [weakSelf.collectionView reloadData];
    }];
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/
-(UICollectionView*)collectionView
{
    if(nil==_collectionView)
    {
        
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        [flowLayout setScrollDirection:UICollectionViewScrollDirectionVertical];
        _collectionView=[[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:flowLayout];
        _collectionView.delegate=self;
        _collectionView.dataSource=self;
        _collectionView.backgroundColor=[UIColor clearColor];
        _collectionView.scrollEnabled=YES;
        _collectionView.showsHorizontalScrollIndicator = NO;
        _collectionView.showsVerticalScrollIndicator= NO;
        
 
//        MJWeakSelf;
//        [[[[MJRefreshBackNormalFooter footerWithRefreshingBlock:^{
//            weakSelf.page ++;
//            [weakSelf requestListData:self.size];
//        }] setAnimationDisabled]
//          autoChangeTransparency:NO]
//         linkTo:_collectionView];
        
    }
    return _collectionView;
}
#pragma mark - UICollectionViewDataSource, UICollectionViewDelegateFlowLayout

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {

        
    return self.arrData.count;

}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {


        static NSString *identifier = @"DLSelectDigitalCell";
        [self.collectionView registerClass:[DLSelectDigitalCell class] forCellWithReuseIdentifier:identifier];
         DLSelectDigitalCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
         DLSelectDigitalModel *selectDigitalModel=self.arrData[indexPath.item];
        cell.selectDigitalModel=selectDigitalModel;
        [cell toSetContent];
//        [cell refreshCell:model];
//        cell.delegate=self;
        return cell;
  
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    return CGSizeMake(floor((self.view.frame.size.width-50)/3), floor(160));
}
//
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    
    return UIEdgeInsetsMake(13, 15, 0, 15);
    
}
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section
{
    return 0;
}

//---------------------------------------------------------------------------
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    
    return 10;
}

//---------------------------------------------------------------------------
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
 
    if(self.arrData.count>indexPath.item)
    {
        DLSelectDigitalModel *selectDigitalModel=self.arrData[indexPath.item];
        for(int i=0;i<[self.arrData count];i++)
        {
            DLSelectDigitalModel * digitalModel=self.arrData[i];
            if(selectDigitalModel.pid==digitalModel.pid)
            {
                [ConfigManager  manager].selectDigitalModel=digitalModel;
                digitalModel.isSelect=YES;
            }
            else
            {
                digitalModel.isSelect=NO;
            }
         
        
        }
        [self.collectionView reloadData];
        
        if(self.selectDitalBlock)
        {
            self.selectDitalBlock(selectDigitalModel);
        }
    }

    
    
}
- (UIScrollView *)listScrollView {
    return self.collectionView;
}

- (UIView *)listView {
    return self.view;
}
- (void)listViewDidScrollCallback:(void (^)(UIScrollView *))callback {
    
    self.scrollCallback = callback;
}

-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    !self.scrollCallback ?: self.scrollCallback(scrollView);
    
}
@end
