//
//  BGMusicCell.m
//  DreamLive
//
//  Created by guiji on 2023/5/23.
//

#import "BGMusicCell.h"
@interface BGMusicCell ()
///播放图片
@property(nonatomic,strong)YYAnimatedImageView * playImageView;
///播放图片
@property(nonatomic,strong)UIImageView * playImageView2;
///播放按钮
@property(nonatomic,strong)UIButton * playBtn;
///名字
@property(nonatomic,strong)UILabel * nameLabel;
///时间
@property(nonatomic,strong)UILabel * durationLabel;
//移除按钮
@property(nonatomic,strong)HYEdgeInsetsButton* deleteBtn;


@end
@implementation BGMusicCell
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
        
        self.musicModel=[[BGMusicModel alloc] init];
        
        self.layer.cornerRadius=4;
  
        self.backgroundColor=[UIColor colorWithHexString:@"#313B5A" alpha:1.0];
    
       
        
        
        [self addSubview:self.playImageView];
        [self addSubview:self.playImageView2];
        
        //播放按钮
        [self addSubview:self.playBtn];
        //音乐标题
        [self addSubview:self.nameLabel];
        //音乐时间
        [self addSubview:self.durationLabel];
        //移除按钮
        [self addSubview:self.deleteBtn];

    }
    return self;
}
#pragma mark -----------------------播放----------------------
-(UIImageView*)playImageView2
{
    if(_playImageView2==nil)
    {
        _playImageView2=[[UIImageView alloc] initWithFrame:CGRectMake(15, (self.height-14)/2, 14, 14)];
        _playImageView2.image=[UIImage imageNamed:@"dl_music_play"];
        _playImageView2.backgroundColor=[UIColor clearColor];
        _playImageView2.clipsToBounds=YES;
    }
    return _playImageView2;
}
#pragma mark -----------------------播放----------------------
-(YYAnimatedImageView*)playImageView
{
    if(_playImageView==nil)
    {
        _playImageView=[[YYAnimatedImageView alloc] initWithFrame:CGRectMake(15, (self.height-14)/2, 14, 14)];
        _playImageView.image=[UIImage imageNamed:@"dl_music_play"];
        _playImageView.backgroundColor=[UIColor clearColor];
        _playImageView.clipsToBounds=YES;
    }
    return _playImageView;
}
#pragma mark ----------------播放按钮-------------------------
- (UIButton *)playBtn {
    
    if (nil == _playBtn) {

        _playBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _playBtn.frame=CGRectMake(0, 0, 44, self.height);
        _playBtn.backgroundColor =[UIColor clearColor];
        [_playBtn addTarget:self action:@selector(toClickPlay) forControlEvents:UIControlEventTouchUpInside];
    }
    return _playBtn;
}
#pragma mark --------------------音乐标题-----------------------
-(UILabel*)nameLabel
{
    if(_nameLabel==nil)
    {
        _nameLabel=[[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(self.playBtn.frame), 10, 210, 16)];
        _nameLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size:11];
        _nameLabel.textColor=[UIColor whiteColor];
        _nameLabel.backgroundColor=[UIColor clearColor];
        _nameLabel.textAlignment=NSTextAlignmentLeft;
        _nameLabel.text=@"在屁大点的公园里挖呀挖";
    }
    return _nameLabel;
   
}
#pragma mark --------------------音乐时间-----------------------
-(UILabel*)durationLabel
{
    if(_durationLabel==nil)
    {
        _durationLabel=[[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(self.playBtn.frame), CGRectGetMaxY(self.nameLabel.frame), 210, 14)];
        _durationLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size:10];
        _durationLabel.textColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:0.5];
        _durationLabel.backgroundColor=[UIColor clearColor];
        _durationLabel.textAlignment=NSTextAlignmentLeft;
        _durationLabel.text=@"20S";
    }
    return _durationLabel;
   
}
#pragma mark -----------------移除按钮-------------------------
- (UIButton *)deleteBtn {
    
    if (nil == _deleteBtn) {

        _deleteBtn = [HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];

        _deleteBtn.backgroundColor =[UIColor clearColor];
        _deleteBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageLeft;
        _deleteBtn.imageTitleSpace=2;
        _deleteBtn.frame=CGRectMake(self.width-58, (self.height-34)/2, 38, 34);
        [_deleteBtn setImage:[UIImage imageNamed:@"dl_music_delete"] forState:UIControlStateNormal];
        [_deleteBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:0.5] forState:UIControlStateNormal];
        [_deleteBtn setTitle:@"移除" forState:UIControlStateNormal];
        _deleteBtn.titleLabel.font= [UIFont fontWithName:@"PingFangSC-Regular" size: 10];

        [_deleteBtn addTarget:self action:@selector(toClickDelete) forControlEvents:UIControlEventTouchUpInside];
    }
    return _deleteBtn;
}
#pragma mark -----------点击播放--------------
-(void)toClickPlay
{
//    self.musicModel.isPlaying=!self.musicModel.isPlaying;
    if(self.delegate &&[self.delegate respondsToSelector:@selector(toPlayMusic:)])
    {
        [self.delegate toPlayMusic:self.musicModel];
    }
}
#pragma mark -----------点击移除--------------
-(void)toClickDelete
{

    if(self.delegate &&[self.delegate respondsToSelector:@selector(toDeleteMusic:)])
    {
     
        [self.delegate toDeleteMusic:self.musicModel];
    }
}
-(void)toSetContent
{
    self.nameLabel.text=self.musicModel.tts_content;

    NSString *timeLength = [NSString stringWithFormat:@"%0.0f",self.musicModel.duration] ;
    self.durationLabel.text=[GlobalFunc getHHMMSSFromSS:timeLength.intValue];

    if(self.musicModel.isPlaying)
    {
        NSString *name_str=@"dl_home_live_scene_playing";
        NSString * filepath=[[NSBundle mainBundle] pathForResource:name_str ofType:@"gif"];
        self.playImageView.yy_imageURL=[NSURL fileURLWithPath:filepath];
        self.playImageView.hidden=NO;
        self.playImageView2.hidden=YES;
    }
    else
    {
        self.playImageView.hidden=YES;
        self.playImageView2.hidden=NO;
    }
}
@end
