//
//  BGMusicView.m
//  DreamLive
//
//  Created by guiji on 2023/5/23.
//

#import "BGMusicView.h"
#import "AudioPlayerView.h"
#import "AudioFileManager.h"
#import "WHActionSheet.h"
#import "DLTTSTextView.h"
@interface BGMusicView ()<UICollectionViewDelegate,UICollectionViewDataSource,BGMusicCellDelegate,WHActionSheetDelegate>
@property(nonatomic,strong)UIView * grayBackView;//灰色背景view
@property(nonatomic,strong)UIView * whiteBackView;//白色背景view
@property(nonatomic,strong)UILabel * titleLabel;//标题
@property(nonatomic,strong)UIButton *closeBtn;//关闭按钮
@property(nonatomic,strong)UIView*musicBackView;//音乐灰色背景view
@property(nonatomic,strong)UICollectionView*collectionView;//背景素材
@property(nonatomic,strong)UIView* backView2;
@property(nonatomic,strong)NSMutableArray*lists;//数组
@property(nonatomic,strong)UIButton * glBtn;//管理按钮
//话术列表按钮
@property (nonatomic, strong) HYEdgeInsetsButton * huashuBtn;
//添加音乐按钮
@property (nonatomic, strong) UIButton * addBtn;
//删除按钮
@property (nonatomic, strong) UIButton * sureBtn;
//请输入文本话术界面
@property (nonatomic, strong)DLTTSTextView * tts_text_view;
//播放num
@property (nonatomic, assign) NSInteger  play_num;



@property (nonatomic, assign) BOOL isStop;
@end
@implementation BGMusicView
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
   

        self.listModel=[[DLHomeListModel alloc] init];
        self.lists=[[NSMutableArray alloc] init];
        //灰色背景view
        [self addSubview:self.grayBackView];
        
        //白色背景view
        [self addSubview:self.whiteBackView];
        
        //音频播放
        [self addSubview:self.audioPlayView];
        
        //标题-请选择接管直播间
        [self.whiteBackView addSubview:self.titleLabel];
        
        //关闭按钮
        [self.whiteBackView addSubview:self.closeBtn];
        
        //顺序播放按钮
        [self.whiteBackView addSubview:self.huashuBtn];
        
        //背景音乐背景
        [self.whiteBackView addSubview:self.musicBackView];
    
        //添加音乐按钮
        [self.whiteBackView addSubview:self.addBtn];
        
    
        
        //删除按钮
        [self.whiteBackView addSubview:self.sureBtn];
        

        
        //背景音乐
        [self.musicBackView addSubview:self.collectionView];
   
//        [self.whiteBackView addSubview:self.glBtn];

        [self toLoadPLayBlock];
        //点击隐藏界面
        UITapGestureRecognizer * tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toHiddenView)];
        [self.grayBackView addGestureRecognizer:tap];
    }
    return self;
}
#pragma mark ---------------播放回调--------------------------
-(void)toLoadPLayBlock
{
    MJWeakSelf
    self.audioPlayView.playStatus = ^(AVPlayerItemStatus status) {
        if(status==AVPlayerItemStatusReadyToPlay)
        {
            [weakSelf.audioPlayView play];
        }
    };
}
#pragma mark --------------------灰色背景view-----------------------
-(UIView *) grayBackView
{
    if(_grayBackView==nil)
    {
        _grayBackView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.width, self.height)];
        _grayBackView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.6];

    }
    return _grayBackView;
}

//#pragma mark --------------------灰色背景view2-----------------------
-(UIView *) musicBackView
{
    if(_musicBackView==nil)
    {
        _musicBackView = [[UIView alloc] initWithFrame:CGRectMake(20,CGRectGetMaxY(self.huashuBtn.frame)+8,self.width-40, self.whiteBackView.height-132-[GlobalFunc getSafeBottom])];
        _musicBackView.backgroundColor = [UIColor colorWithHexString:@"#1A2034" alpha:1.0];
        _musicBackView.layer.cornerRadius=6;
        _musicBackView.clipsToBounds=YES;
    }
    return _musicBackView;
}
#pragma mark ----------------------音频播放界面--------------------
-(AudioPlayerView*)audioPlayView
{
    if(_audioPlayView==nil)
    {
        _audioPlayView=[[AudioPlayerView alloc] initWithFrame:CGRectZero];
        [self toAudioPlayViewBlock];
    
    }
    return _audioPlayView;
}
-(void)toAudioPlayViewBlock
{
    MJWeakSelf
    self.audioPlayView.playEnd = ^{
        [weakSelf toPLayEnd];
    };
}
-(void)toPLayEnd
{
    [self.audioPlayView pause];
    if(self.lists.count>_play_num)
    {
        BGMusicModel * musicModel=self.lists[_play_num];
        musicModel.isPlaying=NO;
        [self.collectionView reloadData];
     
    }
    
}
#pragma mark --------------------白色背景view-----------------------
-(UIView *) whiteBackView
{
    if(_whiteBackView==nil)
    {
        _whiteBackView = [[UIView alloc] initWithFrame:CGRectMake(0, self.height-577, self.width, 577)];
        _whiteBackView.backgroundColor = [UIColor colorWithHexString:@"#212942" alpha:1.0];
        _whiteBackView.clipsToBounds=YES;
        _whiteBackView.layer.cornerRadius=12;
      //  [GlobalFunc cutrounded:_whiteBackView :UIRectCornerTopLeft|UIRectCornerTopRight :CGSizeMake(6, 6)];

    }
    return _whiteBackView;
}
#pragma mark --------------------标题-已导入播放列表-----------------------
-(UILabel*)titleLabel
{
    if(_titleLabel==nil)
    {
        _titleLabel=[[UILabel alloc] initWithFrame:CGRectMake(20, 0, 98, 44)];
        _titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        _titleLabel.textColor=[UIColor whiteColor];
        _titleLabel.backgroundColor=[UIColor clearColor];
        _titleLabel.textAlignment=NSTextAlignmentLeft;
        _titleLabel.text=@"请设置话术";
    }
    return _titleLabel;
   
}
#pragma mark -----------------话术列表按钮-------------------------
- (UIButton *)huashuBtn {
    
    if (nil == _huashuBtn) {

        _huashuBtn = [HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];
        _huashuBtn.frame=CGRectMake(20, CGRectGetMaxY(self.titleLabel.frame)+3, 61, 18);
        _huashuBtn.backgroundColor =[UIColor clearColor];
        _huashuBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageLeft;
//        _sx_btn.imageTitleSpace=4;
        [_huashuBtn setTitle:@"话术列表" forState:UIControlStateNormal];
//        [_sx_btn setImage:[UIImage imageNamed:@"gpt_bg_music_sx"] forState:UIControlStateNormal];
        _huashuBtn.titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:11];
        [_huashuBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _huashuBtn.userInteractionEnabled=NO;
    }
    return _huashuBtn;
}
#pragma mark --------------------关闭按钮-----------------------
-(UIButton*)closeBtn
{
   if(_closeBtn==nil)
   {
       //关闭按钮
       UIImage *closeImage=[UIImage imageNamed:@"dl_live_pl_close"];
      _closeBtn=[UIButton buttonWithType:UIButtonTypeCustom];
       _closeBtn.frame=CGRectMake(self.whiteBackView.width-12-44+(44-closeImage.size.width)/2, 10-(44-closeImage.size.height)/2, 44, 44);
       [_closeBtn setImage:closeImage forState:UIControlStateNormal];
       _closeBtn.backgroundColor=[UIColor clearColor];
       [_closeBtn addTarget:self action:@selector(toHiddenView) forControlEvents:UIControlEventTouchDown];
   }
   return _closeBtn;
}

#pragma mark -----------------添加音乐按钮-------------------------
- (UIButton *)addBtn {
    
    if (nil == _addBtn) {

        _addBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _addBtn.frame=CGRectMake(20, CGRectGetMaxY(self.musicBackView.frame)+15, (self.width-50)/2, 44);
        _addBtn.backgroundColor =[UIColor clearColor];
        _addBtn.layer.borderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor;
        _addBtn.layer.borderWidth=1;
        [_addBtn setTitle:@"新增话术" forState:UIControlStateNormal];
        _addBtn.titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        [_addBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _addBtn.layer.cornerRadius=4;
        _addBtn.clipsToBounds=YES;
//        [_add_btn setImage:ImageWithFileName(@"gpt_bg_music_add") forState:UIControlStateNormal];
        [_addBtn addTarget:self action:@selector(toClickAddMusic) forControlEvents:UIControlEventTouchUpInside];
    }
    return _addBtn;
}

#pragma mark -----------------确认按钮-------------------------
- (UIButton *)sureBtn {
    
    if (nil == _sureBtn) {

        _sureBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _sureBtn.frame=CGRectMake(CGRectGetMaxX(self.addBtn.frame)+10, CGRectGetMaxY(self.musicBackView.frame)+15, (self.width-50)/2, 44);
        _sureBtn.backgroundColor =[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        [_sureBtn setTitle:@"确认" forState:UIControlStateNormal];
        _sureBtn.titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        [_sureBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _sureBtn.layer.cornerRadius=4;
        _sureBtn.clipsToBounds=YES;
//        [_add_btn setImage:ImageWithFileName(@"gpt_bg_music_add") forState:UIControlStateNormal];
        [_sureBtn addTarget:self action:@selector(toClickSure) forControlEvents:UIControlEventTouchUpInside];
    }
    return _sureBtn;
}
-(DLTTSTextView*)tts_text_view
{
    if(nil==_tts_text_view)
    {
        MJWeakSelf
        _tts_text_view=[[DLTTSTextView alloc] initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)];
        _tts_text_view.selectTtsBlock = ^(NSString *url_str, NSString *tts_text) {
            NSArray * urls=[NSArray arrayWithObjects:[NSURL URLWithString:url_str], nil];
            [GlobalFunc toSaveAudioFile:weakSelf.lists :urls :weakSelf.listModel.Id :1 :tts_text];
            [weakSelf  toReadAudioFie];
        };
     
    }
    return _tts_text_view;
}
- (UICollectionView *)collectionView {
    
    if (nil == _collectionView) {
        UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
        layout.scrollDirection = UICollectionViewScrollDirectionVertical;
        //layout.isCalculateHeader=YES;
//        layout.sectionInset = UIEdgeInsetsMake(12, 9, 12, 10);
        _collectionView = [[UICollectionView alloc] initWithFrame:CGRectMake(10,10,self.musicBackView.width-20, self.musicBackView.height-20) collectionViewLayout:layout];
        _collectionView.delegate = self;
        _collectionView.dataSource = self;
        _collectionView.showsVerticalScrollIndicator = NO;
        _collectionView.showsHorizontalScrollIndicator = NO;
        _collectionView.backgroundColor = [UIColor clearColor];
        [_collectionView registerClass:[BGMusicCell class] forCellWithReuseIdentifier:@"BGMusicCell"];
        _collectionView.layer.cornerRadius=6;
        _collectionView.clipsToBounds=YES;
//        [_collectionView registerClass:[PictureHeaderView1 class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"PictureHeaderView1"];
//        [_collectionView registerClass:[PictureHeaderView2 class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"PictureHeaderView2"];
        _collectionView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
       
    }
    return _collectionView;
}
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 1;
}
#pragma mark -UICollectionViewDataSource
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
     
 
        return  self.lists.count;
    



 
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
   
           BGMusicCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"BGMusicCell" forIndexPath:indexPath];
           BGMusicModel *musicModel=self.lists[indexPath.item];
           cell.musicModel=musicModel;
           cell.delegate=self;
           [cell toSetContent];
           return cell;
      
  
}

#pragma mark -UICollectionViewDelegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
 
  
  
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath {
    
  
    return CGSizeMake(floor((self.collectionView.width)), floor(52));
     
   

}
//---------------------------------------------------------------------------
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{

 
    return UIEdgeInsetsMake(0, 0, 0, 0);
  
 

}
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section {
    
    return 6;
}
    
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section {
    

    return 0;

  
}
-(void)toHiddenView
{


    self.audioPlayView.isCanPLay=NO;
    [self toStopALLPlay];
    self.hidden=YES;
    if(self.sureBlock)
    {
        self.sureBlock(1, self.lists);
    }
}






#pragma mark---------------点击添加音乐-------------------------
-(void)toClickAddMusic
{
    [self toStopALLPlay];

    [GlobalFunc toSaveAudioTxt:self.lists :self.listModel.Id];
    
    // 初始化 默认样式
    WHActionSheet *actionSheet = [[WHActionSheet alloc] initWithTitle:@"" sheetTitles:@[@"上传音频",@"输入文本"] cancleBtnTitle:@"取消" sheetStyle:(WHActionSheetIconAndTitle) delegate:nil];

    actionSheet.isCorner = NO;

    actionSheet.cancleHeight = 85+[GlobalFunc getSafeBottom];
    
    actionSheet.subtitleFont=[UIFont fontWithName:@"PingFangSC-Medium" size:12];
    
    // 传入图片数组
    actionSheet.iconArr = [NSMutableArray arrayWithObjects:@"dl_upload_music",@"dl_shuru_wenben", nil];
    
    /*
     * 设置代理 也可在初始化时设置代理
     */
    actionSheet.delegate = self;
    
    
    [actionSheet show];

}
/*
 * ActionSheet 代理方法
 */

- (void)actionSheet:(WHActionSheet *)actionSheet clickButtonAtIndex:(NSInteger)buttonIndex{

    NSLog(@"点击了sheet%ld",(long)buttonIndex+1);
    if(buttonIndex==0)
    {
        MJWeakSelf;
        [[AudioFileManager manager] openFileAndSelectFile:^(NSArray<NSURL *> * _Nonnull urls) {
    
            [GlobalFunc toSaveAudioFile:weakSelf.lists :urls :weakSelf.listModel.Id :0 :@""];
            [weakSelf  toReadAudioFie];

    
        }];
    }
    else    if(buttonIndex==1)
    {
        [self toLoadTTSTextView];
    }
   
}

- (void)actionSheetCancle:(WHActionSheet *)actionSheet{

    NSLog(@"取消");
}
#pragma mark---------------加载输入文本话术界面-------------------------
-(void)toLoadTTSTextView
{
    [self toRemoveTTSTextView];
    
    [self addSubview:self.tts_text_view];
}
#pragma mark---------------删除输入文本话术界面-------------------------
-(void)toRemoveTTSTextView
{
    if(self.tts_text_view!=nil)
    {
        [self.tts_text_view removeFromSuperview];
        self.tts_text_view=nil;
    }
}
#pragma mark---------------点击确认-------------------------
-(void)toClickSure
{
    [self.audioPlayView cancelLoading];
    if(self.sureBlock)
    {
        self.sureBlock(1, self.lists);
    }
}
-(void)toStopALLPlay
{
    [self.audioPlayView pause];
    [self.audioPlayView cancelLoading];
    [self toStopReloadView];
   
}
-(void)toStopReloadView
{
    for(int i=0;i<self.lists.count;i++)
    {
        BGMusicModel *music_model=self.lists[i];
        music_model.isPlaying=NO;
          
    }
    [self.collectionView reloadData];
}
#pragma mark ------------读取本地音频文件------------------
-(void)toReadAudioFie
{
    NSArray *arr=[GlobalFunc toReadAudioFile:self.listModel.Id];
    if(arr==nil)
    {
        arr=[[NSArray alloc] init];
    }
    self.lists=[NSMutableArray arrayWithArray:arr];

    [self.collectionView reloadData];



}


#pragma mark ----------------BGMusicCellDelegate------------------------
//播放音乐
-(void)toPlayMusic:(BGMusicModel*)musicModel
{

    NSFileManager * filemanager=[NSFileManager defaultManager];
    NSString * filepath=[NSString stringWithFormat:@"%@/%@",[GlobalFunc getHistoryCachePath:DLMUSIC],musicModel.music_name];
    
    if([filemanager fileExistsAtPath:filepath] || musicModel.type==1)
    {


                if(!musicModel.isPlaying)
                {
//                    musicModel.isPlaying=YES;
                    [self toSelectAudio:musicModel];
//                    if(musicModel.type==1)
//                    {
//                        [self.audioPlayView setPlayerWithUrl:musicModel.music_name];
//                    }
//                    else
//                    {
                        [self.audioPlayView setPlayWithPath:filepath];
//                    }
            
                    
                    if(self.playBlock)
                    {
                        self.playBlock(musicModel);
                    }
                    if(self.lists.count>0)
                    {
                        if([self.lists containsObject:musicModel])
                        {
                            _play_num=[self.lists indexOfObject:musicModel];
                        }
                    }
                }
                else
                {
                    musicModel.isPlaying=NO;
                    [self.audioPlayView pause];
                }



        [self.collectionView reloadData];
    }
    else
    {
        [GlobalFunc showLoadText:@"音频文件不存在" :self];
    }
    
}
-(void)toSelectAudio:(BGMusicModel*)musicModel
{
    for(int i=0;i<self.lists.count;i++)
    {
        BGMusicModel *music_model=self.lists[i];
        
        if(music_model.pid==musicModel.pid)
        {
            music_model.isPlaying=YES;
        }
        else
        {
            music_model.isPlaying=NO;
        }
        
          
    }
}
//移除音乐
-(void)toDeleteMusic:(BGMusicModel*)musicModel
{
    MJWeakSelf
    [GlobalFunc alertWithTitle:@"提示" msg:@"移除的音乐将不会在直播间播放，\n确认移除吗？" cancle:@"取消" sure:@"确定" :^(NSInteger type) {
        if(type==1)
        {
            [weakSelf toRemoveMusic:musicModel];
        }
    }];
 
}
-(void)toRemoveMusic:(BGMusicModel*)musicModel
{
    NSMutableArray * dataArr=[NSMutableArray arrayWithArray:self.lists];
    for(int i=0;i<self.lists.count;i++)
    {
        BGMusicModel * musci_model=self.lists[i];
        if(musci_model.pid==musicModel.pid)
        {
            if(musicModel.isPlaying)
            {
                [self.audioPlayView cancelLoading];
            }
            [dataArr removeObject:musci_model];
        }
    }
    self.lists=[NSMutableArray arrayWithArray:dataArr];
    [self.collectionView reloadData];
    for(int i=0;i<dataArr.count;i++)
    {
        BGMusicModel * musci_model=dataArr[i];
        musci_model.isPlaying=NO;
        
    }
    self.lists=dataArr;
    [GlobalFunc toSaveAudioTxt:self.lists :self.listModel.Id];
    [GlobalFunc showLoadText:@"已移除播放列表" :self];
    if(self.lists.count==0)
    {
        self.audioPlayView.isCanPLay=NO;
    }
//
//    if(self.musicViewBlock)
//    {
//        self.musicViewBlock(self.audioModel);
//    }
}



-(void)toPLayAudio
{
//    if(self.lists.count>_play_num)
//    {
//        BGMusicModel * musicModel=self.lists[_play_num];
//        NSString * filepath=[NSString stringWithFormat:@"%@/%@",[GlobalFunc getHistoryCachePath:BGMUSIC],musicModel.music_name];
//        [self toSelectAudio:musicModel];
//        [self.audioPlayView setVolume:self.audioModel.volume];
//        self.audioPlayView.isCanPLay=YES;
//
//        [self.audioPlayView setPlayWithPath:filepath];
//        [self.collectionView reloadData];
//        if(self.playBlock)
//        {
//            self.playBlock(musicModel);
//        }
//    }
}
-(void)toLoadData
{
    [self toReadAudioFie];
    if(self.sureBlock)
    {
        self.sureBlock(1, self.lists);
    }
}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
