//
//  DLHomeHeaderView.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/4.
//

#import "DLHomeHeaderView.h"
#import "NSString+LYAttributedString.h"
@interface DLHomeHeaderView ()
///标题
@property(nonatomic,strong)UIImageView * titleImageView;
///创建直播
@property(nonatomic,strong)HYEdgeInsetsButton *createBtn;
//直播列表
@property (nonatomic, strong) UILabel *subTitLabel;
//刷新按钮
@property (nonatomic, strong) UIButton *refreshBtn;
@end
@implementation DLHomeHeaderView
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
       

        [self loadSubView];
    
 
    }
    return self;
}
-(void)loadSubView
{
    //标题
    [self addSubview:self.titleImageView];
    
    //创建直播按钮
    [self addSubview:self.createBtn];
    //直播列表
    [self addSubview:self.subTitLabel];
    //刷新按钮
    [self addSubview:self.refreshBtn];
}
#pragma mark --------------------标题-----------------------
-(UIImageView*)titleImageView
{
    if(_titleImageView==nil)
    {
        _titleImageView=[[UIImageView alloc] init];
        _titleImageView.frame=CGRectMake(14, 20, 102, 18);
        _titleImageView.image=[UIImage imageNamed:@"dl_sdk_demo"];
    }
    return _titleImageView;
   
}
#pragma mark --------------创建直播按钮-------------------
-(HYEdgeInsetsButton*)createBtn
{
    if(_createBtn==nil)
    {
        _createBtn=[HYEdgeInsetsButton buttonWithType:UIButtonTypeCustom];
        _createBtn.frame=CGRectMake(14, CGRectGetMaxY(self.titleImageView.frame)+20, self.frame.size.width-28, 66);
        _createBtn.edgeInsetsStyle=HYButtonEdgeInsetsStyleImageLeft;
        _createBtn.imageTitleSpace=8;
        [_createBtn setImage:[UIImage imageNamed:@"dl_gpt_create"] forState:UIControlStateNormal];
        [_createBtn setTitle:@"创建直播" forState:UIControlStateNormal];
        _createBtn.titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        [_createBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        [_createBtn addTarget:self action:@selector(toCreateLive) forControlEvents:UIControlEventTouchDown];
        CAGradientLayer *gl = [CAGradientLayer layer];
        gl.frame =_createBtn.frame;
        gl.startPoint = CGPointMake(0.5, 1);
        gl.endPoint = CGPointMake(0.5, -0.59);
        gl.colors = @[(__bridge id)[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor, (__bridge id)[UIColor colorWithHexString:@"#0030F4" alpha:1.0].CGColor];
        gl.locations = @[@(0), @(1.0f)];
        gl.cornerRadius = 4;
        [self.layer addSublayer:gl];
      

    }
    return _createBtn;
}
#pragma mark --------------直播列表-------------------
- (UILabel *)subTitLabel {
    
    if (nil == _subTitLabel) {
        _subTitLabel = [[UILabel alloc] initWithFrame:CGRectMake(17, CGRectGetMaxY(self.createBtn.frame)+24, 100, 16)];
        _subTitLabel.text = @"直播列表";
        _subTitLabel.textColor = [UIColor whiteColor];
        _subTitLabel.font =[UIFont fontWithName:@"PingFangSC-Medium" size:16];
        _subTitLabel.textAlignment=NSTextAlignmentLeft;
    }
    return _subTitLabel;
}
#pragma mark --------------刷新按钮-------------------
- (UIButton *)refreshBtn {
    
    if (nil == _refreshBtn) {
        _refreshBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _refreshBtn.frame=CGRectMake(self.frame.size.width-40-3, CGRectGetMinY(self.subTitLabel.frame)-12, 40, 40);
        [_refreshBtn setImage:[UIImage imageNamed:@"dm_home_refresh"] forState:UIControlStateNormal];
        [_refreshBtn addTarget:self action:@selector(refreshAction) forControlEvents:UIControlEventTouchUpInside];
    }
    return _refreshBtn;
}
#pragma mark --------------创建直播间-------------------
-(void)toCreateLive
{
    if (self.headerBlock) {
        self.headerBlock(0);
    }
}
#pragma mark --------------点击刷新按钮-------------------
-(void)refreshAction
{
    [self startAnimation];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5* NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        if (self.headerBlock) {
            self.headerBlock(1);
        }
    });
}
#pragma mark ---------------旋转动画-------------------
- (void)startAnimation {
    
    self.refreshBtn.userInteractionEnabled = NO;
    CABasicAnimation *rotationAnimation;
    rotationAnimation = [CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
    rotationAnimation.toValue = [NSNumber numberWithFloat: -M_PI * 2.0 ];
    rotationAnimation.duration = 1;
    rotationAnimation.cumulative = YES;
    rotationAnimation.repeatCount = 1000000;
    [self.refreshBtn.layer addAnimation:rotationAnimation forKey:@"rotationAnimation"];
}
#pragma mark ---------------结束旋转动画-------------------
- (void)requestFinish {
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5* NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self.refreshBtn.layer removeAllAnimations];
        self.refreshBtn.userInteractionEnabled = YES;
    });
}
@end
