//
//  DLHomeListCell.m
//  DreamLive
//
//  Created by cunzhi on 2022/9/21.
//

#import "DLHomeListCell.h"

@interface DLHomeListCell ()

@property (nonatomic, strong) UIView *bgView;
@property (nonatomic, strong) UIImageView *bgImgView;
@property (nonatomic, strong) UIImageView *coverImgView;
@property (nonatomic, strong) UILabel *tagLabel;
@property (nonatomic, strong) UILabel *titLabel;
@property (nonatomic, strong) UILabel *infoLable;
@property (nonatomic, strong) UILabel *idLable;



@end
@implementation DLHomeListCell

- (id)initWithFrame:(CGRect)frame{
    
    self = [super initWithFrame:frame];
    if (self) {
        self.clipsToBounds = YES;
        self.contentView.backgroundColor = [UIColor clearColor];
        self.backgroundColor = [UIColor clearColor];
        
        self.listModel=[[DLHomeListModel alloc] init];
        //背景view
        [self.contentView addSubview:self.bgView];
        //背景图片
        [self.bgView addSubview:self.bgImgView];
        //封面图片
        [self.bgView addSubview:self.coverImgView];
        //直播间名称
        [self.bgView addSubview:self.titLabel];
        //模特名称和时间
        [self.bgView addSubview:self.infoLable];
        //ID
        [self.bgView addSubview:self.idLable];

        
    
    }
    return self;
}




#pragma mark ----------------背景view------------------
- (UIView *)bgView {

    if (nil == _bgView) {
        _bgView = [[UIView alloc] init];
        _bgView.frame=CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
        _bgView.backgroundColor = [UIColor colorWithHexString:@"#32355C" alpha:1.0];
        _bgView.layer.masksToBounds = YES;
        _bgView.layer.cornerRadius = 8;
    }
    return _bgView;
}
#pragma mark ----------------背景图片------------------
- (UIImageView *)bgImgView {

    if (nil == _bgImgView) {
        _bgImgView = [[UIImageView alloc] init];
        _bgImgView.frame=CGRectMake(0, 0, self.frame.size.width, self.frame.size.height-56);
        _bgImgView.layer.masksToBounds = YES;
        _bgImgView.layer.cornerRadius = 4;
        _bgImgView.contentMode = UIViewContentModeScaleAspectFill;
        UIBlurEffect *blurEffect = [UIBlurEffect effectWithStyle:UIBlurEffectStyleLight];
        UIVisualEffectView *visualView = [[UIVisualEffectView alloc]initWithEffect:blurEffect];
        visualView.frame =CGRectMake(0, 0, self.frame.size.width, self.frame.size.height-56+0.5);
        visualView.layer.cornerRadius= 4;
        [_bgImgView addSubview:visualView];
    }
    return _bgImgView;
}
#pragma mark ----------------图片------------------
- (UIImageView *)coverImgView {

    if (nil == _coverImgView) {
        _coverImgView = [[UIImageView alloc] init];
        _coverImgView.frame=CGRectMake(0, 0, self.frame.size.width, self.frame.size.height-56);
        _coverImgView.contentMode = UIViewContentModeScaleAspectFit;
    }
    return _coverImgView;
}


#pragma mark --------------直播间名称----------------------
- (UILabel *)titLabel {

    if (nil == _titLabel) {
        _titLabel = [[UILabel alloc] init];
        _titLabel.frame=CGRectMake(12, CGRectGetMaxY(self.bgImgView.frame)+15, 200, 16);
        _titLabel.textColor =[UIColor whiteColor];
        _titLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:12];
        _titLabel.textAlignment=NSTextAlignmentLeft;
        _titLabel.text=@"直播名称";

    }
    return _titLabel;
}
#pragma mark --------------模特名称和时间----------------------
- (UILabel *)infoLable {

    if (nil == _infoLable) {
        _infoLable = [[UILabel alloc] init];
        _infoLable.frame=CGRectMake(12, CGRectGetMaxY(self.titLabel.frame)+1, 200, 16);
        _infoLable.textColor = [UIColor colorWithHexString:@"#828CA0" alpha:1.0];
        _infoLable.font = [UIFont fontWithName:@"PingFangSC-Regular" size:10];
        _infoLable.textAlignment=NSTextAlignmentLeft;
        _infoLable.text=@"模特名称  2022-09-20 10:17";
    }
    return _infoLable;
}
#pragma mark --------------ID----------------------
- (UILabel *)idLable {

    if (nil == _idLable) {
        _idLable = [[UILabel alloc] init];
        _idLable.frame=CGRectMake(self.frame.size.width-58-13, CGRectGetMaxY(self.bgImgView.frame)+20, 58, 16);
        _idLable.backgroundColor = [UIColor colorWithHexString:@"#444CF0" alpha:1.0];
        _idLable.layer.masksToBounds = YES;
        _idLable.layer.cornerRadius = 3;
        _idLable.textColor = [UIColor whiteColor];
        _idLable.textAlignment = NSTextAlignmentCenter;
        _idLable.font = [UIFont fontWithName:@"PingFangSC-Medium" size:10];
        _idLable.text=@"ID：00001";
    

    }
    return _idLable;
}

-(void)toSetContent
{
    
    self.titLabel.text = self.listModel.liveName;
    if (IS_Agent_EMPTY(self.listModel.modeName)) {
        self.infoLable.text = [NSString stringWithFormat:@"%@",self.listModel.createdTime?:@""];
    } else {
        self.infoLable.text = [NSString stringWithFormat:@"%@  %@",self.listModel.modeName,self.listModel.createdTime?:@""];
    }
    
    self.idLable.text = [NSString stringWithFormat:@"ID: %@",self.listModel.Id];
    NSString* imagepath= [[NSBundle mainBundle].resourcePath stringByAppendingPathComponent:@"dl_home_live_scene_placeholder"];
    UIImage *placeImage=  [UIImage imageWithContentsOfFile:imagepath];
    [self.coverImgView yy_setImageWithURL:[NSURL URLWithString:self.listModel.coverUrl] placeholder:placeImage];
    [self.bgImgView yy_setImageWithURL:[NSURL URLWithString:self.listModel.coverUrl] placeholder:placeImage];
}


- (void)setSelected:(BOOL)selected {
    [super setSelected:selected];

    // Configure the view for the selected state
}




@end
