//
//  DLRTMPView.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/18.
//

#import "DLRTMPView.h"

@interface DLRTMPView ()<UITextViewDelegate>
@property(nonatomic,strong)UIView * tapView;

@property(nonatomic,strong)UIView * bottomBackView;
//标题
@property(nonatomic,strong)UILabel * titleLabel;
//rtmp文本内容
@property(nonatomic,strong)UITextView* promptTextView;

//取消
@property(nonatomic,strong)UIButton *cancelBtn;
//确认
@property(nonatomic,strong)UIButton *startBtn;
@end
@implementation DLRTMPView

-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
       
        [self loadSubView];
    }
    return self;
}
-(void)loadSubView
{
 
    //灰色背景view
    [self addSubview:self.tapView];
    
    //白色背景view
    [self addSubview:self.bottomBackView];
    //标题
    [self.bottomBackView addSubview:self.titleLabel];
  

    
    //文本内容
    [self.bottomBackView addSubview:self.promptTextView];

    //取消
    [self.bottomBackView addSubview:self.cancelBtn];
    //确认
    [self.bottomBackView addSubview:self.startBtn];
    

    

    //点击隐藏界面
    UITapGestureRecognizer * tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toHiddenView)];
    [self.tapView addGestureRecognizer:tap];
}
-(void)layoutSubviews
{
    [super layoutSubviews];

    self.tapView.frame=CGRectMake(0, 0, self.width, self.height);
    self.bottomBackView.frame=CGRectMake(0, self.height-203-[GlobalFunc getSafeBottom], self.width, 203+[GlobalFunc getSafeBottom]);
    self.titleLabel.frame=CGRectMake(20, 18, 98, 18);

    self.promptTextView.frame=CGRectMake(20, CGRectGetMaxY(self.titleLabel.frame)+13, self.bottomBackView.width-40, 86);

    self.cancelBtn.frame=CGRectMake(20, CGRectGetMaxY(self.promptTextView.frame)+21, floor(self.bottomBackView.width-50)/2, 44);
    self.startBtn.frame=CGRectMake(CGRectGetMaxX(self.cancelBtn.frame)+10, CGRectGetMaxY(self.promptTextView.frame)+21, floor(self.bottomBackView.width-50)/2, 44);

}
-(UIView*)tapView
{
    if(nil==_tapView)
    {
        _tapView=[[UIView alloc] init];
        _tapView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.5];
//        _tapView.hidden=YES;
    }
    return _tapView;
}

-(UIView*)bottomBackView
{
    if(nil==_bottomBackView)
    {
        _bottomBackView=[[UIView alloc] init];
        _bottomBackView.backgroundColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        _bottomBackView.layer.cornerRadius=12;
    }
    return _bottomBackView;
}
#pragma mark --------------------标题-已导入播放列表-----------------------
-(UILabel*)titleLabel
{
    if(_titleLabel==nil)
    {
        _titleLabel=[[UILabel alloc] init];
        _titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        _titleLabel.textColor=[UIColor whiteColor];
        _titleLabel.backgroundColor=[UIColor clearColor];
        _titleLabel.textAlignment=NSTextAlignmentLeft;
        _titleLabel.text=@"直播推流地址";
    }
    return _titleLabel;
   
}
#pragma mark-------------文本内容----------------
-(UITextView*)promptTextView
{
    if(_promptTextView==nil)
    {
//        NSString* place_str=@"请输入文本内容";
        _promptTextView=[[UITextView alloc] init];
        //_promptTextView.attributedPlaceholder=[place_str attributeFont:[UIFont fontWithName:@"PingFangSC-Regular" size:10] color:[UIColor colorWithHexString:@"#FFFFFF" alpha:0.4] subText:place_str];
        _promptTextView.font=[UIFont fontWithName:@"PingFangSC-Regular" size:10];
        _promptTextView.textColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0];
        _promptTextView.delegate=self;
        _promptTextView.textAlignment=NSTextAlignmentLeft;
        _promptTextView.layer.cornerRadius=6;
        _promptTextView.layer.masksToBounds=YES;
        _promptTextView.backgroundColor=[UIColor colorWithHexString:@"#1D1F32" alpha:1.0];
        _promptTextView.textContainerInset = UIEdgeInsetsMake(17, 12, 0, 12);
        _promptTextView.contentInset= UIEdgeInsetsMake(0, 0, 17, 0);
        _promptTextView.editable=NO;
        

    }
    return _promptTextView;
}
#pragma mark-------------取消---------------------
-(UIButton*)cancelBtn
{
    if (nil == _cancelBtn) {
        _cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_cancelBtn setTitle:@"复制推流地址" forState:UIControlStateNormal];
        [_cancelBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _cancelBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size: 14];
        _cancelBtn.backgroundColor=[UIColor clearColor];
        _cancelBtn.layer.cornerRadius=4;
        _cancelBtn.layer.masksToBounds=YES;
        _cancelBtn.layer.borderWidth=1;
        _cancelBtn.layer.borderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor;
        [_cancelBtn addTarget:self action:@selector(toClickCopy) forControlEvents:UIControlEventTouchDown];
    }
    return _cancelBtn;
}
#pragma mark-------------确认---------------------
-(UIButton*)startBtn
{
    if (nil == _startBtn) {
        _startBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_startBtn setTitle:@"确认" forState:UIControlStateNormal];
        [_startBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _startBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size: 14];
        _startBtn.backgroundColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        _startBtn.layer.cornerRadius=4;
        _startBtn.layer.masksToBounds=YES;
        [_startBtn addTarget:self action:@selector(toClickStart) forControlEvents:UIControlEventTouchDown];
    }
    return _startBtn;
}
-(void)toClickCopy
{
   
    [self toClickBtn:0];
}
-(void)toClickStart
{
    [self toClickBtn:1];
    
}

-(void)toClickBtn:(NSInteger)type
{
    if(self.promptTextView.text.length==0)
    {
        [GlobalFunc showLoadText:@"推流地址不能为空" :self];
        return;
    }
    if(type==0)
    {
        UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
        pasteboard.string = self.promptTextView.text;
        [GlobalFunc showWindowText:@"推流地址复制成功" :self];
    }
    
    if(self.rtmpBlock)
    {
        self.rtmpBlock(type,  self.promptTextView.text);
    }
    [self toHiddenView];
}
-(void)toHiddenView
{
    self.hidden=YES;
    
}
-(void)toSetRtmpUrl:(NSString*)rtmp_url
{
    self.promptTextView.text=rtmp_url;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
