//
//  DLSelectDigitalCell.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/5.
//

#import "DLSelectDigitalCell.h"
@interface DLSelectDigitalCell ()
//封面头像
@property (nonatomic, strong) UIImageView *coverImgView;
//数字人名称
@property (nonatomic, strong) UILabel *titLabel;
@end

@implementation DLSelectDigitalCell
- (id)initWithFrame:(CGRect)frame{
    
    self = [super initWithFrame:frame];
    if (self) {
        [self loadSubView];

      

        
    
    }
    return self;
}

-(void)loadSubView
{
    self.clipsToBounds = YES;
    self.contentView.backgroundColor = [UIColor clearColor];
    self.backgroundColor = [UIColor colorWithHexString:@"#1D1F32" alpha:1.0];
    self.layer.cornerRadius=4;
    //封面头像
    [self addSubview:self.coverImgView];
    
    //数字人名称
    [self addSubview:self.titLabel];
}
#pragma mark ------------------封面头像-------------------
-(UIImageView*)coverImgView
{
    if(_coverImgView==nil)
    {
        _coverImgView=[[UIImageView alloc] init];
        _coverImgView.frame=CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
        _coverImgView.backgroundColor=[UIColor clearColor];
        _coverImgView.layer.cornerRadius=4;
        _coverImgView.clipsToBounds=YES;
        _coverImgView.contentMode=UIViewContentModeScaleAspectFill;
    }
    return _coverImgView;
}
#pragma mark --------------数字人名称----------------------
- (UILabel *)titLabel {

    if (nil == _titLabel) {
        _titLabel = [[UILabel alloc] init];
        _titLabel.frame=CGRectMake(0, self.frame.size.height-28, self.frame.size.width, 28);
        _titLabel.textColor =[UIColor colorWithHexString:@"#FFFFFF" alpha:0.5];
        _titLabel.font = [UIFont fontWithName:@"PingFangSC-Regular" size:11];
        _titLabel.textAlignment=NSTextAlignmentCenter;
        _titLabel.backgroundColor=[UIColor colorWithHexString:@"#353958" alpha:1.0];
        _titLabel.text=@"数字人名称";

    }
    return _titLabel;
}
-(void)toSetContent
{
    self.titLabel.text=self.selectDigitalModel.robotName;
    [self.coverImgView yy_setImageWithURL:[NSURL URLWithString:self.selectDigitalModel.coverUrl] placeholder:nil];
    if(self.selectDigitalModel.isSelect)
    {
        self.layer.borderWidth=1.5;
        self.layer.borderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor;
    }
   else
   {
       self.layer.borderWidth=0;
       self.layer.borderColor=[UIColor clearColor].CGColor;
   }
}
- (void)setSelected:(BOOL)selected {
    [super setSelected:selected];
//     if(selected)
//     {
//         self.layer.borderWidth=1.5;
//         self.layer.borderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor;
//     }
//    else
//    {
//        self.layer.borderWidth=0;
//        self.layer.borderColor=[UIColor clearColor].CGColor;
//    }
    // Configure the view for the selected state
}
@end
