//
//  DLSelectDigitalView.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/5.
//

#import "DLSelectDigitalView.h"
#import "DLSelectDigitalViewController.h"

@interface DLSelectDigitalView ()<JXPagerViewDelegate,JXPagerMainTableViewGestureDelegate>
//灰色点击背景view
@property(nonatomic,strong)UIView * grayTapView;
//背景view
@property(nonatomic,strong)UIView * backView;
//标题
@property(nonatomic,strong)UILabel * titleLabel;
//关闭按钮
@property(nonatomic,strong)UIButton *closeBtn;
//分类详情
@property (nonatomic, strong) JXPagerView *pagerView;
//分类标题
@property (nonatomic, strong) JXCategoryTitleView *categoryView;
//确认
@property(nonatomic,strong)UIButton *startBtn;

@end
@implementation DLSelectDigitalView
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
       

        [self loadSubView];
    
 
    }
    return self;
}
-(void)loadSubView
{
    self.selectDigitalModel=[[DLSelectDigitalModel alloc] init];
    //灰色点击背景view
    [self addSubview:self.grayTapView];
    //背景view
    [self addSubview:self.backView];
    //标题
    [self.backView addSubview:self.titleLabel];
    
    //关闭按钮
    [self.backView addSubview:self.closeBtn];
    
    //    //滑动分页
    [self.backView addSubview:self.pagerView];
    self.categoryView.listContainer = (id<JXCategoryViewListContainer>)self.pagerView.listContainerView;
    
    [self.backView addSubview:self.startBtn];

//    self.pagerView.mainTableView.mj_header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
////        NSInteger index= weakSelf.pagerView.listContainerView.currentIndex;
////        [weakSelf toReloadListVC:index :YES];
//    }];

//

  
    
    //点击隐藏界面
    UITapGestureRecognizer * tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toHiddenView)];
    [self.grayTapView addGestureRecognizer:tap];

}
-(void)toLoadData
{
    NSInteger index= self.pagerView.listContainerView.currentIndex;
    DLSelectDigitalViewController *listVC = (DLSelectDigitalViewController*)self.pagerView.listContainerView.validListDict[@(index)];
    [listVC toLoadData];
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/
#pragma mark --------------------灰色背景view-----------------------
-(UIView *) grayTapView
{
    if(_grayTapView==nil)
    {
        _grayTapView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)];
        _grayTapView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.6];

    }
    return _grayTapView;
}
#pragma mark --------------------白色背景view-----------------------
-(UIView *) backView
{
    if(_backView==nil)
    {
        _backView = [[UIView alloc] initWithFrame:CGRectMake(0, self.frame.size.height-577, self.frame.size.width, 577)];
        _backView.backgroundColor = [UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        _backView.clipsToBounds=YES;
        _backView.layer.cornerRadius=12;
//        [GlobalFunc cutrounded:_whiteBackView :UIRectCornerTopLeft|UIRectCornerTopRight :CGSizeMake(12, 12)];

    }
    return _backView;
}
#pragma mark --------------------标题-已导入播放列表-----------------------
-(UILabel*)titleLabel
{
    if(_titleLabel==nil)
    {
        _titleLabel=[[UILabel alloc] initWithFrame:CGRectMake(20, 0, 100, 44)];
        _titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        _titleLabel.textColor=[UIColor whiteColor];
        _titleLabel.backgroundColor=[UIColor clearColor];
        _titleLabel.textAlignment=NSTextAlignmentLeft;
        _titleLabel.text=@"请选择数字人";
    }
    return _titleLabel;
   
}
#pragma mark --------------------关闭按钮-----------------------
-(UIButton*)closeBtn
{
   if(_closeBtn==nil)
   {
       //关闭按钮
       UIImage *closeImage=[UIImage imageNamed:@"dl_select_close"];
      _closeBtn=[UIButton buttonWithType:UIButtonTypeCustom];
       _closeBtn.frame=CGRectMake(self.frame.size.width-44, 0, 44, 44);
       [_closeBtn setImage:closeImage forState:UIControlStateNormal];
       _closeBtn.backgroundColor=[UIColor clearColor];
       [_closeBtn addTarget:self action:@selector(toHiddenView) forControlEvents:UIControlEventTouchDown];
   }
   return _closeBtn;
}
-(void)toHiddenView
{
    self.hidden=YES;
}
#pragma mark-----------------JXPagerSmoothView-----------------------
-(JXPagerView*)pagerView
{
    if(_pagerView==nil)
    {
        _pagerView = [[JXPagerView alloc] initWithDelegate:self];
        _pagerView.backgroundColor=[UIColor clearColor];
        _pagerView.frame =CGRectMake(0, CGRectGetMaxY(self.titleLabel.frame), self.backView.frame.size.width, self.backView.frame.size.height - 15 -84-CGRectGetMaxY(self.titleLabel.frame));
        _pagerView.mainTableView.gestureDelegate = self;
        _pagerView.mainTableView.backgroundColor=[UIColor clearColor];
        _pagerView.listContainerView.backgroundColor=[UIColor clearColor];
        _pagerView.backgroundColor=[UIColor clearColor];
        _pagerView.listContainerView.listCellBackgroundColor=[UIColor clearColor];
//        _pagerView.pinSectionHeaderVerticalOffset=self.headerView.height;
    
    }
    return _pagerView;
}
#pragma mark-----------------JXCategoryTitleView-----------------------
-(JXCategoryTitleView*)categoryView
{
    if(_categoryView==nil)
    {
        _categoryView = [[JXCategoryTitleView alloc] initWithFrame:CGRectMake(0, 0, self.backView.frame.size.width, 30)];
        _categoryView.titles = @[@"推荐", @"我的"];
        _categoryView.backgroundColor = [UIColor clearColor];
        _categoryView.titleSelectedColor = [UIColor whiteColor];
        _categoryView.titleColor = [UIColor colorWithHexString:@"#FFFFFF" alpha:0.5];
        _categoryView.titleFont=[UIFont fontWithName:@"PingFangSC-Medium" size:11];
        _categoryView.titleColorGradientEnabled = YES;
        _categoryView.titleLabelZoomEnabled = NO;
        _categoryView.averageCellSpacingEnabled = NO;
        _categoryView.contentEdgeInsetLeft=20;
        _categoryView.cellSpacing=23;
        _categoryView.contentScrollViewClickTransitionAnimationEnabled = NO;
        JXCategoryIndicatorLineView *lineView = [[JXCategoryIndicatorLineView alloc] init];
        lineView.indicatorColor = [UIColor colorWithHexString:@"#444CF0" alpha:1.0];
        lineView.indicatorWidth = 20;
        _categoryView.indicators = @[lineView];
    }
    return _categoryView;
}
#pragma mark - JXPagerViewDelegate

- (UIView *)tableHeaderViewInPagerView:(JXPagerView *)pagerView {
    return [UIView new];
}

- (NSUInteger)tableHeaderViewHeightInPagerView:(JXPagerView *)pagerView {
    return 0;
}


- (UIView *)viewForPinSectionHeaderInPagerView:(JXPagerView *)pagerView {

        return self.categoryView;
 

}
- (NSUInteger)heightForPinSectionHeaderInPagerView:(JXPagerView *)pagerView
{
        return self.categoryView.frame.size.height;

}

- (NSInteger)numberOfListsInPagerView:(JXPagerView *)pagerView {
    //和categoryView的item数量一致

     return self.categoryView.titles.count;


}

- (id<JXPagerViewListViewDelegate>)pagerView:(JXPagerView *)pagerView initListAtIndex:(NSInteger)index {
    DLSelectDigitalViewController *listVC = [[DLSelectDigitalViewController alloc] init];
//    listVC.delegate=self;
    listVC.viewIndex=index;
    MJWeakSelf
    listVC.selectDitalBlock = ^(DLSelectDigitalModel * _Nonnull selectDigitalModel) {
        weakSelf.selectDigitalModel=selectDigitalModel;
        [ConfigManager manager].selectDigitalModel=selectDigitalModel;
    };
//    listVC.title = self.categoryView.titles[index];
    return listVC;
}

#pragma mark - JXCategoryViewDelegate

- (void)categoryView:(JXCategoryBaseView *)categoryView didSelectedItemAtIndex:(NSInteger)index {

}

#pragma mark - JXPagerMainTableViewGestureDelegate

- (BOOL)mainTableViewGestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer {
    //禁止categoryView左右滑动的时候，上下和左右都可以滚动
    if (otherGestureRecognizer == self.categoryView.collectionView.panGestureRecognizer) {
        return NO;
    }
    return [gestureRecognizer isKindOfClass:[UIPanGestureRecognizer class]] && [otherGestureRecognizer isKindOfClass:[UIPanGestureRecognizer class]];
}

#pragma mark-------------确认---------------------
-(UIButton*)startBtn
{
    if (nil == _startBtn) {
        _startBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _startBtn.frame=CGRectMake(20, CGRectGetMaxY(self.pagerView.frame)+20, self.frame.size.width-40, 44);
        [_startBtn setTitle:@"确认" forState:UIControlStateNormal];
        [_startBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _startBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:12];
        _startBtn.backgroundColor=[UIColor colorWithHexString:@"#0082FF" alpha:1.0];
        _startBtn.layer.cornerRadius=4;
        _startBtn.layer.masksToBounds=YES;
        [_startBtn addTarget:self action:@selector(toClickStart) forControlEvents:UIControlEventTouchDown];
    }
    return _startBtn;
}
-(void)toClickStart
{
    if(self.selectDigitalModel.pid==0)
    {
        [GlobalFunc showLoadText:@"请选择数字人" :self];
        return;
    }
    if(self.selectDigitalBlock)
    {
        self.selectDigitalBlock(0, self.selectDigitalModel);
    }
}
@end
