//
//  DLTTSAnchCell.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/10.
//

#import "DLTTSAnchCell.h"
@interface DLTTSAnchCell()
//配音头像
@property(nonatomic,strong)UIImageView* imageView;
//名字
@property(nonatomic,strong)UILabel * nameLabel;
//下划线
@property(nonatomic,strong)UILabel * lineLabel;
@end
@implementation DLTTSAnchCell
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
        [self loadSubView];

    }
    return self;
}

-(void)loadSubView
{
  
    self.anchModel=[[AnchDubModel alloc] init];
    
    [self addSubview:self.imageView];


    [self addSubview:self.nameLabel];

    [self addSubview:self.lineLabel];
}
-(void)layoutSubviews
{
    [super layoutSubviews];
    
    self.imageView.frame=CGRectMake(14, 10, 18, 18);
    self.nameLabel.frame=CGRectMake(CGRectGetMaxX(self.imageView.frame)+16, 0, 200, self.height);
    self.lineLabel.frame=CGRectMake(13, self.height-0.5, self.width-28, 0.5);
}
#pragma mark-------------配音头像-----------------
-(UIImageView*)imageView
{
    if(nil==_imageView)
    {
        _imageView=[[UIImageView alloc] init];
        _imageView.layer.cornerRadius=9;
        _imageView.clipsToBounds=YES;
        _imageView.userInteractionEnabled=YES;
        _imageView.backgroundColor=[UIColor clearColor];

        
    }
    return _imageView;
}

#pragma mark ------------------名字-------------------------
-(UILabel*)nameLabel
{
    if(_nameLabel==nil)
    {
        _nameLabel=[[UILabel alloc] init];
        _nameLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size:12];
        _nameLabel.textColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0];
        _nameLabel.backgroundColor=[UIColor clearColor];
        _nameLabel.textAlignment=NSTextAlignmentLeft;
        _nameLabel.text=@"苏苏";
//        _nameLabel.text=@"请您跟我描述一下本场直播的商品信息，我会为您丰富商品介绍话术";
    }
    return _nameLabel;
   
}
#pragma mark --------------------下划线-----------------------
-(UILabel*)lineLabel
{
    if(_lineLabel==nil)
    {
        _lineLabel=[[UILabel alloc] init];
        _lineLabel.backgroundColor=[UIColor colorWithHexString:@"#474A69" alpha:1.0];
//        _nameLabel.text=@"请您跟我描述一下本场直播的商品信息，我会为您丰富商品介绍话术";
    }
    return _lineLabel;
   
}
-(void)toSetContent
{
    [self.imageView yy_setImageWithURL:[NSURL URLWithString:self.anchModel.ttsCover?:@""] placeholder:nil];
    self.nameLabel.text=self.anchModel.ttsName?:@"";
}
@end
