//
//  DLTTSAnchView.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/10.
//

#import "DLTTSAnchView.h"
#import "DLTTSAnchCell.h"
@interface DLTTSAnchView()<UICollectionViewDelegate,UICollectionViewDataSource>
@property(nonatomic,strong)UIView * tapView;
@property (nonatomic, strong) UICollectionView *collectionView;
@property (nonatomic, strong) NSMutableArray *arrData;
@end
@implementation DLTTSAnchView
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
        
        [self loadSubView];

    }
    return self;
}

-(void)loadSubView
{
    self.arrData=[[NSMutableArray alloc] init];
    //灰色背景view
    [self addSubview:self.tapView];
    
    [self addSubview:self.collectionView];
    //点击隐藏界面
    UITapGestureRecognizer * tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toHiddenView)];
    [self.tapView addGestureRecognizer:tap];
    
    [self toLoadData];

}
-(void)toLoadData
{
    MJWeakSelf
    [ConfigManager toRequestTtsList:1 size:100 block:^(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData) {
        if(isSuccess)
        {
            weakSelf.arrData=[NSMutableArray arrayWithArray:listData];
            [weakSelf.collectionView reloadData];
            if(weakSelf.arrData.count>0)
            {
                AnchDubModel*anchModel=    weakSelf.arrData[0];
                if(weakSelf.selectBlock)
                {
                    weakSelf.selectBlock(anchModel);
                }
            }
         
        }
    }];
}
-(void)layoutSubviews
{
    [super layoutSubviews];
    self.tapView.frame=CGRectMake(0, 0, ViewWidth, ViewHeight);
    self.collectionView.frame=CGRectMake(85, 320+kStatusBarHeight, self.width-85-20, 185);

}
-(UIView*)tapView
{
    if(nil==_tapView)
    {
        _tapView=[[UIView alloc] init];
        _tapView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.5];

//        _tapView.hidden=YES;
    }
    return _tapView;
}

-(UICollectionView*)collectionView
{
    if(nil==_collectionView)
    {
        
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        [flowLayout setScrollDirection:UICollectionViewScrollDirectionVertical];
        _collectionView=[[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:flowLayout];
        _collectionView.delegate=self;
        _collectionView.dataSource=self;
        _collectionView.backgroundColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        _collectionView.scrollEnabled=YES;
        _collectionView.layer.cornerRadius=6;
        _collectionView.showsHorizontalScrollIndicator = NO;
        _collectionView.showsVerticalScrollIndicator= NO;
        
 
//        MJWeakSelf;
//        [[[[MJRefreshBackNormalFooter footerWithRefreshingBlock:^{
//            weakSelf.page ++;
//            [weakSelf requestListData:self.size];
//        }] setAnimationDisabled]
//          autoChangeTransparency:NO]
//         linkTo:_collectionView];
        
    }
    return _collectionView;
}
#pragma mark - UICollectionViewDataSource, UICollectionViewDelegateFlowLayout

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {

        
    return self.arrData.count;

}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {


        static NSString *identifier = @"DLTTSAnchCell";
        [self.collectionView registerClass:[DLTTSAnchCell class] forCellWithReuseIdentifier:identifier];
        DLTTSAnchCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
        AnchDubModel *anchModel=self.arrData[indexPath.item];
//       cell.delegate=self;
        cell.anchModel=anchModel;
        [cell toSetContent];

         return cell;
  
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    
   
    
    //    PhotoTypeObject *_phototype=self.listArray[indexPath.row];
    //    int width=[GlobalFunc getWidthWithTitle:_phototype.name font: [UIFont systemFontOfSize:12 * [Model sharedInstance].scaleWidth]];
    
    
    return CGSizeMake(floor((self.collectionView.width)), floor(38));
}
//
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    
    return UIEdgeInsetsMake(0, 0, 0, 0);
    
}
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section
{
    return 0;
}

//---------------------------------------------------------------------------
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    
    return 0;
}

//---------------------------------------------------------------------------
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
 if(self.arrData.count>indexPath.item)
 {
     AnchDubModel*anchModel=    self.arrData[indexPath.item];
     [self toHiddenView];
     if(self.selectBlock)
     {
         self.selectBlock(anchModel);
     }
 }

    
    
}
-(void)toHiddenView
{
    self.hidden=YES;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
