//
//  DLTTSTextView.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/10.
//

#import "DLTTSTextView.h"
#import "NSString+LYAttributedString.h"
#import "DLTTSAnchView.h"

@interface DLTTSTextView()<UITextFieldDelegate,UITextViewDelegate>
@property(nonatomic,strong)UIView * tapView;

@property(nonatomic,strong)UIView * bottomBackView;
//标题
@property(nonatomic,strong)UILabel * titleLabel;
//关闭按钮
@property(nonatomic,strong)UIButton *closeBtn;
//选择音色
@property(nonatomic,strong)UIView * anchBackView;
//选择音色文字
@property(nonatomic,strong)UILabel * anchLabel;

//选择音色头像
@property(nonatomic,strong)UIImageView * anchCoverImageView;

//选择音色名称
@property(nonatomic,strong)UILabel * anchNameLabel;

//选择音色向下
@property(nonatomic,strong)UIImageView * anchArrowImageView;

//文本内容 共48字
@property(nonatomic,strong)UILabel * content_num_label;

//文本内容
@property(nonatomic,strong)UITextView* promptTextView;
//本文根据换行符自动切分话术，最多切分200段，每段内容不超过300字
@property(nonatomic,strong)UILabel * detailLabel;
//取消
@property(nonatomic,strong)UIButton *cancelBtn;
//确认
@property(nonatomic,strong)UIButton *startBtn;
//音色TTS界面
@property(nonatomic,strong)DLTTSAnchView * ttsView;
@property(nonatomic,strong)AnchDubModel* anchDubModel;
@end
@implementation DLTTSTextView
-(id)initWithFrame:(CGRect)frame
{
    self=[super initWithFrame:frame];
    if(self)
    {
       
        [self loadSubView];
    }
    return self;
}
-(void)loadSubView
{
    self.anchDubModel=[[AnchDubModel alloc] init];
    //灰色背景view
    [self addSubview:self.tapView];
    
    //白色背景view
    [self addSubview:self.bottomBackView];
    //标题
    [self.bottomBackView addSubview:self.titleLabel];
    //关闭按钮
    [self.bottomBackView addSubview:self.closeBtn];
    //选择音色
    [self.bottomBackView addSubview:self.anchBackView];
    //选择音色文字
    [self.anchBackView  addSubview:self.anchLabel];
    //选择音色头像
    [self.anchBackView  addSubview:self.anchCoverImageView];
    
    //选择音色名称
    [self.anchBackView  addSubview:self.anchNameLabel];
    //选择音色向下
    [self.anchBackView  addSubview:self.anchArrowImageView];
    //文本内容 共48字
    [self.bottomBackView addSubview:self.content_num_label];
    
    //文本内容
    [self.bottomBackView addSubview:self.promptTextView];
    //本文根据换行符自动切分话术，最多切分200段，每段内容不超过300字
    [self.bottomBackView addSubview:self.detailLabel];
    //取消
    [self.bottomBackView addSubview:self.cancelBtn];
    //确认
    [self.bottomBackView addSubview:self.startBtn];
    
    //音色TTS界面
    [self addSubview:self.ttsView];
    
    UITapGestureRecognizer * anch_tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toClickselectTextField)];
    [self.anchBackView addGestureRecognizer:anch_tap];
    //点击隐藏界面
    UITapGestureRecognizer * tap=[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toHiddenView)];
    [self.tapView addGestureRecognizer:tap];
}
-(void)layoutSubviews
{
    [super layoutSubviews];

    self.tapView.frame=CGRectMake(0, 0, self.width, self.height);
    self.bottomBackView.frame=CGRectMake(0, self.height-561-[GlobalFunc getSafeBottom], self.width, 561+[GlobalFunc getSafeBottom]);
    self.titleLabel.frame=CGRectMake(20, 18, 98, 18);
    self.closeBtn.frame=CGRectMake(self.bottomBackView.width-12-44+(44- self.closeBtn.imageView.image.size.width)/2, 16-(44-self.closeBtn.imageView.image.size.height)/2, 44, 44);
    self.anchBackView.frame=CGRectMake(20, CGRectGetMaxY(self.titleLabel.frame)+22, self.bottomBackView.width-40, 44);
    self.anchLabel.frame=CGRectMake(12, 0, 60, 44);
    self.anchCoverImageView.frame=CGRectMake(CGRectGetMaxX(self.anchLabel.frame), 16, 12, 12);
    self.anchNameLabel.frame=CGRectMake(CGRectGetMaxX(self.anchCoverImageView.frame)+2, 0, 150, 44);
    self.anchArrowImageView.frame=CGRectMake(self.anchBackView.width-16-12, 14, 16, 16);
    //选择音色向下
    [self.anchBackView  addSubview:self.anchArrowImageView];
    self.content_num_label.frame=CGRectMake(20, CGRectGetMaxY(self.anchBackView.frame)+17, self.bottomBackView.width-84, 17);
    self.promptTextView.frame=CGRectMake(20, CGRectGetMaxY(self.content_num_label.frame)+16, self.bottomBackView.width-40, 286);
    self.detailLabel.frame=CGRectMake(20, CGRectGetMaxY(self.promptTextView.frame)+8, self.bottomBackView.width-40, 49);
    self.cancelBtn.frame=CGRectMake(20, CGRectGetMaxY(self.detailLabel.frame)+19, floor(self.bottomBackView.width-50)/2, 44);
    self.startBtn.frame=CGRectMake(CGRectGetMaxX(self.cancelBtn.frame)+10, CGRectGetMaxY(self.detailLabel.frame)+19, floor(self.bottomBackView.width-50)/2, 44);
    self.ttsView.frame=CGRectMake(0, 0, ViewWidth, ViewHeight);
}
-(UIView*)tapView
{
    if(nil==_tapView)
    {
        _tapView=[[UIView alloc] init];
        _tapView.backgroundColor = [UIColor colorWithHexString:@"#000000" alpha:0.5];
//        _tapView.hidden=YES;
    }
    return _tapView;
}

-(UIView*)bottomBackView
{
    if(nil==_bottomBackView)
    {
        _bottomBackView=[[UIView alloc] init];
        _bottomBackView.backgroundColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        _bottomBackView.layer.cornerRadius=12;
    }
    return _bottomBackView;
}
#pragma mark --------------------标题-已导入播放列表-----------------------
-(UILabel*)titleLabel
{
    if(_titleLabel==nil)
    {
        _titleLabel=[[UILabel alloc] init];
        _titleLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:14];
        _titleLabel.textColor=[UIColor whiteColor];
        _titleLabel.backgroundColor=[UIColor clearColor];
        _titleLabel.textAlignment=NSTextAlignmentLeft;
        _titleLabel.text=@"请输入文本话术";
    }
    return _titleLabel;
   
}
#pragma mark --------------------关闭按钮-----------------------
-(UIButton*)closeBtn
{
   if(_closeBtn==nil)
   {
       //关闭按钮
       UIImage *closeImage=[UIImage imageNamed:@"dl_live_pl_close"];
      _closeBtn=[UIButton buttonWithType:UIButtonTypeCustom];

       [_closeBtn setImage:closeImage forState:UIControlStateNormal];
       _closeBtn.backgroundColor=[UIColor clearColor];
       [_closeBtn addTarget:self action:@selector(toHiddenView) forControlEvents:UIControlEventTouchDown];
   }
   return _closeBtn;
}
#pragma mark-------------选择音色背景----------------
-(UIView*)anchBackView
{
    if(_anchBackView==nil)
    {
        _anchBackView=[[UIView alloc] init];
        _anchBackView.layer.cornerRadius=6;
        _anchBackView.layer.masksToBounds=YES;
        _anchBackView.backgroundColor=[UIColor colorWithHexString:@"#1D1F32" alpha:1.0];
        
    }
    return _anchBackView;
}
#pragma mark --------------------选择音色文字-----------------------
-(UILabel*)anchLabel
{
    if(_anchLabel==nil)
    {
        _anchLabel=[[UILabel alloc] init];
        _anchLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size: 12];
        _anchLabel.textColor=[UIColor whiteColor];
        _anchLabel.backgroundColor=[UIColor clearColor];
        _anchLabel.textAlignment=NSTextAlignmentLeft;
        _anchLabel.text=@"选择音色";
    }
    return _anchLabel;
   
}
#pragma mark --------------------选择音色头像-----------------------
-(UIImageView*)anchCoverImageView
{
   if(_anchCoverImageView==nil)
   {

       _anchCoverImageView=[[UIImageView alloc] init];
       _anchCoverImageView.layer.cornerRadius=6;
       _anchCoverImageView.clipsToBounds=YES;
       _anchCoverImageView.userInteractionEnabled=YES;
   }
   return _anchCoverImageView;
}
#pragma mark --------------------选择音色文字-----------------------
-(UILabel*)anchNameLabel
{
    if(_anchNameLabel==nil)
    {
        _anchNameLabel=[[UILabel alloc] init];
        _anchNameLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size: 12];
        _anchNameLabel.textColor=[UIColor whiteColor];
        _anchNameLabel.backgroundColor=[UIColor clearColor];
        _anchNameLabel.textAlignment=NSTextAlignmentLeft;
    }
    return _anchNameLabel;
   
}
#pragma mark --------------------选择音色头像-----------------------
-(UIImageView*)anchArrowImageView
{
   if(_anchArrowImageView==nil)
   {

       _anchArrowImageView=[[UIImageView alloc] init];
       _anchArrowImageView.image=[UIImage imageNamed:@"dl_arrow_bottom"];
       _anchArrowImageView.userInteractionEnabled=YES;
   }
   return _anchArrowImageView;
}

#pragma mark --------------------文本内容 共48字-----------------------
-(UILabel*)content_num_label
{
    if(_content_num_label==nil)
    {
        _content_num_label=[[UILabel alloc] init];
        _titleLabel.font=[UIFont fontWithName:@"PingFangSC-Semibold" size:12];
        _content_num_label.textColor=[UIColor colorWithHexString:@"#CCCCCC" alpha:0.5];
        _content_num_label.backgroundColor=[UIColor clearColor];
        _content_num_label.textAlignment=NSTextAlignmentLeft;
        _content_num_label.attributedText= [self toGetTextAttributedText:0];;
       
    }
    return _content_num_label;
   
}
#pragma mark-------------文本内容----------------
-(UITextView*)promptTextView
{
    if(_promptTextView==nil)
    {
        NSString* place_str=@"请输入文本内容";
        _promptTextView=[[UITextView alloc] init];
        _promptTextView.attributedPlaceholder=[place_str attributeFont:[UIFont fontWithName:@"PingFangSC-Regular" size:10] color:[UIColor colorWithHexString:@"#FFFFFF" alpha:0.4] subText:place_str];
        _promptTextView.font=[UIFont fontWithName:@"PingFangSC-Regular" size:10];
        _promptTextView.textColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0];
        _promptTextView.delegate=self;
        _promptTextView.textAlignment=NSTextAlignmentLeft;
        _promptTextView.layer.cornerRadius=6;
        _promptTextView.layer.masksToBounds=YES;
        _promptTextView.backgroundColor=[UIColor colorWithHexString:@"#1D1F32" alpha:1.0];
        _promptTextView.textContainerInset = UIEdgeInsetsMake(17, 12, 0, 12);
        _promptTextView.contentInset= UIEdgeInsetsMake(0, 0, 17, 0);
        

    }
    return _promptTextView;
}
#pragma mark --------------------本文根据换行符自动切分话术，最多切分200段，每段内容不超过300字-----------------------
-(UILabel*)detailLabel
{
    if(_detailLabel==nil)
    {
        _detailLabel=[[UILabel alloc] init];
        _detailLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:11];
        _detailLabel.textColor=[UIColor colorWithHexString:@"#FFFFFF" alpha:0.5];
        _detailLabel.backgroundColor=[UIColor clearColor];
        _detailLabel.textAlignment=NSTextAlignmentLeft;
        _detailLabel.numberOfLines=0;
    
        NSMutableAttributedString *attributedString = [[NSMutableAttributedString alloc] initWithString:@"本文根据换行符自动切分话术，最多切分200段，每段内容不超过300字"attributes: @{NSFontAttributeName: [UIFont fontWithName:@"PingFangSC-Medium" size: 11],NSForegroundColorAttributeName: [UIColor colorWithHexString:@"#FFFFFF" alpha:0.5]}];
          long number = 1.5;
          CFNumberRef num = CFNumberCreate(kCFAllocatorDefault,kCFNumberSInt8Type,&number);
          [attributedString addAttribute:NSKernAttributeName value:(__bridge id)num range:NSMakeRange(0,[attributedString length])];
        _detailLabel.attributedText=attributedString;

    }
    return _detailLabel;
   
}
#pragma mark-------------取消---------------------
-(UIButton*)cancelBtn
{
    if (nil == _cancelBtn) {
        _cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_cancelBtn setTitle:@"取消" forState:UIControlStateNormal];
        [_cancelBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _cancelBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size: 14];
        _cancelBtn.backgroundColor=[UIColor clearColor];
        _cancelBtn.layer.cornerRadius=4;
        _cancelBtn.layer.masksToBounds=YES;
        _cancelBtn.layer.borderWidth=1;
        _cancelBtn.layer.borderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0].CGColor;
        [_cancelBtn addTarget:self action:@selector(toClickCancel) forControlEvents:UIControlEventTouchDown];
    }
    return _cancelBtn;
}
#pragma mark-------------确认---------------------
-(UIButton*)startBtn
{
    if (nil == _startBtn) {
        _startBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_startBtn setTitle:@"确认" forState:UIControlStateNormal];
        [_startBtn setTitleColor:[UIColor colorWithHexString:@"#FFFFFF" alpha:1.0] forState:UIControlStateNormal];
        _startBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size: 14];
        _startBtn.backgroundColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        _startBtn.layer.cornerRadius=4;
        _startBtn.layer.masksToBounds=YES;
        [_startBtn addTarget:self action:@selector(toClickStart) forControlEvents:UIControlEventTouchDown];
    }
    return _startBtn;
}

#pragma mark-------------音色TTS界面---------------------
-(DLTTSAnchView*)ttsView
{
    if(nil==_ttsView)
    {
        _ttsView=[[DLTTSAnchView alloc] initWithFrame:CGRectMake(0, 0, ViewWidth, ViewHeight)];
        _ttsView.hidden=YES;
        MJWeakSelf
        _ttsView.selectBlock = ^(AnchDubModel *anchModel) {
            weakSelf.anchDubModel=anchModel;
            weakSelf.anchNameLabel.text=anchModel.ttsName;
            [weakSelf.anchCoverImageView yy_setImageWithURL:[NSURL URLWithString:anchModel.ttsCover] placeholder:nil];
        };
//        _ttsView.backgroundColor=[UIColor clearColor];
    }
    return _ttsView;
}
#pragma mark-------------点击取消---------------------
-(void)toClickCancel
{
    [self toHiddenView];
}
#pragma mark-------------点击确认---------------------
-(void)toClickStart
{
    MJWeakSelf
    [GlobalFunc showHud];
    NSString* text=self.promptTextView.text?:@"";
    NSDictionary * dict=@{
                @"engineTypeCode": @(10),
                @"upload": @(0),
                 @"customTTSReq":@{@"text":text,@"eightK":[NSNumber numberWithBool:NO],@"f0upKey":@(self.anchDubModel.anchorF0upKey),@"neuralEngine": [NSNumber numberWithBool:NO],@"pitch":@(self.anchDubModel.intonation), @"samplerate": @(16000),@"speedRate":@(self.anchDubModel.speed),@"volume":@(self.anchDubModel.volume),@"ttsSpeaker":self.anchDubModel.ttsSpeaker}
    };//@{@"indeptTTSReq":};
    NSLog(@"dict:%@",dict);
  //  [dict setValue:[NSNumber numberWithInteger:self.viewPage]forKey:@"viewIndex"];
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,SYNCWAV_CHANGEVOICE];
    [ConfigManager toConfigInfo:dict url:url httpMethod:HttpMethodPost block:^(BOOL isSuccess, NSString *msg, id responseObject) {

        if(isSuccess)
        {
            id data=responseObject[@"data"];
           if([data isKindOfClass:[NSDictionary class]])
           {
               NSString * url=[GlobalFunc changeType:data[@"filePath"]];
               
               [weakSelf toDownLoadAudio:url text:text];
//               NSArray * urls=[NSArray arrayWithObjects:[NSURL URLWithString:url], nil];
//               if(self.selectTtsBlock)
//               {
//                   self.selectTtsBlock(url,text);
//               }
//               [GlobalFunc hideHud];
//               [weakSelf toHiddenView];
//               [weakSelf toPlayAudio:url];
           
           }
           else
           {
               [GlobalFunc hideHud];
           }
        }
        else
        {
            [GlobalFunc hideHud];
            [GlobalFunc showLoadText:@"试听失败,请重试" :weakSelf];
       
        }
    }];
}
-(void)toDownLoadAudio:(NSString*)url text:(NSString*)text
{
    MJWeakSelf
    [ConfigManager downloadWithUrlString:url progress:^(NSProgress *progress) {
        
    } success:^(NSURLResponse *response, NSURL *filePath) {
        NSLog(@"filePath:%@",filePath);
        NSString * utl_str=filePath.absoluteString;
        if(self.selectTtsBlock)
        {
            self.selectTtsBlock(utl_str,text);
        }
        [GlobalFunc hideHud];
        [weakSelf toHiddenView];
    } fail:^(NSError *error) {
        [GlobalFunc hideHud];
    }];
}
-(void)toClickselectTextField
{
    self.ttsView.hidden=NO;
}

- (NSMutableAttributedString*)createTextImage:(NSString*)text witImage:(NSString*)imageName withSubContent:(NSString*)subContent
{

    NSMutableAttributedString *scaleStr=  [[NSMutableAttributedString alloc] initWithString:text attributes:@{NSForegroundColorAttributeName:[UIColor whiteColor], NSFontAttributeName: [UIFont fontWithName:@"PingFangSC-Regular" size: 12]}];
    NSRange textRange=NSMakeRange(0, subContent.length-1);
    [scaleStr addAttribute:NSForegroundColorAttributeName value:[UIColor colorWithHexString:@"#FFFFFF" alpha:0.8] range:textRange];
   //添加图片
    NSTextAttachment *textAttachment = [[NSTextAttachment alloc] init];
    textAttachment.bounds = CGRectMake(0, -5, 16, 16); //根据图片位置进行调整
    textAttachment.image = [UIImage imageNamed:imageName];
    
    NSAttributedString *attributedImage = [NSAttributedString attributedStringWithAttachment:(NSTextAttachment *)(textAttachment)];
//   //图片插入到文字后方
  //  [scaleStr appendAttributedString:attributedImage];
   //如果要插入到前面
    [scaleStr insertAttributedString:attributedImage atIndex:subContent.length];


    return scaleStr;
}

-(void)toHiddenView
{
    [self removeFromSuperview];
}
-(void)textViewDidChange:(UITextView *)textView {
 

    NSLog(@"编辑即将结束DidChange-----%lu",(unsigned long)textView.text.length);
    if (textView.text.length > 0) {
        //_playscriptTextView.placeholderLabel.hidden = YES;

        _content_num_label.attributedText= [self toGetTextAttributedText:textView.text.length];
    } else {
        //_playscriptTextView.placeholderLabel.hidden = NO;
    
    }
}
-(NSMutableAttributedString*)toGetTextAttributedText:(NSInteger)length
{
    NSString *subText= @"文本内容";
    NSString * text_str=[NSString stringWithFormat:@"%@ 共%ld字",subText,length];
    NSMutableAttributedString *scaleStr=  [[NSMutableAttributedString alloc] initWithString:text_str attributes:@{NSForegroundColorAttributeName:[UIColor colorWithHexString:@"#CCCCCC" alpha:0.5], NSFontAttributeName: [UIFont fontWithName:@"PingFangSC-Semibold" size: 12]}];
    NSRange textRange=NSMakeRange(0, subText.length);
    [scaleStr addAttribute:NSForegroundColorAttributeName value:[UIColor colorWithHexString:@"#FFFFFF" alpha:0.8] range:textRange];
    return scaleStr;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
