//
//  HttpClient.m
//  Xici
//
//  Created by XICI-Jacob on 10/31/13.
//
//

#import "HttpClient.h"
#import "OpenUDID.h"
#import <zlib.h>
//#import "GYLoginViewController.h"
static HttpClient *_sharedMangaer=nil;

@implementation HttpClient


+(HttpClient *)manager
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        if (!_sharedMangaer) {
            _sharedMangaer=[[HttpClient alloc]init];
        }
    });
    
    return _sharedMangaer;
}

- (id)init
{
    self = [super init];
    if(self)
    {
    }
    return self;
}
-(void)requestWithBaseURL:(NSString *)url
      para:(NSDictionary *)parameters
     headers:(NSDictionary *)headers
    httpMethod:(HttpMethod)httpMethod
    success:(void (^)( id responseObject))success
    failure:(void (^)(NSURLSessionDataTask * task,NSError *error))failure
{

    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    //申明请求的数据是json类型
    manager.requestSerializer=[AFJSONRequestSerializer serializer];
    [manager.requestSerializer willChangeValueForKey:@"timeoutInterval"];
    manager.requestSerializer.timeoutInterval=60;
    [manager.requestSerializer didChangeValueForKey:@"timeoutInterval"];
    NSString *app_Version = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    NSString * skipVersion=[[NSUserDefaults standardUserDefaults] valueForKey:@"skipVersion"];
    NSString * token=   [ConfigManager manager].token?:@"";
    headers=@{@"deviceType":@"1",@"deviceID":[OpenUDID value],@"token":token,@"version":app_Version,@"skipVersion":skipVersion?:@"0",@"source": @"sdk"};
    NSLog(@"headers:%@",headers);
    NSLog(@"OpenUDID==%@",[OpenUDID value]);
    
    NSLog(@"发送token==%@",token);
    //申明返回的结果是json类型
//    manager.responseSerializer = [AFJSONResponseSerializer serializer];
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"application/json",@"text/json", @"text/plain", @"text/html",@"image/jpg", nil];
    if (httpMethod==HttpMethodPost)
    {
    
        [manager POST:url parameters:parameters headers:headers progress:^(NSProgress * _Nonnull uploadProgress)
         { 

        
         } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
             
             
             
             success(responseObject);
             
//             [self loginback:responseObject];
         } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
             failure(task,error);
         }];
 

     
    }else if (httpMethod==HttpMethodGet)
    {
 
        [manager GET:url parameters:parameters headers:headers progress:^(NSProgress * _Nonnull downloadProgress) {

        } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
       
                    success(responseObject);
            
//            [self loginback:responseObject];
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
              failure(task,error);
        }];

    }
}


/// 上传图片接口
/// @param url 上传地址
/// @param parameters 入参
/// @param headers 请求头
/// @param imageData 图片data
/// @param fileName 图片的名字
/// @param success 成功回调
/// @param failure 失败回调
- (void)requestImageWithURL:(NSString *)url
                       para:(NSDictionary *)parameters
                    headers:(NSDictionary *)headers
                  imageData:(NSData *)imageData
                   fileName:(NSString *)fileName
                    success:(void (^)( id responseObject))success
                    failure:(void (^)(NSURLSessionDataTask * task,NSError *error))failure {

    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    //申明请求的数据是json类型
    manager.requestSerializer=[AFJSONRequestSerializer serializer];
    manager.responseSerializer = [AFJSONResponseSerializer serializer];
//    [manager.requestSerializer setValue:@"1" forHTTPHeaderField:@"deviceType"];
    [manager.requestSerializer setValue:[OpenUDID value] forHTTPHeaderField:@"deviceID"];
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"application/json",@"text/json", @"text/plain", @"text/html",@"image/jpg",@"image/png",@"image/gif", nil];
//    [manager.requestSerializer setValue:@"multipart/form-data; boundary=32343211" forHTTPHeaderField:@"Content-Type"];


    [manager POST:url parameters:parameters headers:headers constructingBodyWithBlock:^(id<AFMultipartFormData>  _Nonnull formData) {
        [formData appendPartWithFileData:imageData name:@"file" fileName:fileName mimeType:@"image/jpg/png/jpeg/gif/tiff"];
        
    } progress:^(NSProgress * _Nonnull uploadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        success(responseObject);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        failure(task,error);

    }];
}


@end
