//
//  AudioFileManager.m
//  DreamLive
//
//  Created by guiji on 2023/5/24.
//

#import "AudioFileManager.h"
@interface AudioFileManager()<UIDocumentPickerDelegate>
@property (nonatomic, strong) UIDocumentPickerViewController *documentPickerViewController;
@property (nonatomic, copy) void (^openBlock)(NSArray <NSURL *>* urls);
@end
static AudioFileManager *_manager=nil;
@implementation AudioFileManager
+ (AudioFileManager *)manager
{
    static dispatch_once_t once;
    dispatch_once(&once, ^{
        _manager = [[AudioFileManager alloc] init];
    });
    return _manager;
}

-(UIDocumentPickerViewController*)documentPickerViewController
{
    
    NSArray *documentTypes = @[@"public.audio",@"public.wav",@"public.m4a"];
    _documentPickerViewController = [[UIDocumentPickerViewController alloc] initWithDocumentTypes:documentTypes inMode:UIDocumentPickerModeImport];
    _documentPickerViewController.delegate = self;
    _documentPickerViewController.allowsMultipleSelection=YES;
//    _documentPickerViewController.modalPresentationStyle = UIModalPresentationFullScreen;
    if (@available(iOS 11.0, *)) {
        UIScrollView.appearance.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentAutomatic;
    }
    if (@available(iOS 13.0, *)) {
        _documentPickerViewController.shouldShowFileExtensions = YES;
    }
    return _documentPickerViewController;
}
-(void)openFileAndSelectFile:(void (^)(NSArray <NSURL *>* urls))success
{
    self.openBlock=success;
    [[GlobalFunc getCurrentViewController] presentViewController:self.documentPickerViewController animated:YES completion:^{
        
    }];
}
- (void)documentPicker:(UIDocumentPickerViewController *)controller didPickDocumentsAtURLs:(NSArray <NSURL *>*)urls
{
    if(self.openBlock)
    {
        self.openBlock(urls);
    }
//    [self toSaveAudioFile:urls];
}

// called if the user dismisses the document picker without selecting a document (using the Cancel button)
- (void)documentPickerWasCancelled:(UIDocumentPickerViewController *)controller
{
    
}


@end
