//
//  ConfigManager.h
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/11.
//

#import <Foundation/Foundation.h>
#import "AFNetworking.h"
typedef enum HttpMethod{
    HttpMethodGet,
    HttpMethodPost,
}HttpMethod;

@interface ConfigManager : NSObject
+(ConfigManager*)manager;
//用户token
@property(nonatomic,strong)  NSString *token;
//MQTT用户名
@property (nonatomic, strong)NSString*  mqttUser;
//MQTT密钥
@property (nonatomic, strong)NSString*  mqttPassword;
@property(nonatomic,strong)DLSelectDigitalModel* selectDigitalModel;

#pragma mark---------------获取TOKEN---------------------
+(void)toGetToken:(NSString*)appId :(NSString*)appSecret block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block;
#pragma mark---------------获取商城数字人列表--------------------- page 第几页  size 每页多少个
+(void)toGetListMarketPage:(NSInteger)page size:(NSInteger)size type:(NSInteger)type Block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block;
#pragma mark------------判断是否获取Token------------------
+(void)isAppIdLoginBlock:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block;
#pragma mark------------创建直播------------------
+(void)toCreateLiveByLiveName:(NSString*)liveName coverUrl:(NSString*)coverUrl  udCode:(NSString*)udCode robotCode:(NSString*)robotCode robotName:(NSString*)robotName  block:(void (^)(BOOL isSuccess, NSString *msg,NSString * liveId,id responseObject))block;
#pragma mark------------告知后台开启MQTT订阅------------------
+(void)toSubscribeTopic:(NSString*)uuid_str block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block;
#pragma mark------------告知后台取消MQTT订阅------------------
+(void)toUnsubscribeTopic:(NSString*)uuid_str block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block;
#pragma mark------------获取直播列表------------------
+ (void)toRequestListLive:(NSInteger)page size:(NSInteger)size viewIndex:(NSInteger)viewIndex block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block;
#pragma mark------------获取TTS列表------------------
+ (void)toRequestTtsList:(NSInteger)page size:(NSInteger)size block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block;
#pragma mark ----------------------更新直播间信息------------------
+(void)toUpdateLiveAll:(NSString*)liveId coverUrl:(NSString*)coverUrl liveName:(NSString*)liveName udCode:(NSString*)udCode robotCode:(NSString*)robotCode robotName:(NSString*)robotName  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block;
#pragma mark ----------------------更新直播间名称------------------
+(void)toUpdateLiveNameByLiveId:(NSString*)liveId  liveName:(NSString*)liveName  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block;
#pragma mark ----------------------查询场景信息------------------
+(void)toQuerySceneDetailsByCode:(NSString*)sceneCode  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block;
#pragma mark ----------------------创建直播会话ID并检查资源并订阅MQTT------------------
+(void)tocreateLiveSession:(NSString*)liveId name:(NSString*)name  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block;
//通用接口 传参放入object
+ (void)toConfigInfo:(id)object url:(NSString*)url httpMethod:(HttpMethod)httpMethod block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block;
//下载网络音频
+(void)downloadWithUrlString:(NSString *)urlString progress:(void (^)(NSProgress * progress))progress success:(void (^)(NSURLResponse * response, NSURL * filePath))success fail:(void (^)(NSError * error))fail;
@end

