//
//  ConfigManager.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/11.
//

#import "ConfigManager.h"
#import "HttpClient.h"
#import "DLHomeListModel.h"
#import "AnchDubModel.h"
#define GYMSG [NSString stringWithFormat:@"%@",[responseObject valueForKey:@"msg"]]
//网络错误提示语
#define GYNetworkErrorMsg @"网络异常，请稍后尝试"
@interface ConfigManager()
@property(nonatomic,strong)NSString* appId;
@property(nonatomic,strong)NSString* appSecret;
@end

@implementation ConfigManager
+(ConfigManager*)manager
{
    static dispatch_once_t once;
    static ConfigManager *manager;
    dispatch_once(&once, ^{
        manager = [ConfigManager new];
    });
    return manager;
}
#pragma mark----------------获取Token-----------------------
+(void)toGetToken:(NSString*)appId :(NSString*)appSecret block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block
{
    [ConfigManager manager].appId=appId;
    [ConfigManager manager].appSecret=appSecret;
    NSDictionary *dict=@{@"appId":appId?:@"",@"appSecret":appSecret?:@""};
    NSString * url=[NSString stringWithFormat:@"%@%@",BaseUrl,ACCESS_TOKEN];

    NSLog(@"url==%@",url);
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
        NSLog(@"responseObject==%@",responseObject);
        NSDictionary * dic=responseObject;
        NSInteger success=[dic[@"success"]?:@"" integerValue];
        if (success==1)
        {
//            NSString* message=dic[@"message"];
            NSDictionary * data=dic[@"data"];
            if([data isKindOfClass:[NSDictionary class]])
            {
                [ConfigManager manager].token=[GlobalFunc changeType:data[@"token"]];
                [ConfigManager manager].mqttUser=[GlobalFunc changeType:data[@"mqttUser"]];
                [ConfigManager manager].mqttPassword=[GlobalFunc changeType:data[@"mqttPassword"]];
             
                
                NSLog(@"token:%@",  [ConfigManager manager].token);
                block(YES,@"",responseObject);
            }
            else
            {
                block(NO,GYMSG,responseObject);
            }
//            [self toCheckSig:data appId:appId];
         
        }
        else
        {
            block(NO,@"",responseObject);
        }
     
        
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,@{});
    }];
}
#pragma mark---------------获取商城数字人列表--------------------- page 第几页  size 每页多少个 用于分页
+(void)toGetListMarketPage:(NSInteger)page size:(NSInteger)size type:(NSInteger)type Block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block
{
   NSDictionary *dict=@{
       @"groupId": @"",
       @"name": @"",
       @"address": @"no_group_id",
       @"liveType": @(0),
       @"version": @(0),
       @"orderBy":@"",
//       @"isCollect": [NSNumber numberWithBool:YES],
       @"sceneFilter": @{
           @"applicationType": @(2)
       },
       @"sceneFilterFlag": [NSNumber numberWithBool:YES],
       @"page": @(page),
       @"size": @(size)
   };

        
    NSString * url;
    if(type==1)
    {
        url=[NSString stringWithFormat:@"%@%@",BaseUrl,LIST_PRIVATE];
    }
    else
    {
        url=[NSString stringWithFormat:@"%@%@",BaseUrl,LIST_MARKET];
    }
    NSLog(@"url==%@",url);
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
        NSLog(@"responseObject==%@",responseObject);
        NSDictionary * dic=responseObject;
        NSInteger success=[dic[@"success"]?:@"" integerValue];
        if (success==1)
        {
//            NSString* message=dic[@"message"];
            NSDictionary * data=dic[@"data"];
            if([data isKindOfClass:[NSDictionary class]])
            {
                NSString *totalRecord = [NSString stringWithFormat:@"%@",data[@"totalRecord"]];
                NSArray * records=data[@"records"];
                NSArray *listData = [DLSelectDigitalModel mj_objectArrayWithKeyValuesArray:records];
                NSLog(@"listData:%@",listData);
                block(YES,@"",totalRecord.integerValue,listData);
            }
            else
            {
                block(YES,@"",0,@[]);
            }
//            [self toCheckSig:data appId:appId];
         
        }
        else {
            
            block(NO,GYMSG,0,@[]);
        }
     
        
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,0,@[]);
    }];
}

+(void)isAppIdLoginBlock:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block
{
    if(!IS_Agent_EMPTY([ConfigManager manager].token))
    {
        block(YES,@"",@{});
    }
    else
    {
        [ConfigManager toGetToken: [ConfigManager manager].appId?:@"" :[ConfigManager manager].appSecret?:@"" block:^(BOOL isSuccess, NSString *msg, id responseObject) {
            if(isSuccess)
            {
                block(YES,msg,responseObject);
            }
            else
            {
                block(NO,@"",@{});
            }
            
        }];
    }
}
#pragma mark------------告知后台开启MQTT订阅------------------
+(void)toSubscribeTopic:(NSString*)uuid_str block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block
{

    NSLog(@"uuid_str:%@",uuid_str);
    NSString *url = [NSString stringWithFormat:@"%@%@?sessionId=%@",BaseUrl,GETRESOURCE_BYSESSIONID,uuid_str];
    
    NSLog(@"url:%@",url);
    //    MJWeakSelf;
    [[HttpClient manager] requestWithBaseURL:url para:nil headers:nil httpMethod:HttpMethodGet success:^(id responseObject) {
        NSLog(@"responseObject:%@",responseObject);
        NSDictionary * dic=responseObject;
        NSInteger code=[dic[@"code"]?:@"" integerValue];
        NSString *msg=[GlobalFunc changeType:dic[@"msg"]];
        if(code==0 && [msg isEqualToString:@"ok"])
        {
            block(YES,msg,responseObject);
        }
        else
        {
            block(NO,msg,responseObject);
//            [weakSelf toUnsubscribeTopic:uuid_str];
        }
        
        
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
//        [MBProgressHUD hideHUDForView:self.view animated:NO];
        block(NO,GYNetworkErrorMsg,@{});
        NSLog(@"localizedDescription:%@",error.localizedDescription);
    }];
}
#pragma mark------------告知后台取消MQTT订阅------------------
+(void)toUnsubscribeTopic:(NSString*)uuid_str block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block
{
    MJWeakSelf;
    NSLog(@"uuid_str:%@",uuid_str);
    NSString *url = [NSString stringWithFormat:@"%@%@?sessionId=%@",BaseUrl,RELEASERESOURCEBYSESSIONID,uuid_str];
    NSLog(@"url:%@",url);
    //    MJWeakSelf;
    
    [[HttpClient manager] requestWithBaseURL:url para:nil headers:nil httpMethod:HttpMethodGet success:^(id responseObject) {
        NSLog(@"responseObject:%@",responseObject);
        NSDictionary * dic=responseObject;
        NSInteger code=[dic[@"code"]?:@"" integerValue];
        NSString *msg=[GlobalFunc changeType:dic[@"msg"]];
        if(code==0 && [msg isEqualToString:@"ok"])
        {
            block(YES,msg,responseObject);
        }
        else
        {
            block(NO,msg,responseObject);
        }
        
        
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
//        [MBProgressHUD hideHUDForView:self.view animated:NO];
        block(NO,GYNetworkErrorMsg,@{});
        NSLog(@"localizedDescription:%@",error.localizedDescription);
    }];
}

#pragma mark------------获取直播列表------------------
+ (void)toRequestListLive:(NSInteger)page size:(NSInteger)size viewIndex:(NSInteger)viewIndex block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block
{
    
  
    
    NSString *url = [NSString stringWithFormat:@"%@%@?token=%@",BaseUrl,LIST_LIVE,[ConfigManager manager].token];
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    [dict setValue:@(page) forKey:@"page"];
    [dict setValue:@(size) forKey:@"size"];
    [dict setValue:@(0) forKey:@"liveType"];
    NSLog(@"dict:%@",dict);
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
//        if ([GYCODE isEqualToString:@"200"]) {
            NSLog(@"responseObject:%@",responseObject);
            id  data = responseObject[@"data"];
      
            if([data isKindOfClass:[NSDictionary class]])
            {
                NSArray *records = data[@"records"];
                NSString *totalRecord = [NSString stringWithFormat:@"%@",data[@"totalRecord"]];
                NSArray *listData = [DLHomeListModel mj_objectArrayWithKeyValuesArray:records];
                block(YES,@"",totalRecord.integerValue,listData);
            }
            else
            {
                block(YES,@"",0,@[]);
            }
         
        
//        } else if ([GYCODE isEqualToString:@"50004"] || [GYCODE isEqualToString:@"1000005"]) {
//            //token失效 或 过期
////            [DLCheck toJumpLoginVC:GYCODE.integerValue];
//        } else {
//            block(NO,GYMSG,0,@[]);
//        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,0,@[]);
    }];
}
#pragma mark------------获取TTS列表------------------
+ (void)toRequestTtsList:(NSInteger)page size:(NSInteger)size block:(void (^)(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData))block
{

    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,TTSMODEL_LIST];
    NSString *corpId=@"";//[GlobalFunc changeType:[Model sharedInstance].user.corpId];
    NSDictionary *params=@{@"productType":@10002,@"corpId":corpId};
    NSMutableDictionary *dict=[[NSMutableDictionary alloc] init];
    dict=[NSMutableDictionary dictionaryWithDictionary:@{@"pageNum":@1,@"pageSize":@500,@"corpId":corpId,@"productType":@10002,@"params":params,@"includeTtsSource":@[@10],@"isAllocation":@0,@"queryLanguage":@"cn"}];
    NSLog(@"dict:%@",dict);
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
//        if ([GYCODE isEqualToString:@"200"]) {
            NSLog(@"responseObject:%@",responseObject);
            id  data = responseObject[@"data"];
      
            if([data isKindOfClass:[NSDictionary class]])
            {
                NSArray *records = data[@"list"];
                NSString *totalRecord = [NSString stringWithFormat:@"%@",data[@"total"]];
                NSArray *listData = [AnchDubModel mj_objectArrayWithKeyValuesArray:records];
                block(YES,@"",totalRecord.integerValue,listData);
            }
            else
            {
                block(YES,@"",0,@[]);
            }
         
        
//        } else if ([GYCODE isEqualToString:@"50004"] || [GYCODE isEqualToString:@"1000005"]) {
//            //token失效 或 过期
////            [DLCheck toJumpLoginVC:GYCODE.integerValue];
//        } else {
//            block(NO,GYMSG,0,@[]);
//        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,0,@[]);
    }];
}
#pragma mark------------创建直播------------------
+(void)toCreateLiveByLiveName:(NSString*)liveName coverUrl:(NSString*)coverUrl  udCode:(NSString*)udCode robotCode:(NSString*)robotCode robotName:(NSString*)robotName  block:(void (^)(BOOL isSuccess, NSString *msg,NSString * liveId,id responseObject))block
{
    
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,CREATE_UPDATE_LIVE];
    NSDictionary *dict=@{@"liveType":@(0),@"liveName":liveName,@"coverUrl":coverUrl,@"udCode":udCode,@"robotCode":robotCode,@"robotName":robotName};
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
//        if ([GYCODE isEqualToString:@"200"]) {
           NSInteger  success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
           NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
          if(success==1)
          {
              NSString*  liveId=[NSString stringWithFormat:@"%@",[GlobalFunc changeType:responseObject[@"data"]]];

              block(YES,msg,liveId,responseObject);
         }
        else
        {
       
            block(NO,msg,0,responseObject);
        }

    
      
         
        
//        } else if ([GYCODE isEqualToString:@"50004"] || [GYCODE isEqualToString:@"1000005"]) {
//            //token失效 或 过期
////            [DLCheck toJumpLoginVC:GYCODE.integerValue];
//        } else {
//            block(NO,GYMSG,0,@[]);
//        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,0,@{});
    }];
}

#pragma mark ----------------------更新直播间信息------------------
+(void)toUpdateLiveAll:(NSString*)liveId coverUrl:(NSString*)coverUrl liveName:(NSString*)liveName udCode:(NSString*)udCode robotCode:(NSString*)robotCode robotName:(NSString*)robotName  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block
{
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,CREATE_UPDATE_LIVE];
    NSDictionary *dict=@{@"id":liveId,@"liveName":liveName,@"coverUrl":coverUrl,@"udCode":udCode,@"robotCode":robotCode,@"robotName":robotName};

    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
//        if ([GYCODE isEqualToString:@"200"]) {
        NSLog(@"responseObject:%@",responseObject);
           NSInteger  success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
           NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
          if(success==1)
          {


              block(YES,msg,responseObject);
         }
        else
        {
       
            block(NO,msg,responseObject);
        }

    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,@{});
    }];
}
#pragma mark ----------------------更新直播间名称------------------
+(void)toUpdateLiveNameByLiveId:(NSString*)liveId  liveName:(NSString*)liveName  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block
{
    
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,CREATE_UPDATE_LIVE];
    NSDictionary *dict=@{@"id":liveId,@"liveName":liveName};
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
        NSLog(@"responseObject:%@",responseObject);
           NSInteger  success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
           NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
          if(success==1)
          {


              block(YES,msg,responseObject);
         }
        else
        {
       
            block(NO,msg,responseObject);
        }

    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,@{});
    }];
}
#pragma mark ----------------------创建直播会话ID并检查资源并订阅MQTT------------------
+(void)tocreateLiveSession:(NSString*)liveId name:(NSString*)liveName  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block
{
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,CREATELIVESESSION];
    NSDictionary *dict=@{@"liveId":liveId,@"liveName":liveName};
    [[HttpClient manager] requestWithBaseURL:url para:dict headers:nil httpMethod:HttpMethodPost success:^(id responseObject) {
//        if ([GYCODE isEqualToString:@"200"]) {
        NSLog(@"responseObject:%@",responseObject);
           NSInteger  success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
           NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
          if(success==1)
          {

      
              block(YES,msg,responseObject);
         }
        else
        {
       
            block(NO,msg,responseObject);
        }

    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,@{});
    }];
}
#pragma mark ----------------------查询场景信息------------------
+(void)toQuerySceneDetailsByCode:(NSString*)sceneCode  block:(void (^)(BOOL isSuccess, NSString *msg,id responseObject))block
{
    
    NSString *url = [NSString stringWithFormat:@"%@%@",BaseUrl,QUERYSCENCEDETAILSBYCODE];
    NSLog(@"sceneCode:%@",sceneCode);
    NSDictionary *dic=@{@"sceneCode":sceneCode?:@""};
    [[HttpClient manager] requestWithBaseURL:url para:dic headers:nil httpMethod:HttpMethodGet success:^(id responseObject) {
        NSLog(@"responseObject:%@",responseObject);
           NSInteger  success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
           NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
          if(success==1)
          {


              block(YES,msg,responseObject);
         }
        else
        {
       
            block(NO,msg,responseObject);
        }


    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,@{});
    }];
}
#pragma mark ----------------------通用接口 传参放入object------------------
+ (void)toConfigInfo:(id)object url:(NSString*)url httpMethod:(HttpMethod)httpMethod block:(void (^)(BOOL isSuccess, NSString *msg, id responseObject))block
{
    
    [[HttpClient manager] requestWithBaseURL:url para:object headers:nil httpMethod:httpMethod success:^(id responseObject) {
        NSInteger success=[[GlobalFunc changeType:responseObject[@"success"]] integerValue];
        NSString *msg=[GlobalFunc changeType:responseObject[@"msg"]];
        if (success==1) {
            block(YES,msg,responseObject);
        } else {
            block(NO,msg,responseObject);
        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        block(NO,GYNetworkErrorMsg,nil);
    }];
}

+(void)downloadWithUrlString:(NSString *)urlString progress:(void (^)(NSProgress * progress))progress success:(void (^)(NSURLResponse * response, NSURL * filePath))success fail:(void (^)(NSError * error))fail
{
    //1.创建会话管理者
    AFHTTPSessionManager *manager =[AFHTTPSessionManager manager];
 
    NSURL *url = [NSURL URLWithString:urlString];
//    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    __weak typeof(self)weakself = self;
    NSURLSessionDownloadTask *download = [manager downloadTaskWithRequest:request progress:^(NSProgress * _Nonnull downloadProgress) {
        //监听下载进度
        //completedUnitCount 已经下载的数据大小
        //totalUnitCount     文件数据的中大小
//        _downloadView.progressView.progress = 1.0 * downloadProgress.completedUnitCount / downloadProgress.totalUnitCount;
//        NSLog(@"%f",1.0 *downloadProgress.completedUnitCount / downloadProgress.totalUnitCount);
        progress(downloadProgress);
//        _pressing = 1.0 * downloadProgress.completedUnitCount / downloadProgress.totalUnitCount;
   
 
    } destination:^NSURL * _Nonnull(NSURL * _Nonnull targetPath, NSURLResponse * _Nonnull response) {
        NSLog(@"response.suggestedFilename:%@",response.suggestedFilename);
        // 下载文件存储的路径 拼接上文件的名字
        NSString *fullPath = [NSString stringWithFormat:@"%@/%@",[GlobalFunc getHistoryCachePath:DLMUSIC],response.suggestedFilename];
        return [NSURL fileURLWithPath:fullPath];
    } completionHandler:^(NSURLResponse * _Nonnull response, NSURL * _Nullable filePath, NSError * _Nullable error) {
        /**
         *filePath:下载后文件的保存路径
         */
        if(error)
        {
            fail(error);
            [manager invalidateSessionCancelingTasks:YES resetSession:YES];
        }
        else
        {
            success(response,filePath);
            [manager invalidateSessionCancelingTasks:YES resetSession:YES];
        }
        NSLog(@"%@",filePath);
    }];
 
    //3.执行Task
    [download resume];
}

@end
