
#import <UIKit/UIKit.h>

@class GYActionAlertView;

@protocol GYActionAlertViewDelegate <NSObject>

@optional

// 点击 index 0取消。 1确定，如果只有一个按钮不需要管
- (void)didActionAlertView:(GYActionAlertView *)view
               selectIndex:(NSInteger)index;

@end

@interface GYActionAlertView : UIView
/**设置弹出内容
 title 标题，不设置不展示
 showTextField 是否显示textField
 message 内容
 attribute 富文本 内容 和message只可设置一个，如两个都传，以attribute为准
 cancel 取消按钮文字
 confirm 确认按钮文字
 delegate 和block 可以只实现一个，拿点击回调，也可都不设置。
 */
- (void)setAlert:(NSString *)title showTextField:(BOOL)isShow message:(NSString *)message attributeMessage:(NSMutableAttributedString *)attribute cancel:(NSString *)cancel confirm:(NSString *)confirm delegate:(id<GYActionAlertViewDelegate>)delegate handler:(void (^)(NSInteger type,NSString*nameStr))block;
/**设置弹出内容
 title 标题，不设置不展示
 message 内容
 attribute 富文本 内容 和message只可设置一个，如两个都传，以attribute为准
 cancel 取消按钮文字
 confirm 确认按钮文字
 delegate 和block 可以只实现一个，拿点击回调，也可都不设置。
 */
- (void)setAlert:(NSString * )title
         message:(NSString * )message
attributeMessage:(NSMutableAttributedString * )attribute
          cancel:(NSString * )cancel
         confirm:(NSString * )confirm
        delegate:(id<GYActionAlertViewDelegate>)delegate
         handler:(void(^)(NSInteger type))block;

// 显示
- (void)show;

// MARK: 以下属性需要在调用setAlert方法之前赋值
//高亮
@property (nonatomic, assign) NSRange highRange;
//自己传入的富文本
@property (nonatomic, strong) NSMutableAttributedString *attribute;

@property (nonatomic, strong) UIFont *titleFont;
//标题字体颜色
@property (nonatomic, strong) UIColor *titleColor;
//内容字体颜色
@property (nonatomic, strong) UIColor *contentColor;

//内容
@property (nonatomic, strong) UIColor *nameColor;

//内容
@property (nonatomic, strong) UIColor *nameBackColor;

//写在setAlert方法后
@property (nonatomic, strong) NSString *bottomTitle;

//confirm按钮颜色
@property (nonatomic, strong) UIColor *confirmColor;

//取消按钮文字颜色
@property (nonatomic, strong) UIColor *cancelTitleColor;
//取消按钮边框颜色
@property (nonatomic, strong) UIColor *cancelBorderColor;
//confirm边框粗细
@property (nonatomic, assign) float confirmBorderWidth;
//confirm边框颜色
@property (nonatomic, strong) UIColor *confirmBorderColor;


//标题和内容间距
@property (nonatomic, assign) float title_content_space;

//内容和确认按钮间距
@property (nonatomic, assign) float content_confim_space;

@property (nonatomic, copy) void (^bottomBlock)(void);

/**是否是单个按钮，默认两个按钮*/
@property (nonatomic, assign) BOOL singleBtn;
/**弹出框的宽度 ，默认 300*/
@property (nonatomic, assign) CGFloat showViewWidth;
/**弹出框的高度是否固定，默认NO，计算得出高度*/
@property (nonatomic, assign) BOOL ifShowHeightConstant;
/**弹出框的高度，如设置ifShowHeightConstant = YES，需要给值，否则默认300*/
@property (nonatomic, assign) CGFloat showViewHeight;
@property (nonatomic) NSTextAlignment aligment;
/**消失的时候是否移除，设置为全局对象的时候设置为NO，默认YES用完就移除*/
@property (nonatomic, assign) CGFloat removeWhenHide;
/**弹框背景颜色*/
@property (nonatomic, strong)UIColor * alertBackColor;
/**背景颜色*/
@property (nonatomic, strong)UIColor * backColor;
//是否手动隐藏
@property (nonatomic, assign)BOOL isDismiss;
@property (nonatomic, assign)float left_content_space;
//是否显示动画图标
@property (nonatomic, assign)BOOL isShowAnimation;
@property (nonatomic, strong)NSAttributedString*attributedPlaceholder;
-(void)dismiss;

@end


