

#import "GYActionAlertView.h"
//#import "GYHomeDigitalViewController.h"
//#import "GYHomeDigitalListViewController.h"
//#import "GYCreateViewController.h"
//#import "GYMyViewController.h"

@interface GYActionAlertView ()<UITextFieldDelegate>

@property (nonatomic, weak) id<GYActionAlertViewDelegate> holderDelegate;
@property (nonatomic, copy) void(^actionDidSelectBlock)(NSInteger type);
@property (nonatomic, copy) void(^actionDidSelectBlock2)(NSInteger type,NSString* nameStr);
@property (nonatomic, strong) UIView *containtView;
@property (nonatomic, strong) UILabel *title_label;
@property (nonatomic, strong) UILabel *detailLabel;
@property (nonatomic, strong) UIButton *confirmBtn;
@property (nonatomic, strong) UIButton *cancelBtn;
@property (nonatomic, strong) UIButton *bottomBtn;
@property (nonatomic, strong)UITextField* nameTextField;
@property (nonatomic, strong)YYAnimatedImageView *animatedImageView;
@end

@implementation GYActionAlertView

- (instancetype)init {
    
    self = [super initWithFrame:CGRectMake(0, 0, ViewWidth, ViewHeight)];
    if (self) {
        self.title_content_space=5;
        self.left_content_space=15;
        self.content_confim_space=20;
        self.backgroundColor =[UIColor clearColor];
        [self addSubview:self.containtView];
        [self.containtView addSubview:self.animatedImageView];
        [self.containtView addSubview:self.title_label];
        [self.containtView addSubview:self.detailLabel];
        [self.containtView addSubview:self.bottomBtn];
        [self.containtView addSubview:self.confirmBtn];
        [self.containtView addSubview:self.cancelBtn];
        [self.containtView addSubview:self.nameTextField];
        
        self.containtView.backgroundColor = [UIColor whiteColor];
        self.showViewWidth = 300;
        [self.containtView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(300);
            make.bottom.equalTo(self.confirmBtn.mas_bottom).offset(25);
            make.centerX.mas_equalTo(0);
            make.centerY.mas_equalTo(0);
        }];
        [self.animatedImageView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.mas_equalTo(0);
//            make.right.mas_equalTo(-102);
            make.top.mas_equalTo(39);
            make.width.mas_equalTo(48);
            make.height.mas_equalTo(16);
        }];
        [self.title_label mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(15);
            make.right.mas_equalTo(-15);
            make.top.mas_equalTo(20);
        }];
        [self.detailLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-self.left_content_space);
            make.left.mas_equalTo(self.left_content_space);
            make.top.equalTo(self.title_label.mas_bottom).offset(self.title_content_space);
            make.height.mas_equalTo(0);
        }];
        [self.confirmBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.left.equalTo(self.mas_centerX).offset(10);
            make.top.equalTo(self.detailLabel.mas_bottom).offset(self.content_confim_space);
        }];
        [self.cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.confirmBtn.mas_top);
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.right.equalTo(self.mas_centerX).offset(-10);
        }];
        _aligment = NSTextAlignmentCenter;
    }
    return self;
}

- (void)actionDidAct:(UIButton *)sender {
    
    NSInteger type = 0;
    if (sender == self.confirmBtn) {
        type = 1;
    }
    ! self.actionDidSelectBlock ? : self.actionDidSelectBlock(type);
    ! self.actionDidSelectBlock2 ? : self.actionDidSelectBlock2(type,self.nameTextField.text);
    if (self.holderDelegate && [self.holderDelegate respondsToSelector:@selector(didActionAlertView:selectIndex:)]) {
        [self.holderDelegate didActionAlertView:self selectIndex:type];
    }
    if(!self.isDismiss)
    {
        [self dismiss];
    }

}


- (void)setSingleBtn:(BOOL)singleBtn {
    _singleBtn = singleBtn;
    self.cancelBtn.hidden = singleBtn;
}

- (void)setAligment:(NSTextAlignment)aligment {
    _aligment = aligment;
    self.detailLabel.textAlignment = aligment;
    
}

- (void)setShowViewWidth:(CGFloat)showViewWidth {
    _showViewWidth = showViewWidth;
}
-(void)setAttributedPlaceholder:(NSAttributedString *)attributedPlaceholder
{
    self.nameTextField.attributedPlaceholder=attributedPlaceholder;
}
-(UITextField*)nameTextField
{
    if(_nameTextField==nil)
    {
        _nameTextField=[[UITextField alloc] initWithFrame:CGRectZero];
//        _nameTextField.text=@"背景组";
        _nameTextField.font= [UIFont fontWithName:@"PingFangSC-Regular" size:11];
        _nameTextField.textColor=[UIColor colorWithHexString:@"#585858" alpha:1.0];
        _nameTextField.placeholder=@"仅支持中英文和数字，限10个字";
        _nameTextField.delegate=self;
        _nameTextField.layer.cornerRadius=4;
        _nameTextField.backgroundColor=[UIColor colorWithHexString:@"#F2F2F2" alpha:1.0];
        _nameTextField.textAlignment=NSTextAlignmentLeft;
        [_nameTextField addTarget:self action:@selector(textFieldDidChange:) forControlEvents:UIControlEventEditingChanged];
        UIView *paddingView1 = [[UIView alloc] initWithFrame:CGRectMake(0, 0,12, 38)];
        paddingView1.backgroundColor = [UIColor clearColor];
        _nameTextField.leftView = paddingView1;
        _nameTextField.leftViewMode = UITextFieldViewModeAlways;
        _nameTextField.hidden=YES;
    }
    return _nameTextField;
}
/**设置弹出内容
 title 标题，不设置不展示
 showTextField 是否显示textField
 message 内容
 attribute 富文本 内容 和message只可设置一个，如两个都传，以attribute为准
 cancel 取消按钮文字
 confirm 确认按钮文字
 delegate 和block 可以只实现一个，拿点击回调，也可都不设置。
 */
- (void)setAlert:(NSString *)title showTextField:(BOOL)isShow message:(NSString *)message attributeMessage:(NSMutableAttributedString *)attribute cancel:(NSString *)cancel confirm:(NSString *)confirm delegate:(id<GYActionAlertViewDelegate>)delegate handler:(void (^)(NSInteger type,NSString * nameStr))block {
    
    self.attribute = attribute;
    self.title_label.text = title;
    self.nameTextField.hidden=!isShow;
    NSMutableAttributedString * attri;
    if (message.length > 0) {
        attri = [[NSMutableAttributedString alloc] initWithString:message];
        NSMutableParagraphStyle * style = [[NSMutableParagraphStyle alloc] init];
        style.lineSpacing = 7;
        style.lineBreakMode = NSLineBreakByCharWrapping;
        style.alignment = self.aligment;
        [attri addAttributes:@{NSForegroundColorAttributeName:self.detailLabel.textColor,NSFontAttributeName:[UIFont systemFontOfSize:13 weight:UIFontWeightRegular],NSParagraphStyleAttributeName:style} range:NSMakeRange(0, message.length)];

    } else {
        attri = attribute;
    }
    CGFloat textHeight = [self sizeAttributeHeight:attri];
    if (title.length < 1) {
        self.title_label.hidden = YES;
        [self.title_label mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-15);
            make.left.mas_equalTo(15);
            make.top.mas_equalTo(15);
            make.height.mas_equalTo(0);
        }];
    } else {
        self.title_label.hidden = NO;
    }
    if (textHeight > 2) {
        [self.detailLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-self.left_content_space);
            make.left.mas_equalTo(self.left_content_space);
            make.top.equalTo(self.title_label.mas_bottom).offset(self.title_content_space);
//            make.height.mas_equalTo(textHeight+[UIFont systemFontOfSize:13 weight:UIFontWeightRegular].lineHeight);
        }];
    } else {
        [self.detailLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-self.left_content_space);
            make.left.mas_equalTo(self.left_content_space);
            make.top.equalTo(self.title_label.mas_bottom).offset(0);
            make.height.mas_equalTo(0);
        }];
    }
    
    self.detailLabel.attributedText = attri;
    [self.detailLabel sizeToFit];
    if (cancel.length > 0) {
        [self.cancelBtn setTitle:cancel forState:UIControlStateNormal];
    }
    if(isShow)
    {

        [self.nameTextField mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.height.mas_equalTo(38);
            make.left.mas_equalTo(18);
            make.right.mas_equalTo(-19);
            make.top.equalTo(self.detailLabel.mas_bottom).offset(20);
        }];
        [self.confirmBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.left.equalTo(self.mas_centerX).offset(10);
            make.top.equalTo(self.nameTextField.mas_bottom).offset(25);
        }];
        [self.cancelBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.nameTextField.mas_bottom).offset(25);
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.right.equalTo(self.mas_centerX).offset(-10);
        }];
    }
    if (confirm.length > 0) {
    
        [self.confirmBtn setTitle:confirm forState:UIControlStateNormal];
        if (self.singleBtn) {
            if(isShow)
            {
                [self.confirmBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                    make.left.mas_equalTo(20);
                    make.right.mas_equalTo(-20);
                    make.top.equalTo(self.nameTextField.mas_bottom).offset(self.content_confim_space);
                    make.height.mas_equalTo(44);
                }];
            }
            else
            {
                [self.confirmBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                    make.left.mas_equalTo(20);
                    make.right.mas_equalTo(-20);
                    make.top.equalTo(self.detailLabel.mas_bottom).offset(self.content_confim_space);
                    make.height.mas_equalTo(44);
                }];
            }
         
        }
    }
    _holderDelegate = delegate;
    self.actionDidSelectBlock2 = block;
    
    self.containtView.transform = CGAffineTransformMakeScale(0.1, 0.1);
}
/**设置弹出内容
 title 标题，不设置不展示
 message 内容
 attribute 富文本 内容 和message只可设置一个，如两个都传，以attribute为准
 cancel 取消按钮文字
 confirm 确认按钮文字
 delegate 和block 可以只实现一个，拿点击回调，也可都不设置。
 */
- (void)setAlert:(NSString *)title message:(NSString *)message attributeMessage:(NSMutableAttributedString *)attribute cancel:(NSString *)cancel confirm:(NSString *)confirm delegate:(id<GYActionAlertViewDelegate>)delegate handler:(void (^)(NSInteger))block {
    
    self.attribute = attribute;
    self.title_label.text = title;
    NSMutableAttributedString * attri;
    if (message.length > 0) {
        attri = [[NSMutableAttributedString alloc] initWithString:message];
        NSMutableParagraphStyle * style = [[NSMutableParagraphStyle alloc] init];
        style.lineSpacing = 7;
        style.lineBreakMode = NSLineBreakByCharWrapping;
        style.alignment = self.aligment;
        [attri addAttributes:@{NSForegroundColorAttributeName:self.detailLabel.textColor,NSFontAttributeName:[UIFont systemFontOfSize:13 weight:UIFontWeightRegular],NSParagraphStyleAttributeName:style} range:NSMakeRange(0, message.length)];

    } else {
        attri = attribute;
    }
    CGFloat textHeight = [self sizeAttributeHeight:attri];
    if (title.length < 1) {
        self.title_label.hidden = YES;
        [self.title_label mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-15);
            make.left.mas_equalTo(15);
            make.top.mas_equalTo(15);
            make.height.mas_equalTo(0);
        }];
    } else {
        self.title_label.hidden = NO;
    }
    if (textHeight > 2) {
        if(self.isShowAnimation)
        {
            self.animatedImageView.hidden=NO;
            [self.detailLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.right.mas_equalTo(-self.left_content_space);
                make.left.mas_equalTo(self.left_content_space);
                make.top.equalTo(self.animatedImageView.mas_bottom).offset(self.title_content_space);
    //            make.height.mas_equalTo(textHeight+[UIFont systemFontOfSize:13 weight:UIFontWeightRegular].lineHeight);
            }];
        }
        else
        {
            [self.detailLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.right.mas_equalTo(-self.left_content_space);
                make.left.mas_equalTo(self.left_content_space);
                make.top.equalTo(self.title_label.mas_bottom).offset(self.title_content_space);
    //            make.height.mas_equalTo(textHeight+[UIFont systemFontOfSize:13 weight:UIFontWeightRegular].lineHeight);
            }];
        }
       
    } else {
        [self.detailLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-self.left_content_space);
            make.left.mas_equalTo(self.left_content_space);
            make.top.equalTo(self.title_label.mas_bottom).offset(0);
            make.height.mas_equalTo(0);
        }];
    }
    
    
    self.detailLabel.attributedText = attri;
    [self.detailLabel sizeToFit];
    if (cancel.length > 0) {
        [self.cancelBtn setTitle:cancel forState:UIControlStateNormal];
    }
    if (confirm.length > 0) {
        [self.confirmBtn setTitle:confirm forState:UIControlStateNormal];
        if (self.singleBtn) {
            [self.confirmBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.mas_equalTo(20);
                make.right.mas_equalTo(-20);
                make.top.equalTo(self.detailLabel.mas_bottom).offset(self.content_confim_space);
                make.height.mas_equalTo(44);
            }];
        }
    }
    _holderDelegate = delegate;
    self.actionDidSelectBlock = block;
    
    self.containtView.transform = CGAffineTransformMakeScale(0.1, 0.1);
}

- (void)show {
//
//    UIViewController *vc = [GlobalFunc getCurrentViewController];
//    if ([vc isKindOfClass:[GYHomeDigitalViewController class]] || [vc isKindOfClass:[GYHomeDigitalListViewController class]] || [vc isKindOfClass:[GYCreateViewController class]] || [vc isKindOfClass:[GYMyViewController class]] ) {
//        self.supportTheme = YES;
//    }


        if (self.superview == nil) {
            [[[UIApplication sharedApplication] keyWindow] addSubview:self];
        }
        self.hidden = NO;
        [UIView animateWithDuration:0.25 animations:^{
            self.containtView.transform = CGAffineTransformIdentity;
        } completion:nil];

    
}

- (void)dismiss {
    [self.nameTextField resignFirstResponder];
    [self.animatedImageView stopAnimating];
      
    [UIView animateWithDuration:0.25 animations:^{
//            self.containtView.transform = CGAffineTransformMakeScale(0.1, 0.1);
        } completion:^(BOOL finished) {
            self.hidden = YES;
            if (self.removeWhenHide == YES) {
                [self removeFromSuperview];
          
            }
        }];

}

// 内部自用
- (CGFloat)sizeAttributeHeight:(NSMutableAttributedString *)attr {
    if (attr.length == 0) {
        return 0;
    }
    CGFloat maxWidth = self.showViewWidth - 30.0;
    CGSize size = [attr boundingRectWithSize:CGSizeMake(maxWidth, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin context:nil].size;
    
    return size.height + 1;
}


- (void)setTitleFont:(UIFont *)titleFont {
    
    _titleFont = titleFont;
    self.title_label.font = titleFont;
}

- (void)setBottomTitle:(NSString *)bottomTitle {
    
    _bottomTitle = bottomTitle;
    if (bottomTitle.length > 0) {
        self.bottomBtn.hidden = NO;
        [self.bottomBtn setTitle:bottomTitle forState:UIControlStateNormal];
        [self.bottomBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.centerX.mas_equalTo(0);
            make.top.equalTo(self.detailLabel.mas_bottom).offset(10);
        }];
        [self.confirmBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.left.equalTo(self.mas_centerX).offset(10);
            make.top.equalTo(self.bottomBtn.mas_bottom).offset(10);
        }];
        [self.cancelBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.bottomBtn.mas_bottom).offset(10);
            make.width.mas_equalTo(120);
            make.height.mas_equalTo(44);
            make.right.equalTo(self.mas_centerX).offset(-10);
        }];
    }
}

- (void)clickBottomAction {
    
    if (self.bottomBlock) {
        self.bottomBlock();
        [self dismiss];
    }
}

- (UIButton *)bottomBtn {
    
    if (nil == _bottomBtn) {
        _bottomBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_bottomBtn setTitle:@"" forState:UIControlStateNormal];
        [_bottomBtn setTitleColor:[UIColor colorWithHexString:@"FFB600"] forState:UIControlStateNormal];
        _bottomBtn.titleLabel.font =  [UIFont fontWithName:@"PingFangSC-Regular" size:13];
        [_bottomBtn addTarget:self action:@selector(clickBottomAction) forControlEvents:UIControlEventTouchUpInside];
        _bottomBtn.hidden = YES;
    }
    return _bottomBtn;
}

- (UIButton *)cancelBtn {
    
    if (nil == _cancelBtn) {
        _cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _cancelBtn.layer.masksToBounds = YES;
        _cancelBtn.layer.cornerRadius = 6;
        _cancelBtn.backgroundColor = [UIColor clearColor];
        _cancelBtn.layer.borderWidth = 1;
        _cancelBtn.layer.borderColor=[UIColor colorWithHexString:@"#444CF0"].CGColor;
        [_cancelBtn setTitleColor:[UIColor colorWithHexString:@"#444CF0"] forState:UIControlStateNormal];
        _cancelBtn.titleLabel.font =[UIFont fontWithName:@"PingFangSC-Semibold" size:15];
        [_cancelBtn addTarget:self action:@selector(actionDidAct:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _cancelBtn;
}

- (UIButton *)confirmBtn {
    
    if (nil == _confirmBtn) {
        _confirmBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _confirmBtn.layer.masksToBounds = YES;
        _confirmBtn.backgroundColor = [UIColor colorWithHexString:@"#444CF0"];
        _confirmBtn.layer.masksToBounds = YES;
        [_confirmBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _confirmBtn.layer.cornerRadius = 6;
        _confirmBtn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Semibold" size:15];
        [_confirmBtn addTarget:self action:@selector(actionDidAct:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _confirmBtn;
}

- (UILabel *)detailLabel {
    
    if (nil == _detailLabel) {
        _detailLabel = [[UILabel alloc] init];
        _detailLabel.font = [UIFont systemFontOfSize:13 weight:UIFontWeightRegular];
        _detailLabel.backgroundColor = [UIColor clearColor];
        _detailLabel.textColor = [UIColor blackColor];
        _detailLabel.textAlignment = NSTextAlignmentCenter;
        _detailLabel.userInteractionEnabled = NO;
//        _content_textView.scrollEnabled = NO;
        _detailLabel.numberOfLines = 0;
    }
    return _detailLabel;
}

- (UILabel *)title_label {
    
    if (nil == _title_label) {
        _title_label = [[UILabel alloc] init];
        _title_label.numberOfLines = 0;
        _title_label.font = [UIFont fontWithName:@"PingFangSC-Semibold" size:18];
        _title_label.textColor = [UIColor blackColor];
        _title_label.textAlignment = NSTextAlignmentCenter;
    }
    return _title_label;
}

- (UIView *)containtView {
    
    if (nil == _containtView) {
        _containtView = [UIView new];
        _containtView.backgroundColor = [UIColor whiteColor];
        _containtView.layer.masksToBounds = YES;
        _containtView.layer.cornerRadius = 10;
    }
    return _containtView;
}
-(YYAnimatedImageView*)animatedImageView
{
    if(nil==_animatedImageView)
    {
        _animatedImageView=[[YYAnimatedImageView alloc] init];
        NSString *path = [[NSBundle mainBundle] pathForResource:@"gpt_load_2" ofType:@"gif"];
        NSData *gifData = [NSData dataWithContentsOfFile:path];
        YYImage *yyimage = [YYImage imageWithData:gifData];
        _animatedImageView.image = yyimage;
        _animatedImageView.hidden=YES;
        _animatedImageView.animationRepeatCount=0;
//        [_animatedImageView startAnimating];

    }
    return _animatedImageView;
}
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
    return YES;
}

- (void)textFieldDidChange:(UITextField *)textField {
    
    if (textField == self.nameTextField) {
        NSString *code = self.nameTextField.text;
        code = [code stringByReplacingOccurrencesOfString:@" " withString:@""];
        self.nameTextField.text = code;
        if (self.nameTextField.text.length > 10) {
            self.nameTextField.text = [self.nameTextField.text substringToIndex:10];
        }

    }
    
}
-(void)setBackColor:(UIColor *)backColor
{
    self.backgroundColor =backColor;
}
-(void)setAlertBackColor:(UIColor *)alertBackColor
{
    self.containtView.backgroundColor=alertBackColor;
}
-(void)setTitleColor:(UIColor *)titleColor
{
    self.title_label.textColor=titleColor;
  
 
}

-(void)setContentColor:(UIColor *)contentColor
{
    self.detailLabel.textColor=contentColor;
}
-(void)setNameColor:(UIColor *)nameColor
{
    self.nameTextField.textColor=nameColor;
}
-(void)setNameBackColor:(UIColor *)nameBackColor
{
    self.nameTextField.backgroundColor=nameBackColor;
}
-(void)setConfirmColor:(UIColor *)confirmColor
{
    [self.confirmBtn setBackgroundColor:confirmColor];
}
-(void)setConfirmBorderWidth:(float)confirmBorderWidth
{
    self.confirmBtn.layer.borderWidth=confirmBorderWidth;
}
-(void)setConfirmBorderColor:(UIColor *)confirmBorderColor
{
    self.confirmBtn.layer.borderColor=confirmBorderColor.CGColor;
}
-(void)setIsHiddenTitle:(BOOL)isHiddenTitle
{
    self.title_label.hidden=isHiddenTitle;
}
-(void)setCancelBorderColor:(UIColor *)cancelBorderColor
{
    self.cancelBtn.layer.borderColor=cancelBorderColor.CGColor;
}
-(void)setCancelTitleColor:(UIColor *)cancelTitleColor
{
    [self.cancelBtn setTitleColor:cancelTitleColor forState:UIControlStateNormal];
}
@end

