//
//  GlobalFunc.m
//  GJDigitalDemo
//
//  Created by guiji on 2023/7/5.
//

#import "GlobalFunc.h"

@implementation GlobalFunc
//存放历史缓存的文件夹
+(NSString *)getHistoryCachePath:(NSString*)pathName
{
    NSString* folderPath =[[self getFInalPath] stringByAppendingPathComponent:pathName];
    //创建文件管理器
    NSFileManager *fileManager = [NSFileManager defaultManager];
    //判断temp文件夹是否存在
    BOOL fileExists = [fileManager fileExistsAtPath:folderPath];
    //如果不存在说创建,因为下载时,不会自动创建文件夹
    if (!fileExists)
    {
        [fileManager createDirectoryAtPath:folderPath withIntermediateDirectories:YES attributes:nil error:nil];
    }
    return folderPath;
}
+ (NSString *)getFInalPath
{
    NSString* folderPath =[[[NSHomeDirectory() stringByAppendingPathComponent:@"Library"] stringByAppendingPathComponent:@"Caches"] stringByAppendingPathComponent:@"TR"];
    //创建文件管理器
    NSFileManager *fileManager = [NSFileManager defaultManager];
    //判断temp文件夹是否存在
    BOOL fileExists = [fileManager fileExistsAtPath:folderPath];
    //如果不存在说创建,因为下载时,不会自动创建文件夹
    if (!fileExists) {
        [fileManager createDirectoryAtPath:folderPath withIntermediateDirectories:YES attributes:nil error:nil];
    }
    
    return folderPath;
}
+(void)showWindowText:(NSString *)loadtext :(UIView *)view{
    
    if (loadtext.length == 0) {
        return;
    }
    UIWindow *window= [[[UIApplication sharedApplication] delegate] window];
    MBProgressHUD*  hud = [[MBProgressHUD alloc]initWithView:view];
    [window addSubview:hud];
    //    [[[[UIApplication sharedApplication] delegate] window] addSubview:hud];
    hud.mode = MBProgressHUDModeCustomView;
    hud.detailsLabel.text =loadtext;
    hud.detailsLabel.font=[UIFont fontWithName:@"PingFangSC-Regular" size:16];
    hud.detailsLabel.textColor=[UIColor whiteColor];
    hud.contentColor=[UIColor whiteColor];
    hud.bezelView.style = MBProgressHUDBackgroundStyleSolidColor;
    hud.bezelView.backgroundColor = [UIColor blackColor];
    hud.userInteractionEnabled = NO;
    [hud showAnimated:YES];
    [hud hideAnimated:YES afterDelay:2];
    
    
}
+ (BOOL)isInputRuleNotBlank:(NSString *)str {
    
    //  ^[A-Za-z0-9\u4E00-\u9FA5]*$"
    // [a-zA-Z\\u4E00-\\u9FA5\\u0030-\\u0039
    //^[a-zA-Z\u4E00-\u9FA5\\d\\s]*$
    //^[a-zA-Z\u4E00-\u9FA5\\d\\s]*$
    //^[➋➌➍➎➏➐➑➒\a-zA-Z\u4E00-\u9FA5\\d]*$
    NSString *pattern = @"^[a-zA-Z\\u4E00-\\u9FA5\\u0030-\\u0039]*$";
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", pattern];
    BOOL isMatch = [pred evaluateWithObject:str];
    return isMatch;
}
#pragma mark -------------------------设置文字阴影-------------------------------------
+(NSMutableAttributedString*)toGetFormStr:(NSString*)str font:(UIFont*)font color:(UIColor*)color
{
    NSShadow *shadow = [[NSShadow alloc] init];
    shadow.shadowBlurRadius = 5;
    shadow.shadowColor = [UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:0.5];
    shadow.shadowOffset =CGSizeMake(1,1);
    NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:str attributes: @{NSFontAttributeName:font,NSForegroundColorAttributeName:color, NSShadowAttributeName: shadow}];
    return string;
}
+(float)getSafeBottom
{
    float height=20;
    if([UIApplication sharedApplication].delegate.window.safeAreaInsets.bottom>0)
    {
        height=[UIApplication sharedApplication].delegate.window.safeAreaInsets.bottom;
    }
    return height;

}
#pragma mark ---------------//秒转换成时分秒----------------------
+(NSString *)getHHMMSSFromSS:(int)totalSeconds
{
    int hours = totalSeconds / 3600;
    int minutes = (totalSeconds / 60) % 60;
    int seconds = totalSeconds % 60;
    
    
    NSString *format_time;
    if (hours>0)
    {
        if(seconds>0)
        {
            format_time = [NSString stringWithFormat:@"%d时%d分%d秒",hours,minutes,seconds];
        }
        else
        {
            if(minutes>0)
            {
                format_time = [NSString stringWithFormat:@"%d时%d分",hours,minutes];
            }
            else
            {
                format_time = [NSString stringWithFormat:@"%d时",hours];
            }
         
        }
        
        return format_time;
    }
    
    if (minutes>0)
    {
        if(seconds>0)
        {
            format_time = [NSString stringWithFormat:@"%d分%d秒",minutes,seconds];
        }
        else
        {
            format_time = [NSString stringWithFormat:@"%d分",minutes];
        }
     
        return format_time;
    }
    if(seconds>=0)
    {
        format_time = [NSString stringWithFormat:@"%d秒",seconds];
        return format_time;
    }
    
    return format_time;
    
}
+ (UIViewController *)getCurrentViewController
{
    UIWindow* window = [[[UIApplication sharedApplication] delegate] window];
    NSAssert(window, @"The window is empty");
    //获取根控制器
    UIViewController* currentViewController = window.rootViewController;
    //获取当前页面控制器
    BOOL runLoopFind = YES;
    while (runLoopFind){
        if (currentViewController.presentedViewController)
        {
            currentViewController = currentViewController.presentedViewController;
        } else if ([currentViewController isKindOfClass:[UINavigationController class]])
        {
            UINavigationController  * navigationController = (UINavigationController* )currentViewController;
            currentViewController = [navigationController.childViewControllers lastObject];
        } else if ([currentViewController isKindOfClass:[UITabBarController class]]){
            UITabBarController* tabBarController = (UITabBarController* )currentViewController;
            currentViewController = tabBarController.selectedViewController;
        } else {
            NSUInteger childViewControllerCount = currentViewController.childViewControllers.count;
            if (childViewControllerCount > 0 )
            {
               // currentViewController = currentViewController.childViewControllers.lastObject;
                return currentViewController;
            } else {
                return currentViewController;
            }
        }
    }
    return currentViewController;
}
#pragma mark -------------------------保存音乐文件到本地------------------------------------
+(void)toSaveAudioFile:(NSArray*)array :(NSArray <NSURL *>*)urls :(NSString*)room_id_str :(NSInteger)audio_type :(NSString*)tts_text;
{
    NSFileManager * filemanager=[NSFileManager defaultManager];
    NSString *audio_text_path = [NSString stringWithFormat:@"%@/%@_bg_audio", [GlobalFunc getHistoryCachePath:@"bg_audio"],room_id_str];
    NSMutableArray * data_arr=[[NSMutableArray alloc] init];
//    NSArray *un_arr= [NSKeyedUnarchiver unarchiveObjectWithFile:audio_text_path];
    NSInteger count=0;
    if(array!=nil)
    {

        for(int i=0;i<array.count;i++)
        {
            BGMusicModel * musicModel=array[i];
            musicModel.isPlaying=NO;
            if(i==array.count-1)
            {
                count=musicModel.pid+1;
            }
        }
   
        [data_arr addObjectsFromArray:array];
    }
    for(int i=0;i<urls.count; i++)
    {
        BGMusicModel * musicModel=[[BGMusicModel alloc] init];
        NSURL * url=urls[i];
        AVURLAsset * audioAsset = [AVURLAsset URLAssetWithURL:url options:nil];
        CMTime audioDuration = audioAsset.duration;
        NSString * fileName=[url lastPathComponent];
        if(audio_type==0)
        {
            //本地音频文件
            NSData *data=[NSData dataWithContentsOfURL:url];
            NSString * filepath=[NSString stringWithFormat:@"%@/%@",[GlobalFunc getHistoryCachePath:DLMUSIC],fileName];
            if([filemanager fileExistsAtPath:filepath])
            {
                [filemanager removeItemAtPath:filepath error:nil];
            }
            if(![url.absoluteString containsString:@"http"])
            {
                [data writeToFile:filepath atomically:YES];
            }
            musicModel.music_name = fileName;
            musicModel.tts_content=fileName;
        }
        else
        {
            //网络音频
            musicModel.music_name = fileName;

            musicModel.tts_content=tts_text;
         
        }
        musicModel.type=audio_type;
        musicModel.pid=count+i;
        musicModel.duration = CMTimeGetSeconds(audioDuration);
        [data_arr addObject:musicModel];
    }
    [GlobalFunc toSaveAudioTxt:data_arr :room_id_str];
}
#pragma mark -------------------------读取音乐数组------------------------------------
+(NSArray*)toReadAudioFile:(NSString*)room_id_str
{
    NSString *fliePath = [NSString stringWithFormat:@"%@/%@_bg_audio", [GlobalFunc getHistoryCachePath:@"bg_audio"],room_id_str];
//        [[NSFileManager defaultManager] removeItemAtPath:fliePath error:nil];
    NSArray *un_arr= [NSKeyedUnarchiver unarchiveObjectWithFile:fliePath];
    return un_arr;
}
#pragma mark -------------------------保存音乐数组到本地------------------------------------
+(void)toSaveAudioTxt:(NSArray*)arr :(NSString*)room_id_str
{

    NSString *fliePath = [NSString stringWithFormat:@"%@/%@_bg_audio", [GlobalFunc getHistoryCachePath:@"bg_audio"],room_id_str];
    [NSKeyedArchiver archiveRootObject:arr toFile:fliePath];
}
+(void)alertWithTitle: (NSString *)_title msg: (NSString *)msg cancle:(NSString *)cancle sure:(NSString *)sure :(void (^)(NSInteger type))success
{
//    dispatch_async(dispatch_get_main_queue(), ^{
        GYActionAlertView * alert = [[GYActionAlertView alloc] init];
        alert.title_content_space=20;
        alert.backColor=[UIColor colorWithHexString:@"#000000" alpha:0.6];
        alert.alertBackColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        alert.titleColor=[UIColor whiteColor];
        alert.contentColor=[UIColor whiteColor];
        alert.cancelTitleColor=[UIColor whiteColor];
        alert.cancelBorderColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        alert.confirmColor=[UIColor colorWithHexString:@"#475EFF" alpha:1.0];
        [alert setAlert:_title message:msg attributeMessage:nil cancel:cancle confirm:sure delegate:nil handler:^(NSInteger type) {
            success(type);
            
        }];
        [alert show];
//    });
      
  

    
}
+(void)showLoadText:(NSString *)loadtext :(UIView*)view
{
    if (loadtext.length == 0) {
        return;
    }
    MBProgressHUD*  hud = [[MBProgressHUD alloc]initWithView:view];
    [view addSubview:hud];
    hud.mode = MBProgressHUDModeCustomView;
    hud.detailsLabel.text =loadtext;
    hud.userInteractionEnabled = NO;
    hud.detailsLabel.font=[UIFont fontWithName:@"PingFangSC-Medium" size:16];
    hud.detailsLabel.textColor=[UIColor whiteColor];
    hud.contentColor=[UIColor whiteColor];
    hud.bezelView.style = MBProgressHUDBackgroundStyleSolidColor;
    hud.bezelView.backgroundColor = [UIColor blackColor];
    [hud showAnimated:YES];
    [hud hideAnimated:YES afterDelay:2];
    //    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2* NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    //        [MBProgressHUD hideAllHUDsForView:view animated:YES];
    //    });
}
#pragma mark----------------获取文本高度---------------------
+ (CGFloat)getHeightByWidth:(CGFloat)width title:(NSString *)title font:(UIFont *)font
{
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, width, 0)];
    label.text = title;
    label.font = font;
    label.numberOfLines = 0;
    [label sizeToFit];
    CGFloat height = label.frame.size.height;
    return height;
}

#pragma mark----------------获取文本宽度---------------------
+ (CGFloat)getWidthWithTitle:(NSString *)title font:(UIFont *)font
{
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, 1000, 0)];
    label.text = title;
    label.font = font;
    [label sizeToFit];
    return label.frame.size.width;
}
+(id)changeType:(id)myObj
{
    if ([myObj isKindOfClass:[NSDictionary class]])
    {
        return [self nullDic:myObj];
    }
    else if([myObj isKindOfClass:[NSArray class]])
    {
        return [self nullArr:myObj];
    }
    else if([myObj isKindOfClass:[NSString class]])
    {
        return [self stringToString:myObj];
    }
    else if([myObj isKindOfClass:[NSNull class]] || myObj==nil)
    {
        return [self nullToString];
    }
    else
    {
        return myObj;//此处都转成了string类型，后期特殊需要可以改
    }
}

#pragma mark - 私有方法
//将NSDictionary中的Null类型的项目转化成@""
+(NSDictionary *)nullDic:(NSDictionary *)myDic
{
    NSArray *keyArr = [myDic allKeys];
    NSMutableDictionary *resDic = [[NSMutableDictionary alloc]init];
    for (int i = 0; i < keyArr.count; i ++)
    {
        id obj = [myDic objectForKey:keyArr[i]];
        
        obj = [self changeType:obj];
        
        [resDic setObject:obj forKey:keyArr[i]];
    }
    return resDic;
}

//将NSDictionary中的Null类型的项目转化成@""
+(NSArray *)nullArr:(NSArray *)myArr
{
    NSMutableArray *resArr = [[NSMutableArray alloc] init];
    for (int i = 0; i < myArr.count; i ++)
    {
        id obj = myArr[i];
        
        obj = [self changeType:obj];
        
        [resArr addObject:obj];
    }
    return resArr;
}

//将NSString类型的原路返回
+(NSString *)stringToString:(NSString *)string
{
    if ([string isEqualToString:@"null"]) {
        return @"";
    }
    else
    {
        return string;
    }
    
}

//将Null类型的项目转化成@""
+(NSString *)nullToString
{
    return @"";
}
//JSON字符串转化为字典
+ (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString {
    
    if (jsonString == nil) {
        return nil;
    }
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers
                                                          error:&err];
    if(err)
    {
        NSLog(@"json解析失败：%@",err);
        return nil;
    }
    return dic;
}
+ (void)showHud {
    dispatch_async(dispatch_get_main_queue(), ^{
        [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeClear];
        [SVProgressHUD show];
    });
}

+ (void)showHud:(SVProgressHUDMaskType)maskType {
    dispatch_async(dispatch_get_main_queue(), ^{
        [SVProgressHUD setDefaultMaskType:maskType];
        [SVProgressHUD show];
    });
}

+ (void)hideHud {
    dispatch_async(dispatch_get_main_queue(), ^{
        [SVProgressHUD dismiss];
        [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeNone];
    });
}

@end
