
#import <Foundation/Foundation.h>
/*
 *  NSDate 相关类
 *  日期的格式化，字符串转日期，等
 *  若需要其它的格式，可以在此类中增加方法
 */
@interface NSDate(Helpers)

- (NSString *)getFormatYearMonthDayHourMin;
- (NSString *)getFormatYearMonth;
- (NSString *)getFormatYearMonthDayHourMinSec;
- (NSString *)getFormatYearMonthDay_HourMinSec;
- (NSString *)getFormatYearMonthDayHour;
- (NSString *)getFormatYearMonthDay;
- (NSString *)getFormatYear_Month_Day;
- (NSString *)getFormatChineseYearMonthDay;//农历
- (NSDateComponents *)YMDComponents;
- (NSDateComponents *)YMDChineseComponents;
- (int)getWeekNumOfMonth;
- (int)getWeekOfYear;
- (NSDate *)dateAfterDay:(int)day;
- (NSDate *)dateafterMonth:(int)month;
- (NSUInteger)getDay;
- (NSString*)getweekday;
- (NSUInteger)getMonth;
- (NSUInteger)getYear;
- (NSUInteger)getChineseYear;
- (int)getHour ;
- (int)getMinute;
- (int)getSec;
- (NSString *)getFormatHourMinSec;
- (NSString *)getFormatHourMin;
- (int)getHour:(NSDate *)date ;
- (int)getMinute:(NSDate *)date ;
- (NSUInteger)daysAgo ;
- (NSUInteger)daysAgoAgainstMidnight ;
- (NSString *)stringDaysAgo ;
- (NSString *)stringDaysAgoAgainstMidnight:(BOOL)flag ;
- (NSUInteger)weekday ;
+ (NSDate *)dateFromString:(NSString *)string;
+ (NSDate *)dateFromString:(NSString *)string withFormat:(NSString *)format ;
+ (NSString *)stringFromDate:(NSDate *)date withFormat:(NSString *)format ;
+ (NSString *)stringFromDate:(NSDate *)date ;
+ (NSString *)stringForDisplayFromDate:(NSDate *)date prefixed:(BOOL)prefixed ;
+ (NSString *)stringForDisplayFromDate:(NSDate *)date ;
- (NSString *)stringWithFormat:(NSString *)format ;
- (NSString *)string ;
- (NSString *)stringWithDateStyle:(NSDateFormatterStyle)dateStyle timeStyle:(NSDateFormatterStyle)timeStyle ;																			
- (NSDate *)beginningOfWeek ;
- (NSDate *)beginningOfDay ;
- (NSDate *)beginningOfMonth;
- (NSDate *)endOfMonth;	
- (NSDate *)endOfWeek ;						

+ (NSString *)CNdateFormatString;       //yyyy年MM月dd日
+ (NSString *)dateFormatString ;        //yyyy-MM-dd
+ (NSString *)simpleDateFormatString ;  //yyyyMMdd
+ (NSString *)timeFormatString ;        //HH:mm:ss
+ (NSString *)simpleTimeFormatString ;  //HH:mm
+ (NSString *)timestampFormatString ;   //yyyy-MM-dd HH:mm:ss
+ (NSString *)monthDayFormatString;

+ (NSString *)dotDateFormatString ;     //MM.dd
+ (NSString *)dotDate2FormatString ;    //YY.MM.dd
+ (NSString *)dotTimeFormatString ;     //YYYY.MM.dd HH:mm:ss 
+ (NSString *)dotHHmmssString ;         //am/pm HH:mm:ss 

+ (NSString *)dbFormatString ;


- (NSString *)getMonthAndDay;
- (NSString *)getGTMTimeString;
- (NSString *)getRelateTimeString;      //小时之前、分之前、秒之前

-(NSString *)getTheTimeBucket;//获取上午或者下午
- (BOOL)isEqualToDateWithoutTime:(NSDate *)aDate;
//+(NSString *)filterZero:(NSString *)_string;
+ (BOOL)compareDateByDate1:(NSDate *)_date1 date2:(NSDate *)_date2;
+ (BOOL)compareMonthByDate1:(NSDate *)_date1 date2:(NSDate *)_date2;
 +(BOOL)isBetweenFromDate1:(NSDate*)_date1 toDate2:(NSDate*)_date2 withCurrentDate:(NSDate*)currentDate;
- (BOOL)isToday;
- (BOOL)isYesterday;
- (BOOL)isSameWeekWithDate:(NSDate *)aDate;
-(NSString*)getHourAndMin;


@end
/*
 
    --------Demo-------
 
    NSDate->NSString
    NSDate *date=[NSDate date];
    NSString *dateString=[date stringWithFormat:[NSDate simpleDateFormatString]];
    NSLog(@"%@",dateString);
 
    NSDate->NSString
    NSString *dateString2=@“2012－12－12”;
    NSDate *date2=[NSDate dateFromString:dateString2 withFormat:[NSDate dateFormatString]];
 
 */



