

#import "NSDate_Helper.h"
//static const long long HS_MINUTE_UNIT = 60;
//static const long long HS_HOUR_UNIT =   3600;
static const long long HS_DAY_UNIT =    86400;
static const long long HS_WEEK_UNIT =   604800;

@implementation NSDate(Helpers)
/*
 
 * This guy can be a little unreliable and produce unexpected results,
 
 * you're better off using daysAgoAgainstMidnight
 
 */

//获取年月日如:1987-11-27 2:30:31.

- (NSString *)getFormatYearMonthDayHourMinSec
{
	
	NSString *string = [NSString stringWithFormat:@"%02lu.%02lu.%02lu %02d:%02d:%02d",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay],[self getHour],[self getMinute],[self getSec]];
	
	return string;
	
}
- (NSString *)getFormatYearMonthDay_HourMinSec
{
    
    NSString *string = [NSString stringWithFormat:@"%02lu%02lu%02lu_%02d%02d%02d",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay],[self getHour],[self getMinute],[self getSec]];
    
    return string;
    
}
- (NSString *)getFormatYearMonthDayHourMin
{
    
    NSString *string = [NSString stringWithFormat:@"%02lu-%02lu-%02lu %02d:%02d",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay],[self getHour],[self getMinute]];
    
    return string;
    
}
- (NSString *)getFormatYearMonth
{
    
    NSString *string = [NSString stringWithFormat:@"%02lu.%02lu",(unsigned long)[self getYear],(unsigned long)[self getMonth]];
    
    return string;
    
}

- (NSString *)getFormatYearMonthDayHour
{
    
    NSString *string = [NSString stringWithFormat:@"%02lu-%02lu-%02lu %02d",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay],[self getHour]];
    
    return string;
    
}
- (NSString *)getFormatHourMinSec

{
	
	NSString *string = [NSString stringWithFormat:@"%02d:%02d:%02d",[self getHour],[self getMinute],[self getSec]];
	
	return string;
	
}
- (NSString *)getFormatHourMin

{
    
    NSString *string = [NSString stringWithFormat:@"%02d:%02d",[self getHour],[self getMinute]];
    
    return string;
    
}

//获取年月日如:19871127.
- (NSString *)getFormatYearMonthDay

{
	
	NSString *string = [NSString stringWithFormat:@"%lu.%02lu.%02lu",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay]];
	
	return string;
	
}
//获取年月日对象
- (NSDateComponents *)YMDComponents
{
    return [[NSCalendar currentCalendar] components:
            NSCalendarUnitYear|
            NSCalendarUnitMonth|
            NSCalendarUnitDay|
            NSCalendarUnitWeekday fromDate:self];
}
//获取年月日对象
- (NSDateComponents *)YMDChineseComponents
{
    return [[[NSCalendar alloc]initWithCalendarIdentifier:NSCalendarIdentifierChinese] components:
            NSCalendarUnitYear|
            NSCalendarUnitMonth|
            NSCalendarUnitDay|
            NSCalendarUnitWeekday fromDate:self];
}

//获取年月日如:19871127.
- (NSString *)getFormatYear_Month_Day

{
    
    NSString *string = [NSString stringWithFormat:@"%lu-%02lu-%02lu",(unsigned long)[self getYear],(unsigned long)[self getMonth],(unsigned long)[self getDay]];
    
    return string;
    
}
//获取年月日如:19871127. 农历

- (NSString *)getFormatChineseYearMonthDay

{
    
    NSString *string = [NSString stringWithFormat:@"%lu-%02lu-%02lu",(unsigned long)[self getChineseYear],(unsigned long)[self getChineseMonth],(unsigned long)[self getChineseDay]];
    
    return string;
    
}


//返回当前月一共有几周(可能为4,5,6)

- (int )getWeekNumOfMonth

{
	
	return [[self endOfMonth] getWeekOfYear] - [[self beginningOfMonth] getWeekOfYear] + 1;
	
}

//该日期是该年的第几周

- (int )getWeekOfYear

{
	
	int i;
	
	int year =(int) [self getYear];
	
	NSDate *date = [self endOfWeek];
	
	for (i = 1;[[date dateAfterDay:-7 * i] getYear] == year;i++) 
		
	{
		
	}
	
	return i;
	
}

//返回day天后的日期(若day为负数,则为|day|天前的日期)

- (NSDate *)dateAfterDay:(int)day

{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	// Get the weekday component of the current date
	
	// NSDateComponents *weekdayComponents = [calendar components:NSWeekdayCalendarUnit fromDate:self];
	
	NSDateComponents *componentsToAdd = [[NSDateComponents alloc] init];
	
	// to get the end of week for a particular date, add (7 - weekday) days
	
	[componentsToAdd setDay:day];
	
	NSDate *dateAfterDay = [calendar dateByAddingComponents:componentsToAdd toDate:self options:0];

	return dateAfterDay;
	
}

//month个月后的日期

- (NSDate *)dateafterMonth:(int)month

{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *componentsToAdd = [[NSDateComponents alloc] init];
	
	[componentsToAdd setMonth:month];
	
	NSDate *dateAfterMonth = [calendar dateByAddingComponents:componentsToAdd toDate:self options:0];
    
	return dateAfterMonth;
	
}

//获取日

- (NSUInteger)getDay{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *dayComponents = [calendar components:(NSCalendarUnitDay) fromDate:self];
	
	return [dayComponents day];
	
}
//获取农历日
- (NSUInteger)getChineseDay
{
    
     NSCalendar *localeCalendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierChinese];
    
    NSDateComponents *dayComponents = [localeCalendar components:(NSCalendarUnitDay) fromDate:self];

    return [dayComponents day];
    
}

//获取月
- (NSUInteger)getMonth

{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *dayComponents = [calendar components:(NSCalendarUnitMonth) fromDate:self];
	
	return [dayComponents month];
	
}
//获取月
- (NSUInteger)getChineseMonth

{
    
       NSCalendar *localeCalendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierChinese];
    
    NSDateComponents *dayComponents = [localeCalendar components:(NSCalendarUnitMonth) fromDate:self];
    
    return [dayComponents month];
    
}


//获取年
- (NSUInteger)getYear

{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *dayComponents = [calendar components:(NSCalendarUnitYear) fromDate:self];
	
	return [dayComponents year];
	
}
//获取农历年
- (NSUInteger)getChineseYear
{
    NSCalendar *localeCalendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierChinese];
    NSDateComponents *dayComponents = [localeCalendar components:NSCalendarUnitYear fromDate:self];
    return [dayComponents year];
    
}

//获取小时

- (int )getHour
{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSUInteger unitFlags =NSCalendarUnitYear| NSCalendarUnitMonth | NSCalendarUnitDay |NSCalendarUnitHour |NSCalendarUnitMinute;
	
	NSDateComponents *components = [calendar components:unitFlags fromDate:self];
	
	NSInteger hour = [components hour];
	
	return (int)hour;
	
}

//获取分钟

- (int)getMinute {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSUInteger unitFlags =NSCalendarUnitYear| NSCalendarUnitMonth | NSCalendarUnitDay |NSCalendarUnitHour |NSCalendarUnitMinute;
	
	NSDateComponents *components = [calendar components:unitFlags fromDate:self];
	
	NSInteger minute = [components minute];
	
	return (int)minute;
	
}

//获取秒
- (int)getSec{
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSUInteger unitFlags =NSCalendarUnitYear| NSCalendarUnitMonth | NSCalendarUnitDay |NSCalendarUnitHour |NSCalendarUnitMinute |NSCalendarUnitSecond;
	
	NSDateComponents *components = [calendar components:unitFlags fromDate:self];
	
	NSInteger sec = [components second];
	
	return (int)sec;
	
}


- (int )getHour:(NSDate *)date {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSUInteger unitFlags =NSCalendarUnitYear| NSCalendarUnitMonth | NSCalendarUnitDay |NSCalendarUnitHour |NSCalendarUnitMinute;
	
	NSDateComponents *components = [calendar components:unitFlags fromDate:date];
	
	NSInteger hour = [components hour];
	
	return (int)hour;
	
}

- (int)getMinute:(NSDate *)date {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSUInteger unitFlags =NSCalendarUnitYear| NSCalendarUnitMonth | NSCalendarUnitDay |NSCalendarUnitHour |NSCalendarUnitMinute;
	
	NSDateComponents *components = [calendar components:unitFlags fromDate:date];
	
	NSInteger minute = [components minute];
	
	return (int)minute;
	
}

//在当前日期前几天

- (NSUInteger)daysAgo {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *components = [calendar components:(NSCalendarUnitDay)
									
											   fromDate:self
									
												 toDate:[NSDate date]
									
												options:0];
	
	return [components day];
	
}

//午夜时间距今几天

- (NSUInteger)daysAgoAgainstMidnight
{
	
	// get a midnight version of ourself:
	
	NSDateFormatter *mdf = [[NSDateFormatter alloc] init];
	
	[mdf setDateFormat:@"yyyy-MM-dd"];
	
	NSDate *midnight = [mdf dateFromString:[mdf stringFromDate:self]];
	
	return (int)[midnight timeIntervalSinceNow] / (60*60*24) *-1;
	
}



- (NSString *)stringDaysAgo
{
	return [self stringDaysAgoAgainstMidnight:YES];
}
- (NSString *)stringDaysAgoAgainstMidnight:(BOOL)flag {
	
	NSUInteger daysAgo = (flag) ? [self daysAgoAgainstMidnight] : [self daysAgo];
	NSString *text = nil;
	
	switch (daysAgo) {
			
		case 0:
			
			text = NSLocalizedString(@"今天", nil);
			
			break;
			
		case 1:
			
			text = NSLocalizedString(@"昨天", nil);
			
			break;
			
		default:
			
			text = [NSString stringWithFormat:@"%lu days ago", (unsigned long)daysAgo];
			
	}
	
	return text;
	
}

//返回一周的第几天(周末为第一天)

- (NSUInteger)weekday {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *weekdayComponents = [calendar components:(NSCalendarUnitWeekday) fromDate:self];
	
	return [weekdayComponents weekday];
	
}
-(NSString*)getweekday
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat: @"MM/d/yyyy,EEEE"];
    return [formatter stringFromDate:self];
}
//转为NSString类型的

+ (NSDate *)dateFromString:(NSString *)string {
	
	return [NSDate dateFromString:string withFormat:[NSDate dbFormatString]];
	
}

+ (NSDate *)dateFromString:(NSString *)string withFormat:(NSString *)format {
	
	NSDateFormatter *inputFormatter = [[NSDateFormatter alloc] init];
	
	[inputFormatter setDateFormat:format];
	
	NSDate *date = [inputFormatter dateFromString:string];
	
	return date;
	
}



+ (NSString *)stringFromDate:(NSDate *)date withFormat:(NSString *)format {
	
	return [date stringWithFormat:format];
	
}



+ (NSString *)stringFromDate:(NSDate *)date {
	
	return [date string];
	
}



+ (NSString *)stringForDisplayFromDate:(NSDate *)date prefixed:(BOOL)prefixed {
	
	/* 
	 
	 * if the date is in today, display 12-hour time with meridian,
	 
	 * if it is within the last 7 days, display weekday name (Friday)
	 
	 * if within the calendar year, display as Jan 23
	 
	 * else display as Nov 11, 2008
	 
	 */
	
	
	
	NSDate *today = [NSDate date];
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDateComponents *offsetComponents = [calendar components:(NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay)
										  
													 fromDate:today];
	
	
	
	NSDate *midnight = [calendar dateFromComponents:offsetComponents];
	
	
	
	NSDateFormatter *displayFormatter = [[NSDateFormatter alloc] init];
	
	NSString *displayString = nil;
	
	
	
	// comparing against midnight
	
	if ([date compare:midnight] == NSOrderedDescending) {
		
		if (prefixed) {
			
			[displayFormatter setDateFormat:@"'at' h:mm a"]; // at 11:30 am
			
		} else {
			
			[displayFormatter setDateFormat:@"h:mm a"]; // 11:30 am
			
		}
		
	} else {
		
		// check if date is within last 7 days
		
		NSDateComponents *componentsToSubtract = [[NSDateComponents alloc] init];
		
		[componentsToSubtract setDay:-7];
		
		NSDate *lastweek = [calendar dateByAddingComponents:componentsToSubtract toDate:today options:0];
		
		
		if ([date compare:lastweek] == NSOrderedDescending) {
			
			[displayFormatter setDateFormat:@"EEEE"]; // Tuesday
			
		} else {
			
			// check if same calendar year
			
			NSInteger thisYear = [offsetComponents year];
			
			
			
			NSDateComponents *dateComponents = [calendar components:(NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay)
												
														   fromDate:date];
			
			NSInteger thatYear = [dateComponents year];
			
			if (thatYear >= thisYear) {
				
				[displayFormatter setDateFormat:@"MMM d"];
				
			} else {
				
				[displayFormatter setDateFormat:@"MMM d, yyyy"];
				
			}
			
		}
		
		if (prefixed) {
			
			NSString *dateFormat = [displayFormatter dateFormat];
			
			NSString *prefix = @"'on' ";
			
			[displayFormatter setDateFormat:[prefix stringByAppendingString:dateFormat]];
			
		}
		
	}
	
	
	
	// use display formatter to return formatted date string
	
	displayString = [displayFormatter stringFromDate:date];
	
	return displayString;
	
}



+ (NSString *)stringForDisplayFromDate:(NSDate *)date {
	
	return [self stringForDisplayFromDate:date prefixed:NO];
	
}



- (NSString *)stringWithFormat:(NSString *)format {
	
	NSDateFormatter *outputFormatter = [[NSDateFormatter alloc] init];
	
	[outputFormatter setDateFormat:format];
	
	NSString *timestamp_str = [outputFormatter stringFromDate:self];
	
	return timestamp_str;
	
}



- (NSString *)string {
	
	return [self stringWithFormat:[NSDate dbFormatString]];
	
}



- (NSString *)stringWithDateStyle:(NSDateFormatterStyle)dateStyle timeStyle:(NSDateFormatterStyle)timeStyle {
	
	NSDateFormatter *outputFormatter = [[NSDateFormatter alloc] init];
	
	[outputFormatter setDateStyle:dateStyle];
	
	[outputFormatter setTimeStyle:timeStyle];
	
	NSString *outputString = [outputFormatter stringFromDate:self];
	
	return outputString;
	
}

//返回周日的的开始时间
- (NSDate *)beginningOfWeek {
	
	// largely borrowed from "Date and Time Programming Guide for Cocoa"
	
	// we'll use the default calendar and hope for the best
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	NSDate *beginningOfWeek = nil;
	
	BOOL ok = [calendar rangeOfUnit:NSCalendarUnitWeekOfMonth startDate:&beginningOfWeek
			   
						   interval:NULL forDate:self];
	
	if (ok) {
		
		return beginningOfWeek;
		
	} 
	
	
	
	// couldn't calc via range, so try to grab Sunday, assuming gregorian style
	
	// Get the weekday component of the current date
	
	NSDateComponents *weekdayComponents = [calendar components:NSCalendarUnitWeekday fromDate:self];
	
	
	
	/*
	 
	 Create a date components to represent the number of days to subtract from the current date.
	 
	 The weekday value for Sunday in the Gregorian calendar is 1, so subtract 1 from the number of days to subtract from the date in question.  (If today's Sunday, subtract 0 days.)
	 
	 */
	
	NSDateComponents *componentsToSubtract = [[NSDateComponents alloc] init];
	
	[componentsToSubtract setDay: 0 - ([weekdayComponents weekday] - 1)];
	
	beginningOfWeek = nil;
	
	beginningOfWeek = [calendar dateByAddingComponents:componentsToSubtract toDate:self options:0];
	
	//normalize to midnight, extract the year, month, and day components and create a new date from those components.
	
	NSDateComponents *components = [calendar components:(NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay)
									
											   fromDate:beginningOfWeek];
	
	return [calendar dateFromComponents:components];
	
}

//返回当前天的年月日.

- (NSDate *)beginningOfDay {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	// Get the weekday component of the current date
	
	NSDateComponents *components = [calendar components:(NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay)
									
											   fromDate:self];
	
	return [calendar dateFromComponents:components];
	
}

//返回该月的第一天

- (NSDate *)beginningOfMonth

{
	
	return [self dateAfterDay:-(int)[self getDay] + 1];
	
}

//该月的最后一天

- (NSDate *)endOfMonth

{
	
	return [[[self beginningOfMonth] dateafterMonth:1] dateAfterDay:-1];
	
}

//返回当前周的周末

- (NSDate *)endOfWeek {
	
	NSCalendar *calendar = [NSCalendar currentCalendar];
	
	// Get the weekday component of the current date
	
	NSDateComponents *weekdayComponents = [calendar components:NSCalendarUnitWeekday fromDate:self];
	
	NSDateComponents *componentsToAdd = [[NSDateComponents alloc] init];
	
	// to get the end of week for a particular date, add (7 - weekday) days
	
	[componentsToAdd setDay:(7 - [weekdayComponents weekday])];
	
	NSDate *endOfWeek = [calendar dateByAddingComponents:componentsToAdd toDate:self options:0];
	
	return endOfWeek;
	
}


+ (NSString *)CNdateFormatString {
	return @"yyyy年MM月dd日";
}
+ (NSString *)dateFormatString {
	
	return @"yyyy-MM-dd";
	
}
+ (NSString *)simpleDateFormatString {
	
	return @"yyyyMMdd";
	
}

+ (NSString *)timeFormatString {
	
	return @"HH:mm:ss";
	
}

+ (NSString *)simpleTimeFormatString {
	
	return @"HH:mm";
	
}



+ (NSString *)timestampFormatString {
	
	return @"yyyy-MM-dd HH:mm:ss";
	
}


+ (NSString *)monthDayFormatString {
    
    return @"MM-dd";
    
}

+ (NSString *)dotDateFormatString {
	return @"MM.d";	
}
+ (NSString *)dotDate2FormatString {
	return @"YYYY.M.d";	
}
+ (NSString *)dotTimeFormatString {
	return @"YYYY.M.d HH:mm:ss ";
}
+ (NSString *)dotHHmmssString{
    return @"a HH:mm:ss ";
}


// preserving for compatibility

+ (NSString *)dbFormatString {
	
	return [NSDate timestampFormatString];
	
}

-(NSString *)getMonthAndDay{
	NSDateFormatter *formatter=[[NSDateFormatter alloc] init];
	[formatter setDateFormat:@"M-d"];
	NSString *monthDay=[formatter stringFromDate:self];
	return monthDay;
}

-(NSString *)getGTMTimeString{ 
   // NSTimeZone* localzone = [NSTimeZone localTimeZone];  
  //  NSTimeZone* GTMzone = [NSTimeZone timeZoneForSecondsFromGMT:8];  
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];  
    [dateFormatter setDateFormat:@"HH:mm:ss"];  
   // [dateFormatter setTimeZone:GTMzone];   
    NSString *result=[dateFormatter stringFromDate:self];
    return result;
}

- (NSString *)getRelateTimeString
{
    NSDate * date=[NSDate date];
    long relateS=[[NSDate date] timeIntervalSince1970]-[self timeIntervalSince1970];
    long relateD=relateS/3600/24;
    if (relateD>0)
    {
        if ([date getYear]==[self getYear])
        {
            return [NSString stringWithFormat:@"%02lu-%02lu %02d:%02d",(unsigned long)[self getMonth],[self getDay],[self getHour],[self getMinute]];
        }
        else
        {
            return [self getFormatYearMonthDayHourMin];
        }

    }
    long relateH=relateS/3600;
    if (relateH>0) {
        return [NSString stringWithFormat:@"%ld小时前",relateH];
    }
    long relateM=relateS/60;
    if (relateM>0) {
        return [NSString stringWithFormat:@"%ld分钟前",relateM];
    }
    if (relateS>5) {
        return [NSString stringWithFormat:@"%ld秒前",relateS];
    }else {
        return [NSString stringWithFormat:@"%d秒前",5];
//        return @"刚刚";
    }
}

//+(NSString *)filterZero:(NSString *)_string{
//    NSMutableString *result=[[[NSMutableString alloc] initWithString:_string] autorelease];
//    [result replaceOccurrencesOfString:@".0" withString:@"." options:NSLiteralSearch range:NSMakeRange(0, result.length)];
//    return result;
//}
+ (BOOL)compareDateByDate1:(NSDate *)_date1 date2:(NSDate *)_date2
{
    NSCalendar *calendar = [NSCalendar currentCalendar];
    NSDateComponents *date1 = [calendar components:NSCalendarUnitEra|NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay fromDate:_date1];
    NSDateComponents *date2 = [calendar components:NSCalendarUnitEra|NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay fromDate:_date2];
    return ([date1 day] == [date2 day] &&
            [date1 month] == [date2 month] &&
            [date1 year] == [date2 year] &&
            [date1 era] == [date2 era]);
}
+ (BOOL)compareMonthByDate1:(NSDate *)_date1 date2:(NSDate *)_date2{
    NSCalendar *calendar = [NSCalendar currentCalendar];
    NSDateComponents *date1 = [calendar components:NSCalendarUnitEra|NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay fromDate:_date1];
    NSDateComponents *date2 = [calendar components:NSCalendarUnitEra|NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay fromDate:_date2];
    return ([date1 month] == [date2 month] &&
            [date1 year] == [date2 year] &&
            [date1 era] == [date2 era]);
}
+(BOOL)isBetweenFromDate1:(NSDate*)_date1 toDate2:(NSDate*)_date2 withCurrentDate:(NSDate*)currentDate
{

    
    if ([currentDate compare:_date1]==NSOrderedDescending && [currentDate compare:_date2]==NSOrderedAscending)
    {
       // NSLog(@"该时间在%@, %@-%@ 之间！",currentDate, _date1, _date2);
        return YES;
    }
    return NO;
}

//将时间点转化成日历形式
- (NSDate *)getCustomDateWithHour:(NSInteger)hour
{
    NSCalendar *currentCalendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    //NSDateComponents *currentComps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    
    NSDateComponents  * currentComps = [currentCalendar components:unitFlags fromDate:self];
    
    //设置当前的时间点
    NSDateComponents *resultComps = [[NSDateComponents alloc] init];
    [resultComps setYear:[currentComps year]];
    [resultComps setMonth:[currentComps month]];
    [resultComps setDay:[currentComps day]];
    [resultComps setHour:hour];
    
    NSCalendar *resultCalendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    return [resultCalendar dateFromComponents:resultComps];
}
//获取时间段
-(NSString *)getTheTimeBucket
{
    //    NSDate * currentDate = [self getNowDateFromatAnDate:[NSDate date]];
    
    if ([self compare:[self getCustomDateWithHour:0]] == NSOrderedDescending && [self compare:[self getCustomDateWithHour:9]] == NSOrderedAscending)
    {
        return NSLocalizedString(@"Good Morning", nil);
    }
    else if ([self compare:[self getCustomDateWithHour:9]] == NSOrderedDescending && [self compare:[self getCustomDateWithHour:11]] == NSOrderedAscending)
    {
        return NSLocalizedString(@"Good Morning ", nil);
    }
    else if ([self compare:[self getCustomDateWithHour:11]] == NSOrderedDescending && [self compare:[self getCustomDateWithHour:13]] == NSOrderedAscending)
    {
        return NSLocalizedString(@"Noon", nil);
    }
    else if ([self compare:[self getCustomDateWithHour:13]] == NSOrderedDescending && [self compare:[self getCustomDateWithHour:18]] == NSOrderedAscending)
    {
        return NSLocalizedString(@"Relaxing Afternoon", nil);
    }
    else
    {
        return NSLocalizedString(@"Beautiful Evening", nil);
    }
}
- (BOOL)isEqualToDateWithoutTime:(NSDate *)aDate
{
    NSDateComponents * dateComps =  [[NSCalendar currentCalendar] components:NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay|NSCalendarUnitHour|NSCalendarUnitMinute|NSCalendarUnitSecond fromDate:self];
    NSDateComponents * aDateComps = [[NSCalendar currentCalendar] components:NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay|NSCalendarUnitHour|NSCalendarUnitMinute|NSCalendarUnitSecond fromDate:aDate];
    
    return ((dateComps.year == aDateComps.year) && (dateComps.month == aDateComps.month) && (dateComps.day == aDateComps.day));
}
- (BOOL)isToday
{
    return [self isEqualToDateWithoutTime:[NSDate date]];
}
- (BOOL)isYesterday
{
    return [self isEqualToDateWithoutTime:[NSDate dateYesterday]];
}
+ (NSDate *)dateYesterday
{
    return [[NSDate date] dateAdjustWithDays:-1];
}
- (NSDate *)dateAdjustWithDays:(NSInteger)days{
    return [self dateAdjustWithSeconds:days * HS_DAY_UNIT];
}
- (NSDate *)dateAdjustWithSeconds:(NSInteger)seconds{
    NSTimeInterval interval = [self timeIntervalSince1970];
    return [NSDate dateWithTimeIntervalSince1970:interval + seconds];
}
- (BOOL)isSameWeekWithDate:(NSDate *)aDate
{
    NSDateComponents * dateComps = [[NSCalendar currentCalendar] components:(NSCalendarUnitWeekOfMonth|NSCalendarUnitWeekOfYear|NSCalendarUnitWeekOfMonth) fromDate:self];
    
    NSDateComponents * aDateComps = [[NSCalendar currentCalendar] components:(NSCalendarUnitWeekOfMonth|NSCalendarUnitWeekOfYear|NSCalendarUnitWeekOfMonth) fromDate:aDate];
    
    return (dateComps.weekOfYear == aDateComps.weekOfYear &&  ABS([self timeIntervalSinceDate:aDate]) < HS_WEEK_UNIT);
}
-(NSString*)getHourAndMin
{
    //用于格式化NSDate对象
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    //设置格式：zzz表示时区
    [dateFormatter setDateFormat:@"h:mm"];
    //NSDate转NSString
    NSString *currentDateString = [dateFormatter stringFromDate:self];
    return currentDateString;
}
@end
