//
//  WHActionSheetView.m
//  BeeBee
//
//  Created by quwan on 2017/6/15.
//  Copyright © 2017年 quwan. All rights reserved.
//

// 默认设置


#import "WHActionSheet.h"
#import "WHFooterView.h"
@interface WHActionSheet()<UICollectionViewDelegate,UICollectionViewDataSource>
@property (nonatomic,assign) WHActionSheetStyle actionsheetStyle;
@property (nonatomic, strong) UICollectionView *collectionView;
@property (nonatomic, strong)WHFooterView* footerView;
@end

@implementation WHActionSheet
{
    NSString *_sheetTitle;
    NSString *_cancleTitle;
    NSArray *_sheetTitleArr;
    UIView *_headerView;
    UILabel *_titleLabel;
    UIButton *_cancleBtn;
    
    CGFloat _tableHeight;
    CGFloat _cellHeight;
    CGFloat _titleHeight;
    CGFloat _cancleHeight;
    NSInteger _cellCount;
}

- (instancetype)initWithTitle:(NSString *)title
                  sheetTitles:(NSArray *)sheetTitles
               cancleBtnTitle:(NSString *)cancleBtnTitle
                   sheetStyle:(WHActionSheetStyle)sheetStyle
                     delegate:(id<WHActionSheetDelegate>)delegate{
    
    if (self = [super init]) {
     
        self.frame = CGRectMake(0, 0, ViewWidth, ViewHeight);
        
        _actionsheetStyle = sheetStyle;
        _sheetTitle = title;
        _cancleTitle = cancleBtnTitle;
        _sheetTitleArr = sheetTitles;
        _cellCount = _sheetTitleArr.count;
        if (delegate) {
            self.delegate = delegate;
        }
    }
    return self;
}

-(UICollectionView*)collectionView
{
    if(nil==_collectionView)
    {
        
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        [flowLayout setScrollDirection:UICollectionViewScrollDirectionVertical];
        _collectionView=[[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:flowLayout];
        _collectionView.delegate=self;
        _collectionView.dataSource=self;
        _collectionView.backgroundColor=[UIColor colorWithHexString:@"#2C2F48" alpha:1.0];
        _collectionView.scrollEnabled=YES;
        _collectionView.layer.cornerRadius=12;
        _collectionView.showsHorizontalScrollIndicator = NO;
        _collectionView.showsVerticalScrollIndicator= NO;
        [_collectionView registerClass:[WHFooterView class] forSupplementaryViewOfKind:UICollectionElementKindSectionFooter withReuseIdentifier:@"WHFooterView"];
        

        
    }
    return _collectionView;
}
- (void)setupView{
    
    if (_cellCount == 0) {
        _cellCount = _iconArr.count;
    }
    [UIView animateWithDuration:0.25 animations:^{
        self.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.3];
    }];
    
    _cellHeight = (_sheetHeight)?_sheetHeight:50;
    _cancleHeight = (_cancleHeight)?_cancleHeight:85;
    _tableHeight =_cellCount*_cellHeight + _cancleHeight ;
    self.collectionView.frame=CGRectMake(0, ViewHeight-_tableHeight, ViewWidth, _tableHeight);
  
    
}

- (void)show{

    [self setupView];
    UIWindow *keyWindow = [UIApplication sharedApplication].keyWindow;
    [keyWindow addSubview:self];
    MJWeakSelf
    [UIView animateWithDuration:0.25 animations:^{
        weakSelf.collectionView.frame = CGRectMake(0, ViewHeight - _tableHeight, ViewWidth, _tableHeight);
    }];

    [self addSubview:self.collectionView];
    
}


#pragma mark - UICollectionViewDataSource, UICollectionViewDelegateFlowLayout

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {

        
    return _cellCount;//self.arrData.count;

}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {


        static NSString *identifier = @"WHActionSheetCell";
        [self.collectionView registerClass:[WHActionSheetCell class] forCellWithReuseIdentifier:identifier];
        WHActionSheetCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
        cell.imageName=self.iconArr[indexPath.item];
        cell.name=_sheetTitleArr[indexPath.item];
        [cell toSetContent];
//        [cell refreshCell:model];
//        cell.delegate=self;
        return cell;
  
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    
   
    
    //    PhotoTypeObject *_phototype=self.listArray[indexPath.row];
    //    int width=[GlobalFunc getWidthWithTitle:_phototype.name font: [UIFont systemFontOfSize:12 * [Model sharedInstance].scaleWidth]];
    
    
    return CGSizeMake(floor((self.frame.size.width)), floor(50));
}
//
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    
    return UIEdgeInsetsMake(23, 0, 16, 0);
    
}
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section
{
    return 0;
}

//---------------------------------------------------------------------------
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    
    return 0;
}
- (UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath
{


    if(indexPath.section == 0 && kind == UICollectionElementKindSectionFooter)
    {
        MJWeakSelf
        self.footerView = [collectionView dequeueReusableSupplementaryViewOfKind:UICollectionElementKindSectionFooter withReuseIdentifier:@"WHFooterView" forIndexPath:indexPath];
        self.footerView .backgroundColor=[UIColor clearColor];
        self.footerView.footerBlock = ^{
            [weakSelf dissmiss];
        };
        return   self.footerView ;
    }
   
    return [UICollectionReusableView new];
}
//设置头部

-(CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout referenceSizeForHeaderInSection:(NSInteger)section {
  
    return CGSizeZero;
}
//设置底部
-(CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout referenceSizeForFooterInSection:(NSInteger)section {

    return CGSizeMake(ViewWidth, 85);
}
//---------------------------------------------------------------------------
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
 
    [self actionSheet:self clickButtonAtIndex:indexPath.item];
    
    
}

#pragma mark WHActionSheetDelegate
- (void)actionSheet:(WHActionSheet *)actionSheet clickButtonAtIndex:(NSInteger)buttonIndex{
    
    if ([self.delegate respondsToSelector:@selector(actionSheet:clickButtonAtIndex:)]) {
        [self.delegate actionSheet:self clickButtonAtIndex:buttonIndex];
    }
    [self dissmiss];
    
}

- (void)actionSheetCancle:(WHActionSheet *)actionSheet{

    if ([self.delegate respondsToSelector:@selector(actionSheetCancle:)]) {
        [self.delegate actionSheetCancle:self];
    }
    [self dissmiss];
}

#pragma mark dissmiss
- (void)dissmiss{

    MJWeakSelf
    [UIView animateWithDuration:0.25 animations:^{
        self.alpha = 0;
        self.collectionView.frame = CGRectMake(0, ViewHeight, ViewWidth, weakSelf.collectionView.height);
    } completion:^(BOOL finished) {
        [self removeFromSuperview];
    }];
}

// 点击阴影部分是让视图消失
- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    
    UITouch *touch = [[event allTouches] anyObject];
    if ([touch view] != _collectionView) {
        [self dissmiss];
    }
}
//-(WHFooterView*)footerView
//{
//    if(nil==_footerView)
//    {
//        _footerView=[[WHFooterView alloc] initWithFrame:CGRectMake(<#CGFloat x#>, <#CGFloat y#>, <#CGFloat width#>, <#CGFloat height#>)]
//    }
//}

@end
