//
//  ViewController.m
//  GJDigitalDemo
//
//  Created by guiji on 2021/11/26.
//

#import "ViewController.h"
#import "DigitalViewController.h"
#import "HttpClient.h"
#import "DLHomeHeaderView.h"
#import "DLHomeListCell.h"
#import "DLSelectDigitalView.h"
#import "ConfigManager.h"
#import "HoverViewFlowLayout.h"
#import "NSDate_Helper.h"
#import "GYCheckNetwork.h"
@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource>
@property (nonatomic, strong) UICollectionView *collectionView;//
@property (nonatomic, strong)DLHomeHeaderView * headerView;
@property (nonatomic, strong)NSMutableArray *arrData;
@property (nonatomic, strong)NSString * appid;
//选择数字人
@property (nonatomic, strong)DLSelectDigitalView *selectDigitalView;

@property (nonatomic, assign) NSInteger page;

@property (nonatomic, assign) BOOL isFirst;
@end

@implementation ViewController
-(id)init
{
    self=[super init];
    if(self)
    {
        
    }
    return self;
}
-(void)viewWillAppear:(BOOL)animated
{
//    NSLog(@"send_str:%@",[DigitalConfig shareConfig].send_str);
    self.navigationController.navigationBarHidden=YES;
    [super viewWillAppear:animated];
    MJWeakSelf
//    [ConfigManager manager].token=@"16A69FBA33D7B7EE563114476C0F979853FE3FF5B618DDCEAA764E3EE7BF46A2C350273B65A43D119A6765674210A24FD5A9AC4875AF48E1F21583EC6D8B41F2";
//    [weakSelf.selectDigitalView toLoadData];
//    [weakSelf toLoadData];

//    //判断第一次无网络权限
     [[GYCheckNetwork manager] getWifiState];
     [GYCheckNetwork manager].on_net = ^(NetType state) {

       if(state==Net_WWAN || state==Net_WiFi)
       {
           if(!weakSelf.isFirst)
           {
               [weakSelf toLoadTokenData];
               weakSelf.isFirst=YES;

           }

       }
    };
     
    if(self.isFirst)
    {
        [self toLoadTokenData];
    }

 
//    [ConfigManager toGetSig:APPID];
}
-(void)toLoadTokenData
{
    MJWeakSelf
    [ConfigManager toGetToken:APPID :APPSECRET block:^(BOOL isSuccess, NSString *msg, id responseObject) {
        if(isSuccess)
        {
            [weakSelf.selectDigitalView toLoadData];
            [weakSelf toLoadData];
        }
    }];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.page = 1;
    self.arrData=[[NSMutableArray alloc] init];
    self.view.backgroundColor=[UIColor colorWithHexString:@"#010027" alpha:1.0];

    [self.view addSubview:self.collectionView];
     
    //选择数字人
    [self.view addSubview:self.selectDigitalView];
//    self.collectionView.contentInsetAdjustmentBehavior=NO;
//    [DigitalManager manager];
//    GJSelectView *selectView = [[NSBundle mainBundle] loadNibNamed:@"GJSelectView" owner:nil options:nil].lastObject;
//    __weak typeof(self) weakSelf = self;
//    selectView.startBlock = ^{
//        [weakSelf initDigitalView];
//    };
//    [self.view addSubview:selectView];
    // Do any additional setup after loading the view.

}
- (void)initDigitalView
{
    DigitalViewController *vc = [[DigitalViewController alloc] init];
    [self.navigationController pushViewController:vc animated:YES];
}
-(void)toLoadData
{
    MJWeakSelf
    [ConfigManager toRequestListLive:self.page size:10 viewIndex:0 block:^(BOOL isSuccess, NSString *msg, NSInteger recordsSize, NSArray *listData) {
        [weakSelf.collectionView.mj_header endRefreshing];
        [weakSelf.collectionView.mj_footer endRefreshing];
        [weakSelf.headerView requestFinish];
        if(isSuccess)
        {
            if (weakSelf.page == 1) {
                    [weakSelf.arrData removeAllObjects];
                    [weakSelf.collectionView.mj_footer resetNoMoreData];
                          
            }
            
            [weakSelf.arrData addObjectsFromArray:listData];
            if (weakSelf.arrData.count >= recordsSize) {
                [weakSelf.collectionView.mj_footer endRefreshingWithNoMoreData];
            } else {
                //                weakSelf.page ++;
            }
            [weakSelf.collectionView reloadData];
        }
  
    }];
}

-(UICollectionView*)collectionView
     {
         if(nil==_collectionView)
         {
             HoverViewFlowLayout *flowLayout = [[HoverViewFlowLayout alloc] initWithTopHeight:185];
//             flowLayout.sectionHeadersPinToVisibleBounds=YES;
             [flowLayout setScrollDirection:UICollectionViewScrollDirectionVertical];
             _collectionView=[[UICollectionView alloc] initWithFrame:CGRectMake(0,kStatusBarHeight, self.view.frame.size.width,self.view.frame.size.height-kStatusBarHeight) collectionViewLayout:flowLayout];
             _collectionView.delegate=self;
             _collectionView.dataSource=self;
             _collectionView.backgroundColor=[UIColor clearColor];
             _collectionView.scrollEnabled=YES;
             _collectionView.showsHorizontalScrollIndicator = NO;
             _collectionView.showsVerticalScrollIndicator= NO;
             [_collectionView registerClass:[DLHomeHeaderView class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"DLHomeHeaderView"];
             __weak typeof(self)weakSelf = self;
       
             [[MJRefreshNormalHeader headerWithRefreshingBlock:^{
                     weakSelf.page = 1;
                     [weakSelf toLoadData];
                 }]  linkTo:_collectionView];
//
                 [[[[MJRefreshAutoFooter footerWithRefreshingBlock:^{
                     weakSelf.page ++;
                     NSLog(@"weakSelf.page:%ld",self.page);
                    [weakSelf toLoadData];
                 }] setAnimationDisabled]
                   autoChangeTransparency:NO]
                  linkTo:_collectionView];
             
         }
         return _collectionView;
     }

//-(DLHomeHeaderView*)headerView
//{
//    if(_headerView==nil)
//    {
//        _headerView=[[DLHomeHeaderView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 215)];
//    }
//    return _headerView;
//}

#pragma mark - UICollectionViewDataSource, UICollectionViewDelegateFlowLayout

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    
    
    return self.arrData.count;
    
    
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *identifier = @"DLHomeListCell";
    [self.collectionView registerClass:[DLHomeListCell class] forCellWithReuseIdentifier:identifier];
    DLHomeListCell*cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
    DLHomeListModel * listModel=self.arrData[indexPath.item];
    cell.listModel=listModel;
    [cell toSetContent];
    return cell;
    
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    
    CGSize size=CGSizeMake(floor(self.view.frame.size.width-28), floor(250));
    
    return size;
    
    
}
//
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    
    return UIEdgeInsetsMake(0, 14, 0, 14);
    
}
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section
{
    return 0;
}

//---------------------------------------------------------------------------
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    
    return 14;
}
- (UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath
{


    if(indexPath.section == 0 && kind == UICollectionElementKindSectionHeader)
    {
        __weak typeof(self) weakSelf = self;
        self.headerView = [collectionView dequeueReusableSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"DLHomeHeaderView" forIndexPath:indexPath];
        self.headerView.backgroundColor=[UIColor colorWithHexString:@"#010027" alpha:1.0];
        self.headerView.headerBlock = ^(NSInteger type) {
            [weakSelf toClickHeader:type];
        };
        return   self.headerView ;
    }
   
    return [UICollectionReusableView new];
}
//设置头部

-(CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout referenceSizeForHeaderInSection:(NSInteger)section {

    return CGSizeMake(self.view.frame.size.width, 185);
   
}
#pragma mark -UICollectionViewDelegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    
    if (self.arrData.count==0) {
        return;
    }
    DLHomeListModel *listModel = [self.arrData objectAtIndex:indexPath.item];
    DigitalViewController * digitalVC=[[DigitalViewController alloc] init];
    digitalVC.listModel=listModel;
    [self.navigationController pushViewController:digitalVC animated:YES];
    
}
#pragma mark -----------点击头部-------------------
-(void)toClickHeader:(NSInteger)type
{
    if(type==0)
    {
    

        self.selectDigitalView.hidden=NO;
    }
    else
    {
        //刷新直播间
        self.page = 1;
        [self toLoadData];
    }
}
#pragma mark ---------------选择数字人界面---------------------------------
-(DLSelectDigitalView*)selectDigitalView
{
  if(_selectDigitalView==nil)
  {
      __weak typeof(self) weakSelf = self;
      _selectDigitalView=[[DLSelectDigitalView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
      _selectDigitalView.hidden=YES;
      _selectDigitalView.selectDigitalBlock = ^(NSInteger type, DLSelectDigitalModel * selectDigitalModel) {
          [weakSelf toSelectDigital:selectDigitalModel :type];
      };
  }
  return _selectDigitalView;
}
#pragma mark ---------------选中数字人---------------------------------
-(void)toSelectDigital:(DLSelectDigitalModel*)selectDigitalModel :(NSInteger)type
{
    if(selectDigitalModel.sceneList.count==0)
    {
        return;
    }
    MJWeakSelf
    [GlobalFunc showHud];
    DLDigitalSceneModel * sceneModel=   selectDigitalModel.sceneList[0];
    //直播间名称
    NSString * liveName=[NSString stringWithFormat:@"数字人直播%@",[[NSDate date] getFormatYearMonthDayHourMinSec]];
    //直播间封面
    NSString * coverUrl=[GlobalFunc changeType:sceneModel.coverUrl];
//    //创建直播间
    [ConfigManager toCreateLiveByLiveName:liveName coverUrl:coverUrl udCode:sceneModel.sceneCode robotCode:selectDigitalModel.robotCode robotName:selectDigitalModel.robotName block:^(BOOL isSuccess, NSString *msg, NSString *liveId, id responseObject) {
        [GlobalFunc hideHud];
        if(isSuccess)
        {
            NSLog(@"liveId:%@",liveId);
            weakSelf.selectDigitalView.hidden=YES;
            //直播间信息
            DLHomeListModel * listModel=[[DLHomeListModel alloc] init];
            listModel.Id=liveId;
            listModel.coverUrl=coverUrl;
            listModel.udCode=sceneModel.sceneCode;
            listModel.robotCode=selectDigitalModel.robotCode;
            listModel.robotName=selectDigitalModel.robotName;
            
      
            DigitalViewController * digitalVC=[[DigitalViewController alloc] init];
            digitalVC.listModel=listModel;//直播间信息
            digitalVC.selectDigitalModel=selectDigitalModel;//数字人信息
            [weakSelf.navigationController pushViewController:digitalVC animated:YES];
        }
        else
        {
            [GlobalFunc showLoadText:msg :self.view];
        }
    }];


 
}
- (UIStatusBarStyle)preferredStatusBarStyle {

    return UIStatusBarStyleLightContent;

}


@end
